/*----------------------------------------------------------------------------
                  buffarray.h (definitions of string array)
                       This file is a part of topaz systems
                  Copyright: Hisao Kawaura, All rights reserved
                                   1997 - 98


    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

----------------------------------------------------------------------------*/

#if !defined(__buffarray_h)
#define __buffarray_h


#include <string>



class buffarray
{
 public:
  buffarray();
  ~buffarray();
    
  bool setdata(int pos, const char *val);
  std::string getdata(int pos);
  int getarraylength();     
  bool setarray(int length);
  bool setbuff(int length);
  bool add(const char *val);
  bool addat(int pos, const char *val);
  bool remove(int pos);
  bool setscalar(const char *val);

  buffarray& operator = (const buffarray& buff);
  std::string& operator [] (int pos);

  private:
  int arraylength;          /* array length of filled array */
  int bufflength;           /* buffer length of array */
  std::string **strarray;
  int increment;
  bool changebufflength(int length);
};


#endif









