/*----------------------------------------------------------------------------
               calc.h (definitions of numerical transformation)
                       This file is a part of topaz systems
                  Copyright: Hisao Kawaura, All rights reserved
                                   1997 - 98


    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

----------------------------------------------------------------------------*/

#if !defined(__calc_h)
#define __calc_h

//$B7W;;4X78(B
#define PLUS 						0
#define MINUS 						1
#define TIMES 						2
#define DIVIDE 						3
#define EXP 						4
#define COLON 						5
#define OPAREN 						6
#define CPAREN 						7
#define NUM 						8
#define CELL 						9
#define FUNC 						10
#define EOLN 						11
#define BAD 						12
#define COMMA 						13
#define PREPLUS 					14
#define PREMINUS 					15
#define DATAROW 					16
#define CELLNO 						17
#define OR							18
#define AND							19
#define EQUAL						20
#define NOTEQUAL					21
#define SMALLER_THAN				22
#define SMALLER_EQUAL_THAN			23
#define LARGER_THAN					24
#define LARGER_EQUAL_THAN			25
#define OTHERDATAROW   				26
#define PARAMDATAROW   				27
#define OTHER_X_DATAROW   				28
#define OTHER_Y_DATAROW   				29

#define MAXFUNCNAMELEN 	5


#define PRI_CPAREN 						0
#define PRI_COMMA 						1
#define PRI_OR							2
#define PRI_AND							3
#define	PRI_EQUAL						4
#define	PRI_NOTEQUAL 					4
#define PRI_SMALLER_THAN				5
#define PRI_SMALLER_EQUAL_THAN			5
#define PRI_LARGER_THAN					5
#define PRI_LARGER_EQUAL_THAN			5
#define PRI_PRUSMINUS 					6
#define PRI_MULDIV 						7
#define PRI_EXP 						8
#define PRI_OPERAND 					9
#define PRI_DATAROW 					9
#define PRI_FUNCTION 					10
#define PRI_OPAREN 						11

#define PARSERSTACKSIZE 100
#define MAXINPUT 79

//maxpoint number in path
#define  MAXPOINT_IN_PATH  1000


struct TOKENREC
{
	int priority;   	//$B1i;;$N%W%i%$%*%j%F%#(B
	int status;         //$B%*%Z%i%s%I$+!"1i;;;R$+!"$J$I(B
	struct
	{
		double value;
		int funcno;
		int datarowno;  //1:x-data  2:y-data
	} x;
};

#endif






