/*----------------------------------------------------------------------------
                        convtxt.cc (conversion of text)
                       This file is a part of topaz systems
                  Copyright: Hisao Kawaura, All rights reserved
                                   1997 - 98


    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

----------------------------------------------------------------------------*/

#include <stdio.h>
#include <string>
#include "convtxt.h"

bool tosavetxt(char *in, std::string *out)
{
  std::string str;
  char stemp[10];
  char *p;

  str = std::string("");
  p = in;
  while (*p != 0)
    {
      if (*p == '\n')
	  strcpy(stemp, "\\n");
      else
	{
	  stemp[0] = *p;
	  stemp[1] = 0;
	}
      str += std::string(stemp);
      p++;
    }
  *out = str;
  return true;
}

bool fromsavetxt(char *in, std::string *out)
{
  std::string str;
  char stemp[10];
  char *p;

  str = std::string("");
  p = in;
  while (*p != 0)
    {
      if (*p == '\\' & *(p + 1) == 'n')
	{
	  if (*(p + 1) == 'n')
	    {
	      str += std::string("\n");
	      p += 2;
	    }
	}
      else
	{
	  stemp[0] = *p;
	  stemp[1] = 0;
	  str += std::string(stemp);
	  p++;
	}
    }
  *out = str;
  return true;
}

char *topazfgets(char *s, int size, FILE *fp)
{
  char *p = fgets(s, size, fp);

  if (strlen(s) > 1)
    {
      if (s[strlen(s) - 2] == '\r')
	{
	  s[strlen(s) - 2] = '\n';
	  s[strlen(s) - 1] = 0;
	}
    }

  return p;
}

bool toplainfilename(char *in, std::string *out)
{
  std::string str;
  char stemp[10];
  char *p;

  str = std::string("");
  p = in;
  while (*p != 0)
    {
      if (*p == '#' )
	{
	  str += std::string("##");
	  p ++;
	}
      else if (*p == '\\')
	{
	  str += std::string("\\\\");
	  p ++;
	}
      else if (*p == '^')
	{
	  str += std::string("#^");
	  p ++;
	}
      else if (*p == '_')
	{
	  str += std::string("#_");
	  p ++;
	}
      else if (*p == '|')
	{
	  str += std::string("#|");
	  p ++;
	}
      else
	{
	  stemp[0] = *p;
	  stemp[1] = 0;
	  str += std::string(stemp);
	  p++;
	}
    }
  *out = str;
  return true;
}






