/*----------------------------------------------------------------------------
                  filepoint.h (definitions of filehandle array)
                       This file is a part of topaz systems
                  Copyright: Hisao Kawaura, All rights reserved
                                   1997 - 98


    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

----------------------------------------------------------------------------*/

#if !defined(__filepoint_h)
#define __filepoint_h
# include <stdio.h>
# include <string>


class HandleElement
{
 public:
  HandleElement();
  ~HandleElement(){;}
  std::string label;
  FILE* handle;
  int handletype;
  std::string filename;
  HandleElement& operator = (const HandleElement& ele);

};


class FileHandleArray
{
 public:
 FileHandleArray();
 ~FileHandleArray();
 
 int getarraylength();
 int arraylength;
 int increment;
 int  bufflength;
 
 bool setbuff(int length);
 bool add(std::string *label, FILE **h, int *handletype, std::string *filename);
 bool remove(int pos);
 bool set(std::string *label, FILE **h, int *handletype, std::string *filename);
 bool get(std::string *label, FILE **h, int *handletype, std::string *filename);
 bool search(std::string *label,  int *SeachedIndex);
 bool getinfo(int i, std::string *label, int *handletype, std::string *filename);

 private:
 HandleElement **element;
 int labelnum;
 bool changebufflength(int length);

};



#endif
