/*----------------------------------------------------------------------------
               gamma.h (definitions of gamma, beta, error functions)
                       This file is a part of topaz systems
       This module is based on the codes freely distributed by Mr. Okumura.
                 This module is free from copyright protection.


    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

----------------------------------------------------------------------------*/

#if !defined(__gamma_h)
#define __gamma_h

extern double erf(double x);
extern double erfc(double x);
extern double p_normal(double x);
extern double q_normal(double x);
extern double gamma(double x);
extern double beta(double x, double y);
extern bool dinvq(double in, double *out);

#endif
