/*----------------------------------------------------------------------------
                       gdi.h (definitions of tpv output)
                       This file is a part of topaz systems
                  Copyright: Hisao Kawaura, All rights reserved
                                   1997 - 98


    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

----------------------------------------------------------------------------*/

#if !defined(__gdi_h)
#define __gdi_h

#include <stdio.h>
#include "vectdefs.h"
#include "pointdefs.h"

extern void pmoveto(bool flag, FILE *f, int x, int y);
extern void plineto(bool flag, FILE *f, int x, int y);
extern void pstroke(bool flag, FILE *f);
extern void pbeginpath(bool flag, FILE *f);
extern void pclosepath(bool flag, FILE *f);
extern void plinestyle(bool flag, FILE *f, int width, int cap, int join, int style);
extern void pfillstyle(bool flag, FILE *f, int fillrule, int style);
extern void ppolygon(bool flag, FILE *f, intpointarray *ia);
extern void pellipse(bool flag, FILE *f, int x1, int y1, int x2, int y2);
extern void psetforecolor(bool flag, FILE *f, unsigned int red, unsigned int green, unsigned int blue);
extern void psetbackcolor(bool flag, FILE *f, unsigned int red, unsigned int green, unsigned int blue);
extern void psetpaintmode(bool flag, FILE *f, int mode);
extern void psavegdc(bool flag, FILE *f);
extern void presoregdc(bool flag, FILE *f);
extern void psetcliprect(bool flag, FILE *f, intrect *rect);
extern void pinitcliprect(bool flag, FILE *f);
extern void ploadfont(bool flag, FILE *f, int face, int size, double angle);
extern void pdrawtext(bool flag, FILE *f, int x, int y, const char *text, int h, int w, double angle, int ascend);
extern void psettempdashline(bool flag, FILE *f);
extern void prestorelinestyle(bool flag, FILE *f);
extern void pbegin(bool flag, FILE *f);
extern void ppaint(bool flag, FILE *f);
extern void pclearviewer(bool flag, FILE *f);
extern void pflush(bool flag, FILE *f);
extern void poutBBox(FILE *f);
extern void psetmag(bool flag,FILE *f);
extern void psetshift(bool flag,FILE *f);

#endif
































