/*----------------------------------------------------------------------------
                       msgbuff.h (message area functions)
                       This file is a part of topaz systems
                  Copyright: Hisao Kawaura, All rights reserved
                                   1997 - 98


    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

----------------------------------------------------------------------------*/

#if !defined(__msgbuff_h)
#define __msgbuff_h

#include "topazcurses.h"

class msgbuff
{
 public:
  msgbuff(WINDOW *msgwin, int msgwinlines, int buffline);
  ~msgbuff();
  void copytomsgwin();
  void addtext(const char *str);
  void add(const char *str);
  bool next(int paging);
  bool previous(int paging);
  void print(const char *str);
  int ems(int lineno, char *mes, const char *com);
  void flush();
  
 protected:
  WINDOW *win;
  int width;
  int winlines;
  
  char *buff;
  int pointer;
  int maxline;
  int topline;
};



#endif













