/*----------------------------------------------------------------------------
                      naninf.cc (floating point error status)
                       This file is a part of topaz systems
                  Copyright: Hisao Kawaura, All rights reserved
                                   1997 - 98


    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

----------------------------------------------------------------------------*/

/*
    This module depends on the plathome on which topaz runs.
*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "naninf.h"

#if defined(TOPAZSOLARIS)
#include <ieeefp.h>
#endif

bool isnormalvalue(double f)
{
  if (f_inf(f) || f_nan(f))
    return false;

  return true;
}

double infvalue()
{
#if defined(TOPAZWIN32)
  return infinity();
#else
  return 1.0 / atof("0.0");
#endif

}

int f_inf(double f)
{
#if defined(TOPAZSOLARIS)
  int fp = fpclass(f);
  return (fp == FP_NINF || fp == FP_PINF);
#else
  return isinf(f);
#endif
}

int f_nan(double f)
{
  return isnan(f);
}


