/*----------------------------------------------------------------------------
                      pipecall.h (definitions of pipecall)
                       This file is a part of topaz systems
                  Copyright: Hisao Kawaura, All rights reserved
                                   1997 - 98


    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

----------------------------------------------------------------------------*/

#if !defined(__pipecall_h)
#define __pipecall_h
# include <stdio.h>
# include <string>
#include "buffarray.h"

#define ERROR             0
#define READFROMFILE      1
#define WRITETOFILE       2
#define APPENDTOFILE      3
#define READFROMPIPE      4
#define WRITETOPIPE       5
#define READWRITE         6
#define READWRITETRUNCATE 7
#define READWRITEEND      8

extern FILE *PipeOpen(std::string *str, int *type);
extern bool PipeClose(FILE *h, int *type);
extern bool ReadLine(FILE *h, std::string *buf);
extern bool WriteLine(FILE *h, std::string *buf);
extern bool ReadAllLines(FILE *h, buffarray *barray);
extern bool WriteAllLines(FILE *h, buffarray *barray);


#endif
