/*----------------------------------------------------------------------------
                             plobj.cc (base object)
                       This file is a part of topaz systems
                  Copyright: Hisao Kawaura, All rights reserved
                                   1997 - 98


    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

----------------------------------------------------------------------------*/

#include <string>
#include <stdio.h>
#include <stdlib.h>
#include "plobj.h"
#include "convtxt.h"

plobj& plobj::operator = (const plobj&  obj)
{
  if (version == obj.version)
    return *this;
  return *this;
}

bool plobj::shrinkobject(std::string *member, std::string *out)
{
  unsigned char *p;
  p = (unsigned char*)member->c_str();


  if (numberofpointer(member) > 0)
    {
      while (*p != 0)
	{
	  if (*p == '-' && *(p + 1) == '>')
	    {
	      *out =  std::string((const char *)(p + 2));
	      return true;
	    }
	  p++;
	}
    }

    return false;
}

int plobj::numberofpointer(std::string *member)
{
  unsigned char *p;
  p = (unsigned char*)member->c_str();
  int count = 0;

  while (*p != 0)
    {
      if (*p == '-' && *(p + 1) == '>')
	count ++;
      p++;
    }
  return count;
}


bool extractmemberid(std::string *member, std::string *out, int *id)
{
  unsigned char *p;
  p = (unsigned char*)member->c_str();
  std::string dummy, dummy1;
  char stemp[10];

  dummy = std::string(""); dummy1 = dummy;
  p = (unsigned char *)member->c_str();
  //search [
  while (*p != 0)
    {
      // [ exists
      if (*p == '[')
	{
	  //search ]
	  p++;
	  while (*p != 0)
	    {
	      if (*p == ']')
		{
		  *out = dummy; *id = atoi(dummy1.c_str());
		  return true;
		}
	      else
		{
		  stemp[0] = *p;
		  stemp[1] = 0;
		  dummy1 += std::string(stemp);
		}
	      p++;
	    }
	  return false;
	}
      else
	{
	  stemp[0] = *p;
	  stemp[1] = 0;
	  dummy += std::string(stemp);
	}
      p++;
    }
  
  // [ does not exists
  *out = dummy; *id = -1;
  return true;

}


bool plobj::topobject(std::string *member, std::string *out, int *id)
{
  unsigned char *p;
  p = (unsigned char*)member->c_str();
  std::string dummy;
  int no;
  char stemp[10];

  no = numberofpointer(member);
  if (no == 0)
    {
      if (extractmemberid(member, out, id))
	return true;
      else
	return false;
    }
  else if (no >0)
    {
      dummy = std::string("");
      while (*p != 0)
	{
	  if (*p == '-' && *(p + 1) == '>')
	  {
	    if (extractmemberid(&dummy, out, id))
	      return true;
	    else
	      return false;
	  }
	  else
	    {
	      stemp[0] = *p;
	      stemp[1] = 0;
	      dummy += std::string(stemp);
	    }
	  p++;
	}
      return false;
    }

  return false;
}

char* plobj::nextitem(char *str, std::string *item)
{
  char *p = str;
  std::string buff = std::string("");
  char stemp[3];

  while (*p != 0)
    {
      if (*p == ' ' || *p == '\t' || *p == '\n')
	p++;
      else
	{
	  while (*p != ' ' && *p != '\t' && *p != '\n' && *p != 0)
	    {
	      stemp[0] = *p; stemp[1] = 0;
	      buff += std::string(stemp);
	      p++;
	    }
	  *item = buff;
	  return p;
	}
    }
  return (char *)0;
}


bool plobj::gettxt(char *str, std::string *txt)
{
  int firstpos, endpos;
  char *p = str;
  char stemp[3];

  // find first char
  firstpos = 0;
  while (*p != 0)
    {
      if (*p != ' ' && *p != '\t' && *p != '\n')
	break;
      else
	{
	  firstpos++; p++;
	}
    }

  // find last char
  endpos = strlen(str) - 1;
  p = str + strlen(str) - 1;
  while (p != str)
    {
      if (*p != ' ' && *p != '\t' && *p != '\n')
	break;
      else
	{
	  endpos--; p--;
	}
    }

  if (str[firstpos] == '"' && str[endpos] == '"')
    {
      *txt = std::string(""); 
      for (int i = firstpos + 1; i < endpos; i++)
	{
	  stemp[0] = str[i]; stemp[1] = 0;
	  *txt += std::string(stemp);
	}
      return true;
    }
  else
    return false;
  
  return true;
}

bool plobj::iscomment(char *line)
{
  char *p = line;

  while (*p != 0)
    {
      if (*p != ' ' && *p != '\t')
	break;
    }
  if (*p == '%' || *p == '#')
    return true;
  else
    return false;

  return true;
}

bool plobj::getnextline(char out[], int size, FILE *fp)
{
  while (topazfgets(out, size, fp) != NULL)
    {
      if (!iscomment((char *)out))
	return true;
    }
  return false;
}









