/*----------------------------------------------------------------------------
                      plobj.h (definitions of base objects)
                       This file is a part of topaz systems
                  Copyright: Hisao Kawaura, All rights reserved
                                   1997 - 98


    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

----------------------------------------------------------------------------*/

#if !defined(__plobj_h)
#define __plobj_h

#include <string>
#include "tokenbuff.h"
#include "buffarray.h"

class plobj
{

 public:
  plobj(){parent = 0; version = 0;}
  ~plobj(){}
  plobj& operator = (const plobj& obj); 


  /* basic functions */
  char* nextitem(char *str, std::string *item);
  bool gettxt(char *str, std::string *txt);
  bool iscomment(char *line);
  bool getnextline(char out[], int size, FILE *fp);

  bool shrinkobject(std::string *member, std::string *out);
  int  numberofpointer(std::string *member); /*extract top object name and id  such as name[id]->.... */
  bool topobject(std::string *member, std::string *out, int *id);

  /* parent */
  void *parent;
  int version;

};


#endif











