/*----------------------------------------------------------------------------
                     spline.h (definitions for spline curve)
                       This file is a part of topaz systems
       This module is based on the codes freely distributed by Mr. Okumura.
                 This module is free from copyright protection.


    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

----------------------------------------------------------------------------*/

#if !defined(__spline_h)
#define __spline_h

#include "vectdefs.h"

/* P-spline */
extern int CalcPSpline(doublearray *inx, doublearray *iny,
		       doublearray *outx, doublearray *outy
		       , int contr_kind, int divno);
extern int Omaketable(doublearray *x, doublearray *y, doublearray *z, int N);
extern double Ospline(double t, doublearray *x, doublearray *y, doublearray *z ,int N);
extern int Omaketable2(doublearray *p, doublearray *x, doublearray *y, doublearray *a, doublearray *b, int N);
extern void Ospline2(double t, double *px, double *py,	doublearray *p, doublearray *x, doublearray *y,
		     doublearray *a, doublearray *b,int N);
extern int Cmaketable(doublearray *x, doublearray *y, doublearray *z,int N);
extern double Cspline(double t, doublearray *x, doublearray *y, doublearray *z,int N);
extern int Cmaketable2(doublearray *p, doublearray *x, doublearray *y, doublearray *a, doublearray *b,int N);
extern void Cspline2(double t, double *px, double *py, doublearray *p, doublearray *x, doublearray * y,
		     doublearray *a, doublearray *b,int N);

/* B-Spline */
extern int CalcBSpline(doublearray *INp_cntrX, doublearray *INp_cntrY
		       ,doublearray *OUTp_cntrX, doublearray *OUTp_cntrY
		       ,int end_terminal, int divno);
extern int BSplineAppr(doublearray *INX, doublearray *INY, doublearray *OUTX, doublearray *OUTY,\
		       int npoints,int end_terminal);
extern void GenBspline(int mode, double *dx, double *dy,double *outx, double *outy, double t);
// mode=1:ǽζ 2:ܤζ 3:Ǹ夫飲ܤζ
//      4:Ǹζ֡ζ

//Spline
extern int CalcSpline(doublearray *inx, doublearray *iny,
		      doublearray *outx, doublearray *outy
		      ,int divno);

#endif







