/*----------------------------------------------------------------------------
                  system.cc (child process, file copy.. etc)
                       This file is a part of topaz systems
                  Copyright: Hisao Kawaura, All rights reserved
                                   1997 - 98


    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

----------------------------------------------------------------------------*/

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <string>
#include "convtxt.h"

int execchildprocess(std::string *in, std::string *out)
{
  FILE* read_fp;
  char buffer[BUFSIZ +1], buffer1[BUFSIZ +1];
  int chars_read;
  std::string buffstring = std::string("");

  memset(buffer, '\0', sizeof(buffer));
  read_fp = popen(in->c_str(), "r");
  if (read_fp != NULL)
    {
      chars_read = fread(buffer, sizeof(char), BUFSIZ, read_fp);
      while (chars_read > 0)
	{
	  
	  strncpy(buffer1, buffer, chars_read);
	  buffer1[chars_read] = 0;
	  buffstring += std::string(buffer1);

	  chars_read = fread(buffer, sizeof(char), BUFSIZ, read_fp);
	}
      pclose(read_fp);
      *out = buffstring; 
      return(EXIT_SUCCESS);
    }
  return(EXIT_FAILURE);
}


bool isfileexist(char *file)
{
  FILE* h;
  if ((h = fopen(file, "r")) != NULL)
    {
      fclose(h);
      return true;
    }
  else
    return false;
  return true;
}


bool filecp(char *dest, char *src)
{
  FILE *in, *out;
  char buff[10000];

  if ((in = fopen(src, "r")) == NULL)
      return false;
  if ((out = fopen(dest, "w")) == NULL)
    {
      fclose(in);
      return false;
    }
  while(topazfgets(buff, sizeof(buff), in) != NULL)
    {
      if (strlen(buff) > 0)
	{
	  if (buff[strlen(buff) - 1] == '\n')
	    {
	      if (strlen(buff) > 1 && buff[strlen(buff) - 2] == '\r')
		{
		  buff[strlen(buff) - 2] = '\n';
		  buff[strlen(buff) - 1] = '\0';
		}
	      fputs(buff, out);
	    }
	  else if (buff[strlen(buff) - 1] == 26)
	    {
	      buff[strlen(buff) - 1] = '\0';
	      fputs(buff, out);
	    }
	}
    }

  fclose(in);
  fclose(out);
  return true;
}
