/*----------------------------------------------------------------------------
                    topazprintf.cc (sub routine of topazprintf)
                       This file is a part of topaz systems
                  Copyright: Hisao Kawaura, All rights reserved
                                   1997 - 98


    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

----------------------------------------------------------------------------*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <string>
#include "buffarray.h"

extern void message(const char *msg);

bool topazprintf(buffarray *array, std::string *out)
{
  char *p;
  char stemp[1000];
  std::string outstr = std::string("");
  std::string form = std::string("");
  std::string *arg;
  bool contflag = false;
  int arglength = array->getarraylength() - 1;
  int argcount = 0;

  if (arglength < 0)
    return false;

  p = (char *)(*array)[0].c_str();
  while (*p != 0)
    {
      if (*p == '%')
	{
	  stemp[0] = *p; stemp[1] = 0;
	  form = std::string(stemp);
	  p++;

	  contflag = true;
	  while(*p != 0)
	    {
	      if (strchr("diouxXfeEgGcs", *p) != NULL)
		{
		  argcount++;
		  if (argcount > arglength)
		    return false;
		  arg = &(*array)[argcount];
		  
		  contflag = false;
		  stemp[0] = *p; stemp[1] = 0;
		  form += std::string(stemp);
		  
		  switch(*p)
		    {
		    case 'd':
		    case 'i':
		    case 'o':
		    case 'u':
		    case 'x':
		    case 'X':	
		      sprintf(stemp, form.c_str(), atoi(arg->c_str()));
		      break;
		    case 'f':	
		    case 'e':	
		    case 'E':	
		    case 'g':	
		    case 'G':	
		      sprintf(stemp, form.c_str(), atof(arg->c_str()));
		      break;
		    case 'c':	
		      sprintf(stemp, form.c_str(), atoi(arg->c_str()));
		      break;
		    case 's':	
		      sprintf(stemp, form.c_str(), (char *)arg->c_str());
		      break;
		    }
		  outstr += std::string(stemp);
		  break;
		}
	      else if (*p == '%')
		{
		  contflag = false;
		  sprintf(stemp, "%%%%");
		  outstr += std::string(stemp);
		  break;
		}
	      else
		{
		  stemp[0] = *p; stemp[1] = 0;
		  form += std::string(stemp);
		}
	      p++;
	    }
	}
      else
	{
	  stemp[0] = *p; stemp[1] = 0;
	  outstr += std::string(stemp);
	}
      p++;
    }

  if (contflag)
    return false;

  *out = outstr;
  return true;

}
