/*----------------------------------------------------------------------------
                  valbuff.h (definitions of variable buffer)
                       This file is a part of topaz systems
                  Copyright: Hisao Kawaura, All rights reserved
                                   1997 - 98


    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

----------------------------------------------------------------------------*/

#if !defined(__varbuff_h)
#define __varbuff_h

# include <string>
#include "buffarray.h"

#define ELEMENTLENGTH 100

class BuffElement
{
 public:
  BuffElement();
  BuffElement(BuffElement *ele)
    {label = ele->label, *value = *ele->value; isreadonly = ele->isreadonly;}
  ~BuffElement(){delete value;}
  std::string label;
  buffarray *value;
  int isreadonly;
  BuffElement& operator = (const BuffElement& ele);

};


class VariantBuff
{
 public:
 VariantBuff();
 ~VariantBuff();
 
 bool SetArray (std::string *label, int length);
 bool SystemSetArray (std::string *label, int length);
 bool SetScalar (std::string *label, std::string *value);
 bool SetSystemScalar (std::string *label, std::string *value);
 bool GetScalar(std::string *label, std::string *value);
 bool SystemSet (std::string *label, int pos, std::string *value);
 bool Set (std::string *label, int pos, std::string *value);
 bool Get(std::string *label, int pos, std::string *value);
 bool Add(std::string *label, std::string *val);
 int getarraylength();
 int ArrayLength(std::string *label);
 int arraylength;
 int increment;
 int  bufflength;
 
 bool setbuff(int length);
 bool add(std::string *label, std::string *val);
 bool add(BuffElement *buffele);
 bool addat(std::string *label, int pos, std::string *val);
 bool remove(int pos);
 bool search(std::string *label,  int *SeachedIndex);

 VariantBuff& operator = (const VariantBuff& buff);
 BuffElement& operator [] (int pos);

 private:
 BuffElement **element;
 int labelnum;
 bool changebufflength(int length);

};



#endif

