/*----------------------------------------------------------------------------
                  tpv2prn.c (send Metafile to printer driver)
                       This file is a part of Topaz systems
                  Copyright: Hisao Kawaura, All rights reserved
                                   1997 - 98


    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

----------------------------------------------------------------------------*/

#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <commdlg.h>
#include "Parray.h"
#include <getopt.h>
//char *optarg;

HWND hWnd;
bool silentmode = false;
static volatile HANDLE thread;
extern Parray *xpa;
extern bool drawline(HDC dc, FILE *in, char *str, METAFILEPICT *mpict, int jobtype,
				 double printmagx, double printmagy, double printshiftx, double printshifty);

bool toprn()
{
	char stemp[1000];
	PRINTDLG pd;
	DOCINFO di;
	int resox, resoy;
	double magx, magy;
	double offx, offy;

	xpa = new Parray;

	memset(&pd, 0, sizeof(PRINTDLG));
	pd.lStructSize = sizeof(PRINTDLG);
	pd.hwndOwner   = NULL;
	if (silentmode)
		pd.Flags = PD_RETURNDC | PD_RETURNDEFAULT;
	else
		pd.Flags = PD_RETURNDC;
	
	memset(&di, 0, sizeof(DOCINFO));
	di.cbSize = sizeof(DOCINFO);
	di.lpszDocName = "";
	di.lpszOutput = NULL;

	if (PrintDlg(&pd) != 0)
	{
		resox = GetDeviceCaps(pd.hDC,HORZRES) / GetDeviceCaps(pd.hDC,HORZSIZE);
		resoy = GetDeviceCaps(pd.hDC,VERTRES) / GetDeviceCaps(pd.hDC,VERTSIZE);
		offx  = (double)GetDeviceCaps(pd.hDC,PHYSICALOFFSETX) * resox / 72.;
		offy  = (double)GetDeviceCaps(pd.hDC,PHYSICALOFFSETY) * resoy / 72.;

		magx = (double)resox *25.4 / 72.0;
		magy = (double)resoy *25.4 / 72.0;

		StartDoc(pd.hDC, &di);
		while(fgets(stemp, sizeof(stemp), stdin) != NULL)
		  {
		    if (strcmp(stemp, "BGN\n") == 0)
		      StartPage(pd.hDC);
		    else if (strcmp(stemp, "PNT\n") == 0)
		      EndPage(pd.hDC);
		    else
		      drawline(pd.hDC, stdin, stemp, NULL, 2, magx, magy, -offx, -offy);
		  }
		EndDoc(pd.hDC);
		DeleteDC(pd.hDC);
	}
 	
	delete xpa;
	return true;
}

int main(int argc, char *argv[])
{
	int c;

  // options
	while ((c = getopt(argc, argv, "svh")) != -1)
    {
    	switch(c)
		{
			case 's':
				silentmode = true;
				break;
			case 'v':
			case 'h':
			fprintf(stderr, "tpv2prn Ver. 1.00\n");;
			fprintf(stderr, "Written by Hisao Kawaura\n\n");
			fprintf(stderr, "Options:\n");
			fprintf(stderr, "-s: silent mode (print without showing dialog box)\n");
			exit(0);
		}
    }

	toprn();
	exit (0);
}
