/*----------------------------------------------------------------------------
                         menudef.h (cuimenu definitions)
                       This file is a part of topaz systems
                  Copyright: Hisao Kawaura, All rights reserved
                                   1997 - 99


    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

----------------------------------------------------------------------------*/

#if !defined(__menudef_h)
#define __menudef_h

#include "cui.h"


#define defmenu(name, caption) CUIMENU name[] = {{1, 0, caption, true, "", ""}, 
#define endmenu {0,0,0,0,0,0}}

/* mag */
defmenu(Mag, "mag")
{MAG_OTHERS, (CUIMENU *)1, "&Others", false, "", ""},
{MAG_10, 0, "10%", false, "10", ""},
{MAG_20, 0, "20%", false, "20", ""},
{MAG_30, 0, "30%", false, "30", ""},
{MAG_40, 0, "40%", false, "40", ""},
{MAG_50, 0, "50%", false, "50", ""},
{MAG_60, 0, "60%", false, "60", ""},
{MAG_70, 0, "70%", false, "70", ""},
{MAG_80, 0, "80%", false, "80", ""},
{MAG_90, 0, "90%", false, "90", ""},
{MAG_100, 0, "100%", false, "100", ""},
{MAG_125, 0, "125%", false, "125", ""},
{MAG_150, 0, "150%", false, "150", ""},
{MAG_175, 0, "175%", false, "175", ""},
{MAG_200, 0, "200%", false, "200", ""},
{MAG_300, 0, "300%", false, "300", ""},
{MAG_400, 0, "400%", false, "400", ""},
endmenu;

/*************************************************************************/
/*                          X-axis                                       */
/*************************************************************************/

defmenu(XBase, "Axis | X-axis | Baseline")
{M_X_DISP, 0, "S&how", true,
"$ax = 0;\
if (selectyesno($graph->frame[$_CUR]->axis[$ax]->show, \"Show X-axis?\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->show = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 0; exit yesnoname($graph->frame[$_CUR]->axis[$ax]->show);"},
{M_X_COMMONSET, 0, "Co&mmonset", true,\
"$ax = 0;\
if (selectyesno($graph->frame[$_CUR]->axis[$ax]->commonset, \"Set X-axis as common settings?\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->commonset = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 0; exit yesnoname($graph->frame[$_CUR]->axis[$ax]->commonset);"},
{M_X_ORIGINX, 0, "&X", true,\
"$ax = 0;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->x, \"X-axis origin X =   (1/20 point)\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->x = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 0; exit $graph->frame[$_CUR]->axis[$ax]->x;"},
{M_X_ORIGINY, 0, "&Y", true,\
"$ax = 0;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->y, \"X-axis origin Y=   (1/20 point)\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->y = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 0; exit $graph->frame[$_CUR]->axis[$ax]->y;"},
{M_X_LENGTH, 0, "&Length", true,\
"$ax = 0;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->length, \"X-axis length =   (1/20 point)\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->length = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 0; exit $graph->frame[$_CUR]->axis[$ax]->length;"},
{M_X_ANGLE, 0, "&Angle", true,\
"$ax = 0;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->angle, \"X-axis angle =   (deg)\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->angle = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 0; exit $graph->frame[$_CUR]->axis[$ax]->angle;"},
{M_X_BASETICKAREA_START, 0, "Area &from", true,\
"$ax = 0;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->tickarea_start, \"X-axis tickarea from =   (%)\"))\
{\
  if ($_RET < 0 || $_RET > $graph->frame[$_CUR]->axis[$ax]->tickarea_end)\
  {\
    print (\"Error!: invalid tickarea_start\n\");\
    exit(0);\
  }\
  $graph->frame[$_CUR]->axis[$ax]->tickarea_start = $_RET;\
  $graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 0; exit $graph->frame[$_CUR]->axis[$ax]->tickarea_start;"},
{M_X_BASETICKAREA_END, 0, "Area &to", true,\
"$ax = 0;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->tickarea_end, \"X-axis tickarea to =   (%)\"))\
{\
  if ($_RET < 0 || $_RET < $graph->frame[$_CUR]->axis[$ax]->tickarea_start)\
  {\
    print (\"Error!: invalid tickarea_end\n\");\
    exit(0);\
  }\
  $graph->frame[$_CUR]->axis[$ax]->tickarea_end = $_RET;\
  $graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 0; exit $graph->frame[$_CUR]->axis[$ax]->tickarea_end;"},
{M_X_BASELINEWIDTH, 0, "Line&width", true,\
"$ax = 0;\
if (edittext($graph->frame[$_RET]->axis[$ax]->baselinewidth, \"X-axis baseline width =   (1/20 point)\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->baselinewidth = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 0; exit $graph->frame[$_CUR]->axis[$ax]->baselinewidth;"},
{M_X_BASELINESTYLE, 0, "Line&style", true,\
"\
$ax = 0;\
if (selectlinestyle($graph->frame[$_CUR]->axis[$ax]->baselinestyle, \"X-axis baseline style =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->baselinestyle = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 0; exit $graph->getlinestylename($graph->frame[$_CUR]->axis[$ax]->baselinestyle);"},
{M_X_MAJORTICKLINECOLOR, 0, "Line&color", true,\
"$ax = 0; @a = ($graph->frame[$_CUR]->axis[$ax]->baselinecolor_red,\
$graph->frame[$_CUR]->axis[$ax]->baselinecolor_green,\
$graph->frame[$_CUR]->axis[$ax]->baselinecolor_blue);\
$a = toscalar(@a);\
if (selectcoloritem($a, \"X-axis baseline color =   (r, g, b)\"))\
{\
@a = toarray($_RET);\
$graph->frame[$_CUR]->axis[$ax]->baselinecolor_red = $a[0];\
$graph->frame[$_CUR]->axis[$ax]->baselinecolor_green = $a[1];\
$graph->frame[$_CUR]->axis[$ax]->baselinecolor_blue = $a[2];\
$graph->frame[$_CUR]->arrangeaxes();\
}",\
"\
$ax = 0; @a = ($graph->frame[$_CUR]->axis[$ax]->baselinecolor_red,\
$graph->frame[$_CUR]->axis[$ax]->baselinecolor_green,\
$graph->frame[$_CUR]->axis[$ax]->baselinecolor_blue);\
exit $graph->getcolorname(@a);"},
{M_X_BASELINECAP, 0, "Lineca&p", true,\
"\
$ax = 0;\
if (selectlinecap($graph->frame[$_CUR]->axis[$ax]->baselinecap, \"X-axis baseline cap =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->baselinecap = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",\
"$ax = 0; exit $graph->getlinecapname($graph->frame[$_CUR]->axis[$ax]->baselinecap);"},
endmenu;


defmenu(XRange, "Axis | X-axis | Range")
{M_X_START, 0, "&Start", true,\
"$ax = 0;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->start, \"X-axis start value =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->start = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 0; exit $graph->frame[$_CUR]->axis[$ax]->start;"},
{M_X_END, 0, "&End", false,\
"$ax = 0;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->end, \"X-axis end value =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->end = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 0; exit $graph->frame[$_CUR]->axis[$ax]->end;"},
{M_X_UNIT, 0, "&Unit", false,\
"$ax = 0;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->unit, \"X-axis unit value =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->unit = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 0; exit $graph->frame[$_CUR]->axis[$ax]->unit;"},
{M_X_SCALING, 0, "Sca&ling", true,\
"\
$ax = 0;\
if (selectscaling($graph->frame[$_CUR]->axis[$ax]->scaling, \"X-axis scaling =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->scaling = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",\
"$ax = 0; exit $graph->getscalingname($graph->frame[$_CUR]->axis[$ax]->scaling);"},
{M_X_INVERT, 0, "&Invert", true,\
"$ax = 0;\
if (selectyesno($graph->frame[$_CUR]->axis[$ax]->invertscale, \"Invert X-axis scale?\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->invertscale = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 0; exit yesnoname($graph->frame[$_CUR]->axis[$ax]->invertscale);"},
{M_X_CROSSPOINT, 0, "&Crosspoint", false,\
"$ax = 0;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->crosspoint, \"X-axis crosspoint value =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->crosspoint = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 0; exit $graph->frame[$_CUR]->axis[$ax]->crosspoint;"},
{M_X_AUTOCROSSPOINT, 0, "&Autocross", true,\
"$ax = 0;\
if (selectyesno($graph->frame[$_CUR]->axis[$ax]->autocrosspoint, \"Set X-axis crosspoint automatically?\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->autocrosspoint = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 0; exit yesnoname($graph->frame[$_CUR]->axis[$ax]->autocrosspoint);"},
endmenu;

defmenu(XMajortick, "Axis | X-axis | Tick")
{M_X_TICKPARITY, 0, "Tick&direction", true,\
"\
 $ax = 0;\
 if ($graph->frame[$_CUR]->axis[$ax]->tickparity == 1)\
 { $in = 2;}\
 elsif ($graph->frame[$_CUR]->axis[$ax]->tickparity == 2)\
 { $in = 1;}\
 else\
 { $in = $graph->frame[$_CUR]->axis[$ax]->tickparity;}\
\
 if (selecttickdirection($in, \"X-axis tick direction =\"))\
{\
 if ($_RET == 1)\
 { $graph->frame[$_CUR]->axis[$ax]->tickparity = 2;}\
 elsif ($_RET == 2)\
 { $graph->frame[$_CUR]->axis[$ax]->tickparity = 1;}\
 else\
 {$graph->frame[$_CUR]->axis[$ax]->tickparity = $_RET;}\
$graph->frame[$_CUR]->arrangeaxes();\
}",\
"$ax = 0; exit $graph->gettickdirname($graph->frame[$_CUR]->axis[$ax]->tickparity, $ax);"},
{M_X_TICKWIDTH , 0, "Tick&width", true,\
"$ax = 0;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->tickwidth, \"X-axis tick width =   (1/20 point)\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->tickwidth = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",\
"$ax = 0; exit $graph->frame[$_CUR]->axis[$ax]->tickwidth;"},
{M_X_TICKLENGTH , 0, "Tick&length", true,\
"$ax = 0;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->ticklength, \"X-axis tick length =   (1/20 point)\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->ticklength = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",\
"$ax = 0; exit $graph->frame[$_CUR]->axis[$ax]->ticklength;"},
{M_X_MAJORTICKLINEWIDTH, 0, "Linew&idth", true,\
"$ax = 0;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->majorticklinewidth, \"X-axis tickline width =   (1/20 point)\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->majorticklinewidth = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",\
"$ax = 0; exit $graph->frame[$_CUR]->axis[$ax]->majorticklinewidth;"},
{M_X_MAJORTICKLINESTYLE, 0, "Line&style", true,\
"\
$ax = 0;\
if (selectlinestyle($graph->frame[$_CUR]->axis[$ax]->majorticklinestyle, \"X-axis tickline style =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->majorticklinestyle = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 0; exit $graph->getlinestylename($graph->frame[$_CUR]->axis[$ax]->majorticklinestyle);"},
{M_X_MAJORTICKLINECOLOR, 0, "Line&color", true,\
"$ax = 0; @a = ($graph->frame[$_CUR]->axis[$ax]->majorticklinecolor_red,\
$graph->frame[$_CUR]->axis[$ax]->majorticklinecolor_green,\
$graph->frame[$_CUR]->axis[$ax]->majorticklinecolor_blue);\
$a = toscalar(@a);\
if (selectcoloritem($a, \"X-axis tickline color =   (r, g, b)\"))\
{\
@a = toarray($_RET);\
$graph->frame[$_CUR]->axis[$ax]->majorticklinecolor_red = $a[0];\
$graph->frame[$_CUR]->axis[$ax]->majorticklinecolor_green = $a[1];\
$graph->frame[$_CUR]->axis[$ax]->majorticklinecolor_blue = $a[2];\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 0; @a = ($graph->frame[$_CUR]->axis[$ax]->majorticklinecolor_red,\
$graph->frame[$_CUR]->axis[$ax]->majorticklinecolor_green,\
$graph->frame[$_CUR]->axis[$ax]->majorticklinecolor_blue);\
exit $graph->getcolorname(@a);"},
{M_X_MAJORTICKLINECAP, 0, "Lineca&p", true,\
"\
$ax = 0;\
if (selectlinecap($graph->frame[$_CUR]->axis[$ax]->majorticklinecap, \"X-axis tickline cap =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->majorticklinecap = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 0; exit $graph->getlinecapname($graph->frame[$_CUR]->axis[$ax]->majorticklinecap);"},
endmenu;


defmenu(XMinortick, "Axis | X-axis | Subtick")
{M_X_DIVISION , 0, "&Division No.", true,\
"$ax = 0;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->tickdivision, \"X-axis tick division number =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->tickdivision = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 0; exit $graph->frame[$_CUR]->axis[$ax]->tickdivision;"},
{M_X_MINORTICKLINEWIDTH, 0, "Line&width", true,\
"$ax = 0;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->minorticklinewidth, \"X-axis subtickline width =   (1/20 point)\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->minorticklinewidth = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 0; exit $graph->frame[$_CUR]->axis[$ax]->minorticklinewidth;"},
{M_X_MINORTICKLINESTYLE, 0, "Line&style", true,\
"\
$ax = 0;\
if (selectlinestyle($graph->frame[$_CUR]->axis[$ax]->minorticklinestyle, \"X-axis subtickline style =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->minorticklinestyle = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 0; exit $graph->getlinestylename($graph->frame[$_CUR]->axis[$ax]->minorticklinestyle);"},
{M_X_MINORTICKLINECOLOR, 0, "Line&color", true,\
"$ax = 0; @a = ($graph->frame[$_CUR]->axis[$ax]->minorticklinecolor_red,\
$graph->frame[$_CUR]->axis[$ax]->minorticklinecolor_green,\
$graph->frame[$_CUR]->axis[$ax]->minorticklinecolor_blue);\
$a = toscalar(@a);\
if (selectcoloritem($a, \"X-axis subtickline color =   (r, g, b)\"))\
{\
@a = toarray($_RET);\
$graph->frame[$_CUR]->axis[$ax]->minorticklinecolor_red = $a[0];\
$graph->frame[$_CUR]->axis[$ax]->minorticklinecolor_green = $a[1];\
$graph->frame[$_CUR]->axis[$ax]->minorticklinecolor_blue = $a[2];\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 0; @a = ($graph->frame[$_CUR]->axis[$ax]->minorticklinecolor_red,\
$graph->frame[$_CUR]->axis[$ax]->minorticklinecolor_green,\
$graph->frame[$_CUR]->axis[$ax]->minorticklinecolor_blue);\
exit $graph->getcolorname(@a);"},
{M_X_MINORTICKLINECAP, 0, "Lineca&p", true,\
"\
$ax = 0;\
if (selectlinecap($graph->frame[$_CUR]->axis[$ax]->minorticklinecap, \"X-axis subtickline cap =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->minorticklinecap = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 0; exit $graph->getlinecapname($graph->frame[$_CUR]->axis[$ax]->minorticklinecap);"},
endmenu;

defmenu(XLabel, "Axis | X-axis | Label")
{M_X_LABELFONTFACE, 0, "&Fontface", true,\
"$ax = 0;\
if (selectfontface($graph->frame[$_CUR]->axis[$ax]->fontface, \"X-axis label font =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->fontface = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 0; exit $graph->gettextfacename($graph->frame[$_CUR]->axis[$ax]->fontface);"},
{M_X_LABELFONTSIZE, 0, "Font&size", true,\
"$ax = 0;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->fontsize, \"X-axis label fontsize =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->fontsize = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 0; exit $graph->frame[$_CUR]->axis[$ax]->fontsize;"},
{M_X_LABELFONTANGLE, 0, "Font&angle", true,\
"$ax = 0;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->fontangle, \"X-axis label fontangle =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->fontangle = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 0; exit $graph->frame[$_CUR]->axis[$ax]->fontangle;"},
{M_X_LABELCOLOR, 0, "&Color", true,\
"$ax = 0; @a = ($graph->frame[$_CUR]->axis[$ax]->fontcolor_red,\
$graph->frame[$_CUR]->axis[$ax]->fontcolor_green,\
$graph->frame[$_CUR]->axis[$ax]->fontcolor_blue);\
$a = toscalar(@a);\
if (selectcoloritem($a, \"X-axis label color =   (r, g, b)\"))\
{\
@a = toarray($_RET);\
$graph->frame[$_CUR]->axis[$ax]->fontcolor_red = $a[0];\
$graph->frame[$_CUR]->axis[$ax]->fontcolor_green = $a[1];\
$graph->frame[$_CUR]->axis[$ax]->fontcolor_blue = $a[2];\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 0; @a = ($graph->frame[$_CUR]->axis[$ax]->fontcolor_red,\
$graph->frame[$_CUR]->axis[$ax]->fontcolor_green,\
$graph->frame[$_CUR]->axis[$ax]->fontcolor_blue);\
exit $graph->getcolorname(@a);"},
{M_X_LABELFORMAT, 0, "For&mat", true,\
"$ax = 0;\
if (selectlabelformat($graph->frame[$_CUR]->axis[$ax]->format, \"X-axis label format =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->format = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 0; exit $graph->getlabelformatname($graph->frame[$_CUR]->axis[$ax]->format);"},
{M_X_LABELADDPLUS, 0, "A&dd plus", true,\
"$ax = 0;\
if (selectyesno($graph->frame[$_CUR]->axis[$ax]->addplus, \"X-axis: add plus to label?\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->addplus = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 0; exit yesnoname($graph->frame[$_CUR]->axis[$ax]->addplus);"},
{M_X_LABELPOSITION, 0, "&Offset", true,\
"$ax = 0;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->offset, \"X-axis label positon =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->offset = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 0; exit $graph->frame[$_CUR]->axis[$ax]->offset;"},
{M_X_LABELSKIP, 0, "S&kipping", true,\
"$ax = 0;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->skip, \"X-axis labelskip = (0: auto)\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->skip = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 0; exit $graph->frame[$_CUR]->axis[$ax]->skip;"},
{M_X_LABELAUTOPRECISION, 0, "A&uto precision", true,\
"$ax = 0;\
if (selectyesno($graph->frame[$_CUR]->axis[$ax]->autoprecision, \"X-axis: auto precision ?\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->autoprecision = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 0; exit yesnoname($graph->frame[$_CUR]->axis[$ax]->autoprecision);"},
{M_X_LABELINTPRECISION, 0, "&Int. precision", true,\
"$ax = 0;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->intprecision, \"X-axis int precision ?\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->intprecision = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 0; exit $graph->frame[$_CUR]->axis[$ax]->intprecision;"},
{M_X_LABELDECIMALPRECISION, 0, "D&ec. precision", true,\
"$ax = 0;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->decimalprecision, \"X-axis decimal precision ?\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->decimalprecision = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 0; exit $graph->frame[$_CUR]->axis[$ax]->decimalprecision;"},
{M_X_LABELPARITY, 0, "&Parity", true,\
"$ax = 0;\
if (selectlabelparity($graph->frame[$_CUR]->axis[$ax]->labelparity, \"X-axis label parity ?\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->labelparity = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 0; exit $graph->getlabelparityname($graph->frame[$_CUR]->axis[$ax]->labelparity);"},
{M_X_CROSSPOINTPARITY, 0, "CrossP. pa&rity", true,\
"$ax = 0;\
if (selectlabelcpparity($graph->frame[$_CUR]->axis[$ax]->crosspointparity, \"X-axis crosspoint parity ?\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->crosspointparity = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 0; exit $graph->getlabelcpparityname($graph->frame[$_CUR]->axis[$ax]->crosspointparity);"},
{M_X_CROSSPOINTOFFSET, 0, "crossP. offse&t", true,\
"$ax = 0;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->crosspointoffset, \"X-axis crosspoint offset ?\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->crosspointoffset = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 0; exit $graph->frame[$_CUR]->axis[$ax]->crosspointoffset;"},
endmenu;

defmenu(X, "Axis | X-axis")
{M_X_BASE, 0, "&Baseline", true, "xbasemenu();", ""},
{M_X_RANGE, 0, "&Range", true, "xrangemenu();", ""},
{M_X_MAJORTICK, 0, "&Tick", true, "xtickmenu();", ""},
{M_X_MINORTICK, 0, "&Subtick", true, "xsubtickmenu();", ""},
{M_X_LABEL, 0, "&Label", true, "xlabelmenu();", ""},
endmenu;

/******************* end of x-axis *******************************/


/*************************************************************************/
/*                          Y-axis                                       */
/*************************************************************************/

defmenu(YBase, "Axis | Y-axis | Baseline")
{M_Y_DISP, 0, "S&how", true,
"$ax = 1;\
if (selectyesno($graph->frame[$_CUR]->axis[$ax]->show, \"Show Y-axis?\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->show = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 1; exit yesnoname($graph->frame[$_CUR]->axis[$ax]->show);"},
{M_Y_COMMONSET, 0, "Co&mmonset", true,\
"$ax = 1;\
if (selectyesno($graph->frame[$_CUR]->axis[$ax]->commonset, \"Set Y-axis as common settings?\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->commonset = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 1; exit yesnoname($graph->frame[$_CUR]->axis[$ax]->commonset);"},
{M_Y_ORIGINX, 0, "&X", true,\
"$ax = 1;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->x, \"Y-axis origin X =   (1/20 point)\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->x = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 1; exit $graph->frame[$_CUR]->axis[$ax]->x;"},
{M_Y_ORIGINY, 0, "&Y", true,\
"$ax = 1;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->y, \"Y-axis origin Y=   (1/20 point)\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->y = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 1; exit $graph->frame[$_CUR]->axis[$ax]->y;"},
{M_Y_LENGTH, 0, "&Length", true,\
"$ax = 1;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->length, \"Y-axis length =   (1/20 point)\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->length = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 1; exit $graph->frame[$_CUR]->axis[$ax]->length;"},
{M_Y_ANGLE, 0, "&Angle", true,\
"$ax = 1;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->angle, \"Y-axis angle =   (deg)\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->angle = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 1; exit $graph->frame[$_CUR]->axis[$ax]->angle;"},
{M_Y_BASETICKAREA_START, 0, "Area &from", true,\
"$ax = 1;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->tickarea_start, \"Y-axis tickarea from =   (%)\"))\
{\
  if ($_RET < 0 || $_RET > $graph->frame[$_CUR]->axis[$ax]->tickarea_end)\
  {\
    print (\"Error!: invalid tickarea_start\n\");\
    exit(0);\
  }\
  $graph->frame[$_CUR]->axis[$ax]->tickarea_start = $_RET;\
  $graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 1; exit $graph->frame[$_CUR]->axis[$ax]->tickarea_start;"},
{M_Y_BASETICKAREA_END, 0, "Area &to", true,\
"$ax = 1;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->tickarea_end, \"Y-axis tickarea to =   (%)\"))\
{\
  if ($_RET < 0 || $_RET < $graph->frame[$_CUR]->axis[$ax]->tickarea_start)\
  {\
    print (\"Error: invalid tickarea_end\n\");\
    exit(0);\
  }\
  $graph->frame[$_CUR]->axis[$ax]->tickarea_end = $_RET;\
  $graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 1; exit $graph->frame[$_CUR]->axis[$ax]->tickarea_end;"},
{M_Y_BASELINEWIDTH, 0, "Line&width", true,\
"$ax = 1;\
if (edittext($graph->frame[$_RET]->axis[$ax]->baselinewidth, \"Y-axis baseline width =   (1/20 point)\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->baselinewidth = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 1; exit $graph->frame[$_CUR]->axis[$ax]->baselinewidth;"},
{M_Y_BASELINESTYLE, 0, "Line&style", true,\
"\
$ax = 1;\
if (selectlinestyle($graph->frame[$_CUR]->axis[$ax]->baselinestyle, \"Y-axis baseline style =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->baselinestyle = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 1; exit $graph->getlinestylename($graph->frame[$_CUR]->axis[$ax]->baselinestyle);"},
{M_Y_MAJORTICKLINECOLOR, 0, "Line&color", true,\
"$ax = 1; @a = ($graph->frame[$_CUR]->axis[$ax]->baselinecolor_red,\
$graph->frame[$_CUR]->axis[$ax]->baselinecolor_green,\
$graph->frame[$_CUR]->axis[$ax]->baselinecolor_blue);\
$a = toscalar(@a);\
if (selectcoloritem($a, \"Y-axis baseline color =   (r, g, b)\"))\
{\
@a = toarray($_RET);\
$graph->frame[$_CUR]->axis[$ax]->baselinecolor_red = $a[0];\
$graph->frame[$_CUR]->axis[$ax]->baselinecolor_green = $a[1];\
$graph->frame[$_CUR]->axis[$ax]->baselinecolor_blue = $a[2];\
$graph->frame[$_CUR]->arrangeaxes();\
}",\
"\
$ax = 1; @a = ($graph->frame[$_CUR]->axis[$ax]->baselinecolor_red,\
$graph->frame[$_CUR]->axis[$ax]->baselinecolor_green,\
$graph->frame[$_CUR]->axis[$ax]->baselinecolor_blue);\
exit $graph->getcolorname(@a);"},
{M_Y_BASELINECAP, 0, "Lineca&p", true,\
"\
$ax = 1;\
if (selectlinecap($graph->frame[$_CUR]->axis[$ax]->baselinecap, \"Y-axis baseline cap =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->baselinecap = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",\
"$ax = 1; exit $graph->getlinecapname($graph->frame[$_CUR]->axis[$ax]->baselinecap);"},
endmenu;


defmenu(YRange, "Axis | Y-axis | Range")
{M_Y_START, 0, "&Start", true,\
"$ax = 1;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->start, \"Y-axis start value =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->start = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 1; exit $graph->frame[$_CUR]->axis[$ax]->start;"},
{M_Y_END, 0, "&End", false,\
"$ax = 1;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->end, \"Y-axis end value =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->end = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 1; exit $graph->frame[$_CUR]->axis[$ax]->end;"},
{M_Y_UNIT, 0, "&Unit", false,\
"$ax = 1;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->unit, \"Y-axis unit value =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->unit = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 1; exit $graph->frame[$_CUR]->axis[$ax]->unit;"},
{M_Y_SCALING, 0, "Sca&ling", true,\
"\
$ax = 1;\
if (selectscaling($graph->frame[$_CUR]->axis[$ax]->scaling, \"Y-axis scaling =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->scaling = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",\
"$ax = 1; exit $graph->getscalingname($graph->frame[$_CUR]->axis[$ax]->scaling);"},
{M_Y_INVERT, 0, "&Invert", true,\
"$ax = 1;\
if (selectyesno($graph->frame[$_CUR]->axis[$ax]->invertscale, \"Invert Y-axis scale?\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->invertscale = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 1; exit yesnoname($graph->frame[$_CUR]->axis[$ax]->invertscale);"},
{M_Y_CROSSPOINT, 0, "&Crosspoint", false,\
"$ax = 1;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->crosspoint, \"Y-axis crosspoint value =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->crosspoint = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 1; exit $graph->frame[$_CUR]->axis[$ax]->crosspoint;"},
{M_Y_AUTOCROSSPOINT, 0, "&Autocross", true,\
"$ax = 1;\
if (selectyesno($graph->frame[$_CUR]->axis[$ax]->autocrosspoint, \"Set Y-axis crosspoint automatically?\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->autocrosspoint = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 1; exit yesnoname($graph->frame[$_CUR]->axis[$ax]->autocrosspoint);"},
endmenu;

defmenu(YMajortick, "Axis | Y-axis | Tick")
{M_Y_TICKPARITY, 0, "Tick&direction", true,\
"\
 $ax = 1;\
 if ($graph->frame[$_CUR]->axis[$ax]->tickparity == 1)\
 { $in = 1;}\
 elsif ($graph->frame[$_CUR]->axis[$ax]->tickparity == 2)\
 { $in = 2;}\
 else\
 { $in = $graph->frame[$_CUR]->axis[$ax]->tickparity;}\
\
 if (selecttickdirection($in, \"Y-axis tick direction =\"))\
{\
 if ($_RET == 1)\
 { $graph->frame[$_CUR]->axis[$ax]->tickparity = 1;}\
 elsif ($_RET == 2)\
 { $graph->frame[$_CUR]->axis[$ax]->tickparity = 2;}\
 else\
 {$graph->frame[$_CUR]->axis[$ax]->tickparity = $_RET;}\
$graph->frame[$_CUR]->arrangeaxes();\
}",\
"$ax = 1; exit $graph->gettickdirname($graph->frame[$_CUR]->axis[$ax]->tickparity, $ax);"},
{M_Y_TICKWIDTH , 0, "Tick&width", true,\
"$ax = 1;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->tickwidth, \"Y-axis tick width =   (1/20 point)\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->tickwidth = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",\
"$ax = 1; exit $graph->frame[$_CUR]->axis[$ax]->tickwidth;"},
{M_Y_TICKLENGTH , 0, "Tick&length", true,\
"$ax = 1;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->ticklength, \"Y-axis tick length =   (1/20 point)\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->ticklength = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",\
"$ax = 1; exit $graph->frame[$_CUR]->axis[$ax]->ticklength;"},
{M_Y_MAJORTICKLINEWIDTH, 0, "Linew&idth", true,\
"$ax = 1;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->majorticklinewidth, \"Y-axis tickline width =   (1/20 point)\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->majorticklinewidth = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",\
"$ax = 1; exit $graph->frame[$_CUR]->axis[$ax]->majorticklinewidth;"},
{M_Y_MAJORTICKLINESTYLE, 0, "Line&style", true,\
"\
$ax = 1;\
if (selectlinestyle($graph->frame[$_CUR]->axis[$ax]->majorticklinestyle, \"Y-axis tickline style =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->majorticklinestyle = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 1; exit $graph->getlinestylename($graph->frame[$_CUR]->axis[$ax]->majorticklinestyle);"},
{M_Y_MAJORTICKLINECOLOR, 0, "Line&color", true,\
"$ax = 1; @a = ($graph->frame[$_CUR]->axis[$ax]->majorticklinecolor_red,\
$graph->frame[$_CUR]->axis[$ax]->majorticklinecolor_green,\
$graph->frame[$_CUR]->axis[$ax]->majorticklinecolor_blue);\
$a = toscalar(@a);\
if (selectcoloritem($a, \"Y-axis tickline color =   (r, g, b)\"))\
{\
@a = toarray($_RET);\
$graph->frame[$_CUR]->axis[$ax]->majorticklinecolor_red = $a[0];\
$graph->frame[$_CUR]->axis[$ax]->majorticklinecolor_green = $a[1];\
$graph->frame[$_CUR]->axis[$ax]->majorticklinecolor_blue = $a[2];\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 1; @a = ($graph->frame[$_CUR]->axis[$ax]->majorticklinecolor_red,\
$graph->frame[$_CUR]->axis[$ax]->majorticklinecolor_green,\
$graph->frame[$_CUR]->axis[$ax]->majorticklinecolor_blue);\
exit $graph->getcolorname(@a);"},
{M_Y_MAJORTICKLINECAP, 0, "Lineca&p", true,\
"\
$ax = 1;\
if (selectlinecap($graph->frame[$_CUR]->axis[$ax]->majorticklinecap, \"Y-axis tickline cap =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->majorticklinecap = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 1; exit $graph->getlinecapname($graph->frame[$_CUR]->axis[$ax]->majorticklinecap);"},
endmenu;


defmenu(YMinortick, "Axis | Y-axis | Subtick")
{M_Y_DIVISION , 0, "&Division No.", true,\
"$ax = 1;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->tickdivision, \"Y-axis tick division number =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->tickdivision = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 1; exit $graph->frame[$_CUR]->axis[$ax]->tickdivision;"},
{M_Y_MINORTICKLINEWIDTH, 0, "Line&width", true,\
"$ax = 1;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->minorticklinewidth, \"Y-axis subtickline width =   (1/20 point)\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->minorticklinewidth = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 1; exit $graph->frame[$_CUR]->axis[$ax]->minorticklinewidth;"},
{M_Y_MINORTICKLINESTYLE, 0, "Line&style", true,\
"\
$ax = 1;\
if (selectlinestyle($graph->frame[$_CUR]->axis[$ax]->minorticklinestyle, \"Y-axis subtickline style =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->minorticklinestyle = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 1; exit $graph->getlinestylename($graph->frame[$_CUR]->axis[$ax]->minorticklinestyle);"},
{M_Y_MINORTICKLINECOLOR, 0, "Line&color", true,\
"$ax = 1; @a = ($graph->frame[$_CUR]->axis[$ax]->minorticklinecolor_red,\
$graph->frame[$_CUR]->axis[$ax]->minorticklinecolor_green,\
$graph->frame[$_CUR]->axis[$ax]->minorticklinecolor_blue);\
$a = toscalar(@a);\
if (selectcoloritem($a, \"Y-axis subtickline color =   (r, g, b)\"))\
{\
@a = toarray($_RET);\
$graph->frame[$_CUR]->axis[$ax]->minorticklinecolor_red = $a[0];\
$graph->frame[$_CUR]->axis[$ax]->minorticklinecolor_green = $a[1];\
$graph->frame[$_CUR]->axis[$ax]->minorticklinecolor_blue = $a[2];\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 1; @a = ($graph->frame[$_CUR]->axis[$ax]->minorticklinecolor_red,\
$graph->frame[$_CUR]->axis[$ax]->minorticklinecolor_green,\
$graph->frame[$_CUR]->axis[$ax]->minorticklinecolor_blue);\
exit $graph->getcolorname(@a);"},
{M_Y_MINORTICKLINECAP, 0, "Lineca&p", true,\
"\
$ax = 1;\
if (selectlinecap($graph->frame[$_CUR]->axis[$ax]->minorticklinecap, \"Y-axis subtickline cap =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->minorticklinecap = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 1; exit $graph->getlinecapname($graph->frame[$_CUR]->axis[$ax]->minorticklinecap);"},
endmenu;

defmenu(YLabel, "Axis | Y-axis | Label")
{M_Y_LABELFONTFACE, 0, "&Fontface", true,\
"$ax = 1;\
if (selectfontface($graph->frame[$_CUR]->axis[$ax]->fontface, \"Y-axis label font =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->fontface = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 1; exit $graph->gettextfacename($graph->frame[$_CUR]->axis[$ax]->fontface);"},
{M_Y_LABELFONTSIZE, 0, "Font&size", true,\
"$ax = 1;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->fontsize, \"Y-axis label fontsize =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->fontsize = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 1; exit $graph->frame[$_CUR]->axis[$ax]->fontsize;"},
{M_Y_LABELFONTANGLE, 0, "Font&angle", true,\
"$ax = 1;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->fontangle, \"Y-axis label fontangle =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->fontangle = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 1; exit $graph->frame[$_CUR]->axis[$ax]->fontangle;"},
{M_Y_LABELCOLOR, 0, "&Color", true,\
"$ax = 1; @a = ($graph->frame[$_CUR]->axis[$ax]->fontcolor_red,\
$graph->frame[$_CUR]->axis[$ax]->fontcolor_green,\
$graph->frame[$_CUR]->axis[$ax]->fontcolor_blue);\
$a = toscalar(@a);\
if (selectcoloritem($a, \"Y-axis label color =   (r, g, b)\"))\
{\
@a = toarray($_RET);\
$graph->frame[$_CUR]->axis[$ax]->fontcolor_red = $a[0];\
$graph->frame[$_CUR]->axis[$ax]->fontcolor_green = $a[1];\
$graph->frame[$_CUR]->axis[$ax]->fontcolor_blue = $a[2];\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 1; @a = ($graph->frame[$_CUR]->axis[$ax]->fontcolor_red,\
$graph->frame[$_CUR]->axis[$ax]->fontcolor_green,\
$graph->frame[$_CUR]->axis[$ax]->fontcolor_blue);\
exit $graph->getcolorname(@a);"},
{M_Y_LABELFORMAT, 0, "For&mat", true,\
"$ax = 1;\
if (selectlabelformat($graph->frame[$_CUR]->axis[$ax]->format, \"Y-axis label format =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->format = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 1; exit $graph->getlabelformatname($graph->frame[$_CUR]->axis[$ax]->format);"},
{M_Y_LABELADDPLUS, 0, "A&dd plus", true,\
"$ax = 1;\
if (selectyesno($graph->frame[$_CUR]->axis[$ax]->addplus, \"Y-axis: add plus to label?\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->addplus = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 1; exit yesnoname($graph->frame[$_CUR]->axis[$ax]->addplus);"},
{M_Y_LABELPOSITION, 0, "&Offset", true,\
"$ax = 1;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->offset, \"Y-axis label positon =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->offset = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 1; exit $graph->frame[$_CUR]->axis[$ax]->offset;"},
{M_Y_LABELSKIP, 0, "S&kipping", true,\
"$ax = 1;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->skip, \"Y-axis labelskip = (0: auto)\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->skip = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 1; exit $graph->frame[$_CUR]->axis[$ax]->skip;"},
{M_Y_LABELAUTOPRECISION, 0, "A&uto precision", true,\
"$ax = 1;\
if (selectyesno($graph->frame[$_CUR]->axis[$ax]->autoprecision, \"Y-axis: auto precision ?\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->autoprecision = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 1; exit yesnoname($graph->frame[$_CUR]->axis[$ax]->autoprecision);"},
{M_Y_LABELINTPRECISION, 0, "&Int. precision", true,\
"$ax = 1;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->intprecision, \"Y-axis int precision ?\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->intprecision = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 1; exit $graph->frame[$_CUR]->axis[$ax]->intprecision;"},
{M_Y_LABELDECIMALPRECISION, 0, "D&ec. precision", true,\
"$ax = 1;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->decimalprecision, \"Y-axis decimal precision ?\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->decimalprecision = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 1; exit $graph->frame[$_CUR]->axis[$ax]->decimalprecision;"},
{M_Y_LABELPARITY, 0, "&Parity", true,\
"$ax = 1;\
if (selectlabelparity($graph->frame[$_CUR]->axis[$ax]->labelparity, \"Y-axis label parity ?\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->labelparity = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 1; exit $graph->getlabelparityname($graph->frame[$_CUR]->axis[$ax]->labelparity);"},
{M_Y_CROSSPOINTPARITY, 0, "CrossP pa&rity", true,\
"$ax = 1;\
if (selectlabelcpparity($graph->frame[$_CUR]->axis[$ax]->crosspointparity, \"Y-axis crosspoint parity ?\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->crosspointparity = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 1; exit $graph->getlabelcpparityname($graph->frame[$_CUR]->axis[$ax]->crosspointparity);"},
{M_Y_CROSSPOINTOFFSET, 0, "crossP. offse&t", true,\
"$ax = 1;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->crosspointoffset, \"Y-axis crosspoint offset ?\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->crosspointoffset = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 1; exit $graph->frame[$_CUR]->axis[$ax]->crosspointoffset;"},
endmenu;


defmenu(Y, "Axis | Y-axis")
{M_Y_BASE, 0, "&Baseline", true, "ybasemenu();", ""},
{M_Y_RANGE, 0, "&Range", true, "yrangemenu();", ""},
{M_Y_MAJORTICK, 0, "&Tick", true, "ytickmenu();", ""},
{M_Y_MINORTICK, 0, "&Subtick", true, "ysubtickmenu();", ""},
{M_Y_LABEL, 0, "&Label", true, "ylabelmenu();", ""},
endmenu;

/******************* end of y-axis *******************************/

/*************************************************************************/
/*                          T-axis                                       */
/*************************************************************************/

defmenu(TBase, "Axis | T-axis | Baseline")
{M_T_DISP, 0, "S&how", true,
"$ax = 2;\
if (selectyesno($graph->frame[$_CUR]->axis[$ax]->show, \"Show T-axis?\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->show = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 2; exit yesnoname($graph->frame[$_CUR]->axis[$ax]->show);"},
{M_T_COMMONSET, 0, "Co&mmonset", true,\
"$ax = 2;\
if (selectyesno($graph->frame[$_CUR]->axis[$ax]->commonset, \"Set T-axis as common settings?\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->commonset = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 2; exit yesnoname($graph->frame[$_CUR]->axis[$ax]->commonset);"},
{M_T_ORIGINX, 0, "&X", true,\
"$ax = 2;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->x, \"T-axis origin X =   (1/20 point)\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->x = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 2; exit $graph->frame[$_CUR]->axis[$ax]->x;"},
{M_T_ORIGINY, 0, "&Y", true,\
"$ax = 2;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->y, \"T-axis origin Y=   (1/20 point)\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->y = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 2; exit $graph->frame[$_CUR]->axis[$ax]->y;"},
{M_T_LENGTH, 0, "&Length", true,\
"$ax = 2;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->length, \"T-axis length =   (1/20 point)\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->length = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 2; exit $graph->frame[$_CUR]->axis[$ax]->length;"},
{M_T_ANGLE, 0, "&Angle", true,\
"$ax = 2;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->angle, \"T-axis angle =   (deg)\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->angle = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 2; exit $graph->frame[$_CUR]->axis[$ax]->angle;"},
{M_T_BASETICKAREA_START, 0, "Area &from", true,\
"$ax = 2;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->tickarea_start, \"T-axis tickarea from =   (%)\"))\
{\
  if ($_RET < 0 || $_RET > $graph->frame[$_CUR]->axis[$ax]->tickarea_end)\
  {\
    print (\"Error: invalid tickarea_start\n\");\
    exit(0);\
  }\
  $graph->frame[$_CUR]->axis[$ax]->tickarea_start = $_RET;\
  $graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 2; exit $graph->frame[$_CUR]->axis[$ax]->tickarea_start;"},
{M_T_BASETICKAREA_END, 0, "Area &to", true,\
"$ax = 2;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->tickarea_end, \"T-axis tickarea to =   (%)\"))\
{\
  if ($_RET < 0 || $_RET < $graph->frame[$_CUR]->axis[$ax]->tickarea_start)\
  {\
    print (\"Error: invalid tickarea_end\n\");\
    exit(0);\
  }\
  $graph->frame[$_CUR]->axis[$ax]->tickarea_end = $_RET;\
  $graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 2; exit $graph->frame[$_CUR]->axis[$ax]->tickarea_end;"},
{M_T_BASELINEWIDTH, 0, "Line&width", true,\
"$ax = 2;\
if (edittext($graph->frame[$_RET]->axis[$ax]->baselinewidth, \"T-axis baseline width =   (1/20 point)\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->baselinewidth = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 2; exit $graph->frame[$_CUR]->axis[$ax]->baselinewidth;"},
{M_T_BASELINESTYLE, 0, "Line&style", true,\
"\
$ax = 2;\
if (selectlinestyle($graph->frame[$_CUR]->axis[$ax]->baselinestyle, \"T-axis baseline style =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->baselinestyle = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 2; exit $graph->getlinestylename($graph->frame[$_CUR]->axis[$ax]->baselinestyle);"},
{M_T_MAJORTICKLINECOLOR, 0, "Line&color", true,\
"$ax = 2; @a = ($graph->frame[$_CUR]->axis[$ax]->baselinecolor_red,\
$graph->frame[$_CUR]->axis[$ax]->baselinecolor_green,\
$graph->frame[$_CUR]->axis[$ax]->baselinecolor_blue);\
$a = toscalar(@a);\
if (selectcoloritem($a, \"T-axis baseline color =   (r, g, b)\"))\
{\
@a = toarray($_RET);\
$graph->frame[$_CUR]->axis[$ax]->baselinecolor_red = $a[0];\
$graph->frame[$_CUR]->axis[$ax]->baselinecolor_green = $a[1];\
$graph->frame[$_CUR]->axis[$ax]->baselinecolor_blue = $a[2];\
$graph->frame[$_CUR]->arrangeaxes();\
}",\
"\
$ax = 2; @a = ($graph->frame[$_CUR]->axis[$ax]->baselinecolor_red,\
$graph->frame[$_CUR]->axis[$ax]->baselinecolor_green,\
$graph->frame[$_CUR]->axis[$ax]->baselinecolor_blue);\
exit $graph->getcolorname(@a);"},
{M_T_BASELINECAP, 0, "Lineca&p", true,\
"\
$ax = 2;\
if (selectlinecap($graph->frame[$_CUR]->axis[$ax]->baselinecap, \"T-axis baseline cap =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->baselinecap = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",\
"$ax = 2; exit $graph->getlinecapname($graph->frame[$_CUR]->axis[$ax]->baselinecap);"},
endmenu;


defmenu(TRange, "Axis | T-axis | Range")
{M_T_START, 0, "&Start", true,\
"$ax = 2;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->start, \"T-axis start value =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->start = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 2; exit $graph->frame[$_CUR]->axis[$ax]->start;"},
{M_T_END, 0, "&End", false,\
"$ax = 2;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->end, \"T-axis end value =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->end = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 2; exit $graph->frame[$_CUR]->axis[$ax]->end;"},
{M_T_UNIT, 0, "&Unit", false,\
"$ax = 2;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->unit, \"T-axis unit value =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->unit = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 2; exit $graph->frame[$_CUR]->axis[$ax]->unit;"},
{M_T_SCALING, 0, "Sca&ling", true,\
"\
$ax = 2;\
if (selectscaling($graph->frame[$_CUR]->axis[$ax]->scaling, \"T-axis scaling =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->scaling = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",\
"$ax = 2; exit $graph->getscalingname($graph->frame[$_CUR]->axis[$ax]->scaling);"},
{M_T_INVERT, 0, "&Invert", true,\
"$ax = 2;\
if (selectyesno($graph->frame[$_CUR]->axis[$ax]->invertscale, \"Invert T-axis scale?\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->invertscale = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 2; exit yesnoname($graph->frame[$_CUR]->axis[$ax]->invertscale);"},
{M_T_CROSSPOINT, 0, "&Crosspoint", false,\
"$ax = 2;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->crosspoint, \"T-axis crosspoint value =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->crosspoint = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 2; exit $graph->frame[$_CUR]->axis[$ax]->crosspoint;"},
{M_T_AUTOCROSSPOINT, 0, "&Autocross", true,\
"$ax = 2;\
if (selectyesno($graph->frame[$_CUR]->axis[$ax]->autocrosspoint, \"Set T-axis crosspoint automatically?\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->autocrosspoint = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 2; exit yesnoname($graph->frame[$_CUR]->axis[$ax]->autocrosspoint);"},
endmenu;

defmenu(TMajortick, "Axis | T-axis | Tick")
{M_T_TICKPARITY, 0, "Tick&direction", true,\
"\
 $ax = 2;\
 if ($graph->frame[$_CUR]->axis[$ax]->tickparity == 1)\
 { $in = 1;}\
 elsif ($graph->frame[$_CUR]->axis[$ax]->tickparity == 2)\
 { $in = 2;}\
 else\
 { $in = $graph->frame[$_CUR]->axis[$ax]->tickparity;}\
\
 if (selecttickdirection($in, \"T-axis tick direction =\"))\
{\
 if ($_RET == 1)\
 { $graph->frame[$_CUR]->axis[$ax]->tickparity = 1;}\
 elsif ($_RET == 2)\
 { $graph->frame[$_CUR]->axis[$ax]->tickparity = 2;}\
 else\
 {$graph->frame[$_CUR]->axis[$ax]->tickparity = $_RET;}\
$graph->frame[$_CUR]->arrangeaxes();\
}",\
"$ax = 2; exit $graph->gettickdirname($graph->frame[$_CUR]->axis[$ax]->tickparity, $ax);"},
{M_T_TICKWIDTH , 0, "Tick&width", true,\
"$ax = 2;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->tickwidth, \"T-axis tick width =   (1/20 point)\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->tickwidth = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",\
"$ax = 2; exit $graph->frame[$_CUR]->axis[$ax]->tickwidth;"},
{M_T_TICKLENGTH , 0, "Tick&length", true,\
"$ax = 2;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->ticklength, \"T-axis tick length =   (1/20 point)\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->ticklength = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",\
"$ax = 2; exit $graph->frame[$_CUR]->axis[$ax]->ticklength;"},
{M_T_MAJORTICKLINEWIDTH, 0, "Linew&idth", true,\
"$ax = 2;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->majorticklinewidth, \"T-axis tickline width =   (1/20 point)\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->majorticklinewidth = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",\
"$ax = 2; exit $graph->frame[$_CUR]->axis[$ax]->majorticklinewidth;"},
{M_T_MAJORTICKLINESTYLE, 0, "Line&style", true,\
"\
$ax = 2;\
if (selectlinestyle($graph->frame[$_CUR]->axis[$ax]->majorticklinestyle, \"T-axis tickline style =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->majorticklinestyle = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 2; exit $graph->getlinestylename($graph->frame[$_CUR]->axis[$ax]->majorticklinestyle);"},
{M_T_MAJORTICKLINECOLOR, 0, "Line&color", true,\
"$ax = 2; @a = ($graph->frame[$_CUR]->axis[$ax]->majorticklinecolor_red,\
$graph->frame[$_CUR]->axis[$ax]->majorticklinecolor_green,\
$graph->frame[$_CUR]->axis[$ax]->majorticklinecolor_blue);\
$a = toscalar(@a);\
if (selectcoloritem($a, \"T-axis tickline color =   (r, g, b)\"))\
{\
@a = toarray($_RET);\
$graph->frame[$_CUR]->axis[$ax]->majorticklinecolor_red = $a[0];\
$graph->frame[$_CUR]->axis[$ax]->majorticklinecolor_green = $a[1];\
$graph->frame[$_CUR]->axis[$ax]->majorticklinecolor_blue = $a[2];\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 2; @a = ($graph->frame[$_CUR]->axis[$ax]->majorticklinecolor_red,\
$graph->frame[$_CUR]->axis[$ax]->majorticklinecolor_green,\
$graph->frame[$_CUR]->axis[$ax]->majorticklinecolor_blue);\
exit $graph->getcolorname(@a);"},
{M_T_MAJORTICKLINECAP, 0, "Lineca&p", true,\
"\
$ax = 2;\
if (selectlinecap($graph->frame[$_CUR]->axis[$ax]->majorticklinecap, \"T-axis tickline cap =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->majorticklinecap = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 2; exit $graph->getlinecapname($graph->frame[$_CUR]->axis[$ax]->majorticklinecap);"},
endmenu;


defmenu(TMinortick, "Axis | T-axis | Subtick")
{M_T_DIVISION , 0, "&Division No.", true,\
"$ax = 2;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->tickdivision, \"T-axis tick division number =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->tickdivision = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 2; exit $graph->frame[$_CUR]->axis[$ax]->tickdivision;"},
{M_T_MINORTICKLINEWIDTH, 0, "Line&width", true,\
"$ax = 2;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->minorticklinewidth, \"T-axis subtickline width =   (1/20 point)\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->minorticklinewidth = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 2; exit $graph->frame[$_CUR]->axis[$ax]->minorticklinewidth;"},
{M_T_MINORTICKLINESTYLE, 0, "Line&style", true,\
"\
$ax = 2;\
if (selectlinestyle($graph->frame[$_CUR]->axis[$ax]->minorticklinestyle, \"T-axis subtickline style =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->minorticklinestyle = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 2; exit $graph->getlinestylename($graph->frame[$_CUR]->axis[$ax]->minorticklinestyle);"},
{M_T_MINORTICKLINECOLOR, 0, "Line&color", true,\
"$ax = 2; @a = ($graph->frame[$_CUR]->axis[$ax]->minorticklinecolor_red,\
$graph->frame[$_CUR]->axis[$ax]->minorticklinecolor_green,\
$graph->frame[$_CUR]->axis[$ax]->minorticklinecolor_blue);\
$a = toscalar(@a);\
if (selectcoloritem($a, \"T-axis subtickline color =   (r, g, b)\"))\
{\
@a = toarray($_RET);\
$graph->frame[$_CUR]->axis[$ax]->minorticklinecolor_red = $a[0];\
$graph->frame[$_CUR]->axis[$ax]->minorticklinecolor_green = $a[1];\
$graph->frame[$_CUR]->axis[$ax]->minorticklinecolor_blue = $a[2];\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 2; @a = ($graph->frame[$_CUR]->axis[$ax]->minorticklinecolor_red,\
$graph->frame[$_CUR]->axis[$ax]->minorticklinecolor_green,\
$graph->frame[$_CUR]->axis[$ax]->minorticklinecolor_blue);\
exit $graph->getcolorname(@a);"},
{M_T_MINORTICKLINECAP, 0, "Lineca&p", true,\
"\
$ax = 2;\
if (selectlinecap($graph->frame[$_CUR]->axis[$ax]->minorticklinecap, \"T-axis subtickline cap =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->minorticklinecap = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 2; exit $graph->getlinecapname($graph->frame[$_CUR]->axis[$ax]->minorticklinecap);"},
endmenu;

defmenu(TLabel, "Axis | T-axis | Label")
{M_T_LABELFONTFACE, 0, "&Fontface", true,\
"$ax = 2;\
if (selectfontface($graph->frame[$_CUR]->axis[$ax]->fontface, \"T-axis label font =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->fontface = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 2; exit $graph->gettextfacename($graph->frame[$_CUR]->axis[$ax]->fontface);"},
{M_T_LABELFONTSIZE, 0, "Font&size", true,\
"$ax = 2;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->fontsize, \"T-axis label fontsize =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->fontsize = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 2; exit $graph->frame[$_CUR]->axis[$ax]->fontsize;"},
{M_T_LABELFONTANGLE, 0, "Font&angle", true,\
"$ax = 2;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->fontangle, \"T-axis label fontangle =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->fontangle = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 2; exit $graph->frame[$_CUR]->axis[$ax]->fontangle;"},
{M_T_LABELCOLOR, 0, "&Color", true,\
"$ax = 2; @a = ($graph->frame[$_CUR]->axis[$ax]->fontcolor_red,\
$graph->frame[$_CUR]->axis[$ax]->fontcolor_green,\
$graph->frame[$_CUR]->axis[$ax]->fontcolor_blue);\
$a = toscalar(@a);\
if (selectcoloritem($a, \"T-axis label color =   (r, g, b)\"))\
{\
@a = toarray($_RET);\
$graph->frame[$_CUR]->axis[$ax]->fontcolor_red = $a[0];\
$graph->frame[$_CUR]->axis[$ax]->fontcolor_green = $a[1];\
$graph->frame[$_CUR]->axis[$ax]->fontcolor_blue = $a[2];\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 2; @a = ($graph->frame[$_CUR]->axis[$ax]->fontcolor_red,\
$graph->frame[$_CUR]->axis[$ax]->fontcolor_green,\
$graph->frame[$_CUR]->axis[$ax]->fontcolor_blue);\
exit $graph->getcolorname(@a);"},
{M_T_LABELFORMAT, 0, "For&mat", true,\
"$ax = 2;\
if (selectlabelformat($graph->frame[$_CUR]->axis[$ax]->format, \"T-axis label format =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->format = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 2; exit $graph->getlabelformatname($graph->frame[$_CUR]->axis[$ax]->format);"},
{M_T_LABELADDPLUS, 0, "A&dd plus", true,\
"$ax = 2;\
if (selectyesno($graph->frame[$_CUR]->axis[$ax]->addplus, \"T-axis: add plus to label?\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->addplus = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 2; exit yesnoname($graph->frame[$_CUR]->axis[$ax]->addplus);"},
{M_T_LABELPOSITION, 0, "&Offset", true,\
"$ax = 2;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->offset, \"T-axis label positon =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->offset = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 2; exit $graph->frame[$_CUR]->axis[$ax]->offset;"},
{M_T_LABELSKIP, 0, "S&kipping", true,\
"$ax = 2;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->skip, \"T-axis labelskip = (0: auto)\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->skip = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 2; exit $graph->frame[$_CUR]->axis[$ax]->skip;"},
{M_T_LABELAUTOPRECISION, 0, "A&uto precision", true,\
"$ax = 2;\
if (selectyesno($graph->frame[$_CUR]->axis[$ax]->autoprecision, \"T-axis: auto precision ?\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->autoprecision = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 2; exit yesnoname($graph->frame[$_CUR]->axis[$ax]->autoprecision);"},
{M_T_LABELINTPRECISION, 0, "&Int. precision", true,\
"$ax = 2;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->intprecision, \"T-axis int precision ?\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->intprecision = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 2; exit $graph->frame[$_CUR]->axis[$ax]->intprecision;"},
{M_T_LABELDECIMALPRECISION, 0, "D&ec. precision", true,\
"$ax = 2;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->decimalprecision, \"T-axis decimal precision ?\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->decimalprecision = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 2; exit $graph->frame[$_CUR]->axis[$ax]->decimalprecision;"},
{M_T_LABELPARITY, 0, "&Parity", true,\
"$ax = 2;\
if (selectlabelparity($graph->frame[$_CUR]->axis[$ax]->labelparity, \"T-axis label parity ?\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->labelparity = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 2; exit $graph->getlabelparityname($graph->frame[$_CUR]->axis[$ax]->labelparity);"},
{M_T_CROSSPOINTPARITY, 0, "CrossP pa&rity", true,\
"$ax = 2;\
if (selectlabelcpparity($graph->frame[$_CUR]->axis[$ax]->crosspointparity, \"T-axis crosspoint parity ?\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->crosspointparity = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 2; exit $graph->getlabelcpparityname($graph->frame[$_CUR]->axis[$ax]->crosspointparity);"},
{M_T_CROSSPOINTOFFSET, 0, "crossP. offse&t", true,\
"$ax = 2;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->crosspointoffset, \"T-axis crosspoint offset ?\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->crosspointoffset = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 2; exit $graph->frame[$_CUR]->axis[$ax]->crosspointoffset;"},
endmenu;

defmenu(T, "Axis | T-axis")
{M_T_BASE, 0, "&Baseline", true, "tbasemenu();", ""},
{M_T_RANGE, 0, "&Range", true, "trangemenu();", ""},
{M_T_MAJORTICK, 0, "&Tick", true, "ttickmenu();", ""},
{M_T_MINORTICK, 0, "&Subtick", true, "tsubtickmenu();", ""},
{M_T_LABEL, 0, "&Label", true, "tlabelmenu();", ""},
endmenu;

/******************* end of t-axis *******************************/


/*************************************************************************/
/*                          R-axis                                       */
/*************************************************************************/

defmenu(RBase, "Axis | R-axis | Baseline")
{M_R_DISP, 0, "S&how", true,
"$ax = 3;\
if (selectyesno($graph->frame[$_CUR]->axis[$ax]->show, \"Show R-axis?\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->show = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 3; exit yesnoname($graph->frame[$_CUR]->axis[$ax]->show);"},
{M_R_COMMONSET, 0, "Co&mmonset", true,\
"$ax = 3;\
if (selectyesno($graph->frame[$_CUR]->axis[$ax]->commonset, \"Set R-axis as common settings?\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->commonset = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 3; exit yesnoname($graph->frame[$_CUR]->axis[$ax]->commonset);"},
{M_R_ORIGINX, 0, "&X", true,\
"$ax = 3;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->x, \"R-axis origin X =   (1/20 point)\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->x = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 3; exit $graph->frame[$_CUR]->axis[$ax]->x;"},
{M_R_ORIGINY, 0, "&Y", true,\
"$ax = 3;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->y, \"R-axis origin Y=   (1/20 point)\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->y = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 3; exit $graph->frame[$_CUR]->axis[$ax]->y;"},
{M_R_LENGTH, 0, "&Length", true,\
"$ax = 3;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->length, \"R-axis length =   (1/20 point)\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->length = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 3; exit $graph->frame[$_CUR]->axis[$ax]->length;"},
{M_R_ANGLE, 0, "&Angle", true,\
"$ax = 3;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->angle, \"R-axis angle =   (deg)\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->angle = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 3; exit $graph->frame[$_CUR]->axis[$ax]->angle;"},
{M_R_BASETICKAREA_START, 0, "Area &from", true,\
"$ax = 3;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->tickarea_start, \"R-axis tickarea from =   (%)\"))\
{\
  if ($_RET < 0 || $_RET > $graph->frame[$_CUR]->axis[$ax]->tickarea_end)\
  {\
    print (\"Error: invalid tickarea_start\n\");\
    exit(0);\
  }\
  $graph->frame[$_CUR]->axis[$ax]->tickarea_start = $_RET;\
  $graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 3; exit $graph->frame[$_CUR]->axis[$ax]->tickarea_start;"},
{M_R_BASETICKAREA_END, 0, "Area &to", true,\
"$ax = 3;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->tickarea_end, \"R-axis tickarea to =   (%)\"))\
{\
  if ($_RET < 0 || $_RET < $graph->frame[$_CUR]->axis[$ax]->tickarea_start)\
  {\
    print (\"Error: invalid tickarea_end\n\");\
    exit(0);\
  }\
  $graph->frame[$_CUR]->axis[$ax]->tickarea_end = $_RET;\
  $graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 3; exit $graph->frame[$_CUR]->axis[$ax]->tickarea_end;"},
{M_R_BASELINEWIDTH, 0, "Line&width", true,\
"$ax = 3;\
if (edittext($graph->frame[$_RET]->axis[$ax]->baselinewidth, \"R-axis baseline width =   (1/20 point)\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->baselinewidth = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 3; exit $graph->frame[$_CUR]->axis[$ax]->baselinewidth;"},
{M_R_BASELINESTYLE, 0, "Line&style", true,\
"\
$ax = 3;\
if (selectlinestyle($graph->frame[$_CUR]->axis[$ax]->baselinestyle, \"R-axis baseline style =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->baselinestyle = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 3; exit $graph->getlinestylename($graph->frame[$_CUR]->axis[$ax]->baselinestyle);"},
{M_R_MAJORTICKLINECOLOR, 0, "Line&color", true,\
"$ax = 3; @a = ($graph->frame[$_CUR]->axis[$ax]->baselinecolor_red,\
$graph->frame[$_CUR]->axis[$ax]->baselinecolor_green,\
$graph->frame[$_CUR]->axis[$ax]->baselinecolor_blue);\
$a = toscalar(@a);\
if (selectcoloritem($a, \"R-axis baseline color =   (r, g, b)\"))\
{\
@a = toarray($_RET);\
$graph->frame[$_CUR]->axis[$ax]->baselinecolor_red = $a[0];\
$graph->frame[$_CUR]->axis[$ax]->baselinecolor_green = $a[1];\
$graph->frame[$_CUR]->axis[$ax]->baselinecolor_blue = $a[2];\
$graph->frame[$_CUR]->arrangeaxes();\
}",\
"\
$ax = 3; @a = ($graph->frame[$_CUR]->axis[$ax]->baselinecolor_red,\
$graph->frame[$_CUR]->axis[$ax]->baselinecolor_green,\
$graph->frame[$_CUR]->axis[$ax]->baselinecolor_blue);\
exit $graph->getcolorname(@a);"},
{M_R_BASELINECAP, 0, "Lineca&p", true,\
"\
$ax = 3;\
if (selectlinecap($graph->frame[$_CUR]->axis[$ax]->baselinecap, \"R-axis baseline cap =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->baselinecap = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",\
"$ax = 3; exit $graph->getlinecapname($graph->frame[$_CUR]->axis[$ax]->baselinecap);"},
endmenu;


defmenu(RRange, "Axis | R-axis | Range")
{M_R_START, 0, "&Start", true,\
"$ax = 3;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->start, \"R-axis start value =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->start = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 3; exit $graph->frame[$_CUR]->axis[$ax]->start;"},
{M_R_END, 0, "&End", false,\
"$ax = 3;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->end, \"R-axis end value =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->end = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 3; exit $graph->frame[$_CUR]->axis[$ax]->end;"},
{M_R_UNIT, 0, "&Unit", false,\
"$ax = 3;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->unit, \"R-axis unit value =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->unit = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 3; exit $graph->frame[$_CUR]->axis[$ax]->unit;"},
{M_R_SCALING, 0, "Sca&ling", true,\
"\
$ax = 3;\
if (selectscaling($graph->frame[$_CUR]->axis[$ax]->scaling, \"R-axis scaling =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->scaling = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",\
"$ax = 3; exit $graph->getscalingname($graph->frame[$_CUR]->axis[$ax]->scaling);"},
{M_R_INVERT, 0, "&Invert", true,\
"$ax = 3;\
if (selectyesno($graph->frame[$_CUR]->axis[$ax]->invertscale, \"Invert R-axis scale?\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->invertscale = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 3; exit yesnoname($graph->frame[$_CUR]->axis[$ax]->invertscale);"},
{M_R_CROSSPOINT, 0, "&Crosspoint", false,\
"$ax = 3;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->crosspoint, \"R-axis crosspoint value =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->crosspoint = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 3; exit $graph->frame[$_CUR]->axis[$ax]->crosspoint;"},
{M_R_AUTOCROSSPOINT, 0, "&Autocross", true,\
"$ax = 3;\
if (selectyesno($graph->frame[$_CUR]->axis[$ax]->autocrosspoint, \"Set R-axis crosspoint automatically?\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->autocrosspoint = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 3; exit yesnoname($graph->frame[$_CUR]->axis[$ax]->autocrosspoint);"},
endmenu;

defmenu(RMajortick, "Axis | R-axis | Tick")
{M_R_TICKPARITY, 0, "Tick&direction", true,\
"\
 $ax = 3;\
 if ($graph->frame[$_CUR]->axis[$ax]->tickparity == 1)\
 { $in = 2;}\
 elsif ($graph->frame[$_CUR]->axis[$ax]->tickparity == 2)\
 { $in = 1;}\
 else\
 { $in = $graph->frame[$_CUR]->axis[$ax]->tickparity;}\
\
 if (selecttickdirection($in, \"R-axis tick direction =\"))\
{\
 if ($_RET == 1)\
 { $graph->frame[$_CUR]->axis[$ax]->tickparity = 2;}\
 elsif ($_RET == 2)\
 { $graph->frame[$_CUR]->axis[$ax]->tickparity = 1;}\
 else\
 {$graph->frame[$_CUR]->axis[$ax]->tickparity = $_RET;}\
$graph->frame[$_CUR]->arrangeaxes();\
}",\
"$ax = 3; exit $graph->gettickdirname($graph->frame[$_CUR]->axis[$ax]->tickparity, $ax);"},
{M_R_TICKWIDTH , 0, "Tick&width", true,\
"$ax = 3;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->tickwidth, \"R-axis tick width =   (1/20 point)\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->tickwidth = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",\
"$ax = 3; exit $graph->frame[$_CUR]->axis[$ax]->tickwidth;"},
{M_R_TICKLENGTH , 0, "Tick&length", true,\
"$ax = 3;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->ticklength, \"R-axis tick length =   (1/20 point)\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->ticklength = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",\
"$ax = 3; exit $graph->frame[$_CUR]->axis[$ax]->ticklength;"},
{M_R_MAJORTICKLINEWIDTH, 0, "Linew&idth", true,\
"$ax = 3;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->majorticklinewidth, \"R-axis tickline width =   (1/20 point)\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->majorticklinewidth = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",\
"$ax = 3; exit $graph->frame[$_CUR]->axis[$ax]->majorticklinewidth;"},
{M_R_MAJORTICKLINESTYLE, 0, "Line&style", true,\
"\
$ax = 3;\
if (selectlinestyle($graph->frame[$_CUR]->axis[$ax]->majorticklinestyle, \"R-axis tickline style =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->majorticklinestyle = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 3; exit $graph->getlinestylename($graph->frame[$_CUR]->axis[$ax]->majorticklinestyle);"},
{M_R_MAJORTICKLINECOLOR, 0, "Line&color", true,\
"$ax = 3; @a = ($graph->frame[$_CUR]->axis[$ax]->majorticklinecolor_red,\
$graph->frame[$_CUR]->axis[$ax]->majorticklinecolor_green,\
$graph->frame[$_CUR]->axis[$ax]->majorticklinecolor_blue);\
$a = toscalar(@a);\
if (selectcoloritem($a, \"R-axis tickline color =   (r, g, b)\"))\
{\
@a = toarray($_RET);\
$graph->frame[$_CUR]->axis[$ax]->majorticklinecolor_red = $a[0];\
$graph->frame[$_CUR]->axis[$ax]->majorticklinecolor_green = $a[1];\
$graph->frame[$_CUR]->axis[$ax]->majorticklinecolor_blue = $a[2];\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 3; @a = ($graph->frame[$_CUR]->axis[$ax]->majorticklinecolor_red,\
$graph->frame[$_CUR]->axis[$ax]->majorticklinecolor_green,\
$graph->frame[$_CUR]->axis[$ax]->majorticklinecolor_blue);\
exit $graph->getcolorname(@a);"},
{M_R_MAJORTICKLINECAP, 0, "Lineca&p", true,\
"\
$ax = 3;\
if (selectlinecap($graph->frame[$_CUR]->axis[$ax]->majorticklinecap, \"R-axis tickline cap =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->majorticklinecap = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 3; exit $graph->getlinecapname($graph->frame[$_CUR]->axis[$ax]->majorticklinecap);"},
endmenu;


defmenu(RMinortick, "Axis | R-axis | Subtick")
{M_R_DIVISION , 0, "&Division No.", true,\
"$ax = 3;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->tickdivision, \"R-axis tick division number =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->tickdivision = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 3; exit $graph->frame[$_CUR]->axis[$ax]->tickdivision;"},
{M_R_MINORTICKLINEWIDTH, 0, "Line&width", true,\
"$ax = 3;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->minorticklinewidth, \"R-axis subtickline width =   (1/20 point)\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->minorticklinewidth = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 3; exit $graph->frame[$_CUR]->axis[$ax]->minorticklinewidth;"},
{M_R_MINORTICKLINESTYLE, 0, "Line&style", true,\
"\
$ax = 3;\
if (selectlinestyle($graph->frame[$_CUR]->axis[$ax]->minorticklinestyle, \"R-axis subtickline style =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->minorticklinestyle = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 3; exit $graph->getlinestylename($graph->frame[$_CUR]->axis[$ax]->minorticklinestyle);"},
{M_R_MINORTICKLINECOLOR, 0, "Line&color", true,\
"$ax = 3; @a = ($graph->frame[$_CUR]->axis[$ax]->minorticklinecolor_red,\
$graph->frame[$_CUR]->axis[$ax]->minorticklinecolor_green,\
$graph->frame[$_CUR]->axis[$ax]->minorticklinecolor_blue);\
$a = toscalar(@a);\
if (selectcoloritem($a, \"R-axis subtickline color =   (r, g, b)\"))\
{\
@a = toarray($_RET);\
$graph->frame[$_CUR]->axis[$ax]->minorticklinecolor_red = $a[0];\
$graph->frame[$_CUR]->axis[$ax]->minorticklinecolor_green = $a[1];\
$graph->frame[$_CUR]->axis[$ax]->minorticklinecolor_blue = $a[2];\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 3; @a = ($graph->frame[$_CUR]->axis[$ax]->minorticklinecolor_red,\
$graph->frame[$_CUR]->axis[$ax]->minorticklinecolor_green,\
$graph->frame[$_CUR]->axis[$ax]->minorticklinecolor_blue);\
exit $graph->getcolorname(@a);"},
{M_R_MINORTICKLINECAP, 0, "Lineca&p", true,\
"\
$ax = 3;\
if (selectlinecap($graph->frame[$_CUR]->axis[$ax]->minorticklinecap, \"R-axis subtickline cap =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->minorticklinecap = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 3; exit $graph->getlinecapname($graph->frame[$_CUR]->axis[$ax]->minorticklinecap);"},
endmenu;

defmenu(RLabel, "Axis | R-axis | Label")
{M_R_LABELFONTFACE, 0, "&Fontface", true,\
"$ax = 3;\
if (selectfontface($graph->frame[$_CUR]->axis[$ax]->fontface, \"R-axis label font =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->fontface = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 3; exit $graph->gettextfacename($graph->frame[$_CUR]->axis[$ax]->fontface);"},
{M_R_LABELFONTSIZE, 0, "Font&size", true,\
"$ax = 3;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->fontsize, \"R-axis label fontsize =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->fontsize = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 3; exit $graph->frame[$_CUR]->axis[$ax]->fontsize;"},
{M_R_LABELFONTANGLE, 0, "Font&angle", true,\
"$ax = 3;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->fontangle, \"R-axis label fontangle =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->fontangle = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 3; exit $graph->frame[$_CUR]->axis[$ax]->fontangle;"},
{M_R_LABELCOLOR, 0, "&Color", true,\
"$ax = 3; @a = ($graph->frame[$_CUR]->axis[$ax]->fontcolor_red,\
$graph->frame[$_CUR]->axis[$ax]->fontcolor_green,\
$graph->frame[$_CUR]->axis[$ax]->fontcolor_blue);\
$a = toscalar(@a);\
if (selectcoloritem($a, \"R-axis label color =   (r, g, b)\"))\
{\
@a = toarray($_RET);\
$graph->frame[$_CUR]->axis[$ax]->fontcolor_red = $a[0];\
$graph->frame[$_CUR]->axis[$ax]->fontcolor_green = $a[1];\
$graph->frame[$_CUR]->axis[$ax]->fontcolor_blue = $a[2];\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 3; @a = ($graph->frame[$_CUR]->axis[$ax]->fontcolor_red,\
$graph->frame[$_CUR]->axis[$ax]->fontcolor_green,\
$graph->frame[$_CUR]->axis[$ax]->fontcolor_blue);\
exit $graph->getcolorname(@a);"},
{M_R_LABELFORMAT, 0, "For&mat", true,\
"$ax = 3;\
if (selectlabelformat($graph->frame[$_CUR]->axis[$ax]->format, \"R-axis label format =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->format = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 3; exit $graph->getlabelformatname($graph->frame[$_CUR]->axis[$ax]->format);"},
{M_R_LABELADDPLUS, 0, "A&dd plus", true,\
"$ax = 3;\
if (selectyesno($graph->frame[$_CUR]->axis[$ax]->addplus, \"R-axis: add plus to label?\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->addplus = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 3; exit yesnoname($graph->frame[$_CUR]->axis[$ax]->addplus);"},
{M_R_LABELPOSITION, 0, "&Offset", true,\
"$ax = 3;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->offset, \"R-axis label positon =\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->offset = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 3; exit $graph->frame[$_CUR]->axis[$ax]->offset;"},
{M_R_LABELSKIP, 0, "S&kipping", true,\
"$ax = 3;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->skip, \"R-axis labelskip = (0: auto)\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->skip = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 3; exit $graph->frame[$_CUR]->axis[$ax]->skip;"},
{M_R_LABELAUTOPRECISION, 0, "A&uto precision", true,\
"$ax = 3;\
if (selectyesno($graph->frame[$_CUR]->axis[$ax]->autoprecision, \"R-axis: auto precision ?\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->autoprecision = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 3; exit yesnoname($graph->frame[$_CUR]->axis[$ax]->autoprecision);"},
{M_R_LABELINTPRECISION, 0, "&Int. precision", true,\
"$ax = 3;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->intprecision, \"R-axis int precision ?\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->intprecision = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 3; exit $graph->frame[$_CUR]->axis[$ax]->intprecision;"},
{M_R_LABELDECIMALPRECISION, 0, "D&ec. precision", true,\
"$ax = 3;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->decimalprecision, \"R-axis decimal precision ?\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->decimalprecision = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 3; exit $graph->frame[$_CUR]->axis[$ax]->decimalprecision;"},
{M_R_LABELPARITY, 0, "&Parity", true,\
"$ax = 3;\
if (selectlabelparity($graph->frame[$_CUR]->axis[$ax]->labelparity, \"R-axis label parity ?\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->labelparity = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 3; exit $graph->getlabelparityname($graph->frame[$_CUR]->axis[$ax]->labelparity);"},
{M_R_CROSSPOINTPARITY, 0, "CrossP pa&rity", true,\
"$ax = 3;\
if (selectlabelcpparity($graph->frame[$_CUR]->axis[$ax]->crosspointparity, \"R-axis crosspoint parity ?\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->crosspointparity = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 3; exit $graph->getlabelcpparityname($graph->frame[$_CUR]->axis[$ax]->crosspointparity);"},
{M_R_CROSSPOINTOFFSET, 0, "crossP. offse&t", true,\
"$ax = 3;\
if (edittext($graph->frame[$_CUR]->axis[$ax]->crosspointoffset, \"R-axis crosspoint offset ?\"))\
{\
$graph->frame[$_CUR]->axis[$ax]->crosspointoffset = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"$ax = 3; exit $graph->frame[$_CUR]->axis[$ax]->crosspointoffset;"},
endmenu;

defmenu(R, "Axis | R-axis")
{M_R_BASE, 0, "&Baseline", true, "rbasemenu();", ""},
{M_R_RANGE, 0, "&Range", true, "rrangemenu();", ""},
{M_R_MAJORTICK, 0, "&Tick", true, "rtickmenu();", ""},
{M_R_MINORTICK, 0, "&Subtick", true, "rsubtickmenu();", ""},
{M_R_LABEL, 0, "&Label", true, "rlabelmenu();", ""},
endmenu;

/******************* end of r-axis *******************************/


defmenu(Frame, "Axis | Frame")
{M_FRAME_X, 0, "&X1", true,\
"if (edittext($graph->frame[$_CUR]->x1, \"Frame X1 =   (1/20 point)\"))\
{\
$graph->frame[$_CUR]->x1 = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"exit $graph->frame[$_CUR]->x1;"
},
{M_FRAME_Y, 0, "&Y1", true,\
 "if (edittext($graph->frame[$_CUR]->y1, \"Frame Y1 =   (1/20 point)\"))\
{\
$graph->frame[$_CUR]->y1 = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"exit $graph->frame[$_CUR]->y1;"},
{M_FRAME_LENGTH_X, 0, "X2", true,\
"if (edittext($graph->frame[$_CUR]->x2, \"Frame X2 =   (1/20 point)\"))\
{\
$graph->frame[$_CUR]->x2 = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"exit $graph->frame[$_CUR]->x2;"},
{M_FRAME_LENGTH_Y, 0, "Y2", true,\
"if (edittext($graph->frame[$_CUR]->y2, \"Frame Y2 =   (1/20 point)\"))\
{\
$graph->frame[$_CUR]->y2 = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"exit $graph->frame[$_CUR]->y2;"},
{M_FRAMETYPE, 0, "&Frametype", true,\
"if (selectframetype($graph->frame[$_CUR]->frametype, \"Frame type =\"))\
{\
$graph->frame[$_CUR]->frametype = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"exit $graph->getframetypename($graph->frame[$_CUR]->frametype);"},
{M_FRAMELINE_WIDTH, 0, "Line&width", true,\
"if (edittext($graph->frame[$_CUR]->framelinewidth, \"Frame width =   (1/20 point)\"))\
{\
$graph->frame[$_CUR]->framelinewidth = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"exit $graph->frame[$_CUR]->framelinewidth;"},
{M_FRAMELINE_STYLE, 0, "Line&style", true,\
"if (selectlinestyle($graph->frame[$_CUR]->framelinestyle, \"Frameline style =\"))\
{\
$graph->frame[$_CUR]->framelinestyle = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"exit $graph->getlinestylename($graph->frame[$_CUR]->framelinestyle);"},
{M_FRAME_COLOR, 0, "Line&color", true,\
"\
@a = ($graph->frame[$_CUR]->framelinecolor_red,\
$graph->frame[$_CUR]->framelinecolor_green,\
$graph->frame[$_CUR]->framelinecolor_blue);\
$a = toscalar(@a);\
if (selectcoloritem($a, \"Frameline color =   (r, g, b)\"))\
{\
@a = toarray($_RET);\
$graph->frame[$_CUR]->framelinecolor_red = $a[0];\
$graph->frame[$_CUR]->framelinecolor_green = $a[1];\
$graph->frame[$_CUR]->framelinecolor_blue = $a[2];\
}",
"@a = ($graph->frame[$_CUR]->framelinecolor_red,\
$graph->frame[$_CUR]->framelinecolor_green,\
$graph->frame[$_CUR]->framelinecolor_blue);\
exit $graph->getcolorname(@a);\
"},
{M_FRAMEBODY_STYLE, 0, "Bodys&tyle", true,\
"if (selectfillstyle($graph->frame[$_CUR]->framebodyfillstyle, \"Framebody fill style =\"))\
{\
$graph->frame[$_CUR]->framebodyfillstyle = $_RET;\
$graph->frame[$_CUR]->arrangeaxes();\
}",
"exit $graph->getfillstylename($graph->frame[$_CUR]->framebodyfillstyle);"},
{M_FRAMEBODY_COLOR, 0, "Bodyc&olor", true,\
"@a = ($graph->frame[$_CUR]->framebodycolor_red,\
$graph->frame[$_CUR]->framebodycolor_green,\
$graph->frame[$_CUR]->framebodycolor_blue);\
$a = toscalar(@a);\
if (selectcoloritem($a, \"Framebody color =   (r, g, b)\"))\
{\
@a = toarray($_RET);\
$graph->frame[$_CUR]->framebodycolor_red = $a[0];\
$graph->frame[$_CUR]->framebodycolor_green = $a[1];\
$graph->frame[$_CUR]->framebodycolor_blue = $a[2];\
}",
"@a = ($graph->frame[$_CUR]->framebodycolor_red,\
$graph->frame[$_CUR]->framebodycolor_green,\
$graph->frame[$_CUR]->framebodycolor_blue);\
exit $graph->getcolorname(@a);\
"},
{M_FRAMEWITHDATA, 0, "Save with &data", false,
"\
if (selectyesno($graph->frame[$_CUR]->withdata, 'Save graph with data?'))\
{\
  $graph->frame[$_CUR]->withdata = $_RET;\
}\
",
"exit yesnoname($graph->frame[$_CUR]->withdata);"},
{M_FRAMPAINTORDER, 0, "&Paint order", true,\
"if (edittext($graph->frame[$_CUR]->paintorder, \"Paint order\"))\
{\
$graph->frame[$_CUR]->paintorder = $_RET;\
}",
"exit $graph->frame[$_CUR]->paintorder;"},
endmenu;

defmenu(Autoscale, "Axis | Autoscale")
{M_AUTOSCALE_ALL, 0, "&All", false, "\
if (edittext($graph->autoscalemargin, 'Autoscale margin =   (%)'))\
{\
  $graph->autoscalemargin = $_RET;\
  $graph->frame[$_CUR]->autoscale($_ALL, $_RET);\
}", ""},
{M_AUTOSCALE_X, 0, "&X", false, "\
if (edittext($graph->autoscalemargin, 'Autoscale margin =   (%)'))\
{\
  $graph->autoscalemargin = $_RET;\
  $graph->frame[$_CUR]->autoscale(0, $_RET);\
}", ""},
{M_AUTOSCALE_Y, 0, "&Y", false, "\
if (edittext($graph->autoscalemargin, 'Autoscale margin =   (%)'))\
{\
  $graph->autoscalemargin = $_RET;\
  $graph->frame[$_CUR]->autoscale(1, $_RET);\
}", ""},
{M_AUTOSCALE_T, 0, "&T", false, "\
if (edittext($graph->autoscalemargin, 'Autoscale margin =   (%)'))\
{\
  $graph->autoscalemargin = $_RET;\
  $graph->frame[$_CUR]->autoscale(2, $_RET);\
}", ""},
{M_AUTOSCALE_R, 0, "&R", false, "\
if (edittext($graph->autoscalemargin, 'Autoscale margin =   (%)'))\
{\
  $graph->autoscalemargin = $_RET;\
  $graph->frame[$_CUR]->autoscale(3, $_RET);\
}", ""},
endmenu;


defmenu(FrameEdit, "&Edit")
{M_FRAMELIST, 0, "&List", false,
"\
selectobject(frame, 1);\
", ""},
{M_FRAMEDEL, 0, "&Delete", false,
"\
if (selectyesno(1, 'Delete selected frames?'))\
{\
  if ($_RET){\
    $len = $graph->length(frame);\
    for ($i = $len - 1; $i >= 0; $i--)\
    {\
      if ($graph->frame[$i]->selected)\
      {\
        $graph->delete(frame, $i);\
      }\
    }\
    if ($graph->length(frame) == 0)\
    {\
      $graph->new(frame);\
    }\
    if ($graph->currentframe > $graph->length(frame) - 1)\
    {\
      $graph->currentframe = 0;\
    }\
    $graph->flushselect(frame);\
  }\
}\
", ""},
{M_FRAMEMOVE, 0, "&Move", false,
"\
@fr = ($graph->frame[$_CUR]->wtov_x(0),\
       $graph->frame[$_CUR]->wtov_y(0),\
       $graph->frame[$_CUR]->wtov_x($graph->frame[$_CUR]->x2 - $graph->frame[$_CUR]->x1),\
       $graph->frame[$_CUR]->wtov_y($graph->frame[$_CUR]->y2 - $graph->frame[$_CUR]->y1));\
if (objectmove(@fr))\
{\
  $x1 = $graph->frame[$_CUR]->vtow_x($_RET[0]);\
  $y1 = $graph->frame[$_CUR]->vtow_y($_RET[1]);\
  $x2 = $graph->frame[$_CUR]->vtow_x($_RET[2]) - $graph->frame[$_CUR]->x2 + $graph->frame[$_CUR]->x1;\
  $y2 = $graph->frame[$_CUR]->vtow_y($_RET[3]) - $graph->frame[$_CUR]->y2 + $graph->frame[$_CUR]->y1;\
  $graph->frame[$_CUR]->x1 += $x1;\
  $graph->frame[$_CUR]->y1 += $y1;\
  $graph->frame[$_CUR]->x2 += $x2;\
  $graph->frame[$_CUR]->y2 += $y2;\
  $graph->frame[$_CUR]->arrangeaxes();\
}", ""},
{M_FRAMESTRETCH, 0, "&Stretch", false,
"\
@fr = ($graph->frame[$_CUR]->wtov_x(0),\
       $graph->frame[$_CUR]->wtov_y(0),\
       $graph->frame[$_CUR]->wtov_x($graph->frame[$_CUR]->x2 - $graph->frame[$_CUR]->x1),\
       $graph->frame[$_CUR]->wtov_y($graph->frame[$_CUR]->y2 - $graph->frame[$_CUR]->y1));\
if (objectstretch(@fr))\
{\
  $x1 = $graph->frame[$_CUR]->vtow_x($_RET[0]);\
  $y1 = $graph->frame[$_CUR]->vtow_y($_RET[1]);\
  $x2 = $graph->frame[$_CUR]->vtow_x($_RET[2]) - $graph->frame[$_CUR]->x2 + $graph->frame[$_CUR]->x1;\
  $y2 = $graph->frame[$_CUR]->vtow_y($_RET[3]) - $graph->frame[$_CUR]->y2 + $graph->frame[$_CUR]->y1;\
  $graph->frame[$_CUR]->x1 += $x1;\
  $graph->frame[$_CUR]->y1 += $y1;\
  $graph->frame[$_CUR]->x2 += $x2;\
  $graph->frame[$_CUR]->y2 += $y2;\
  $graph->frame[$_CUR]->arrangeaxes();\
}", ""},
{M_FRAMEORDER, 0, "&Order", false, "\
if ($graph->selectednumber(frame) == 1)\
{\
  if (selectorder(0, 'selected frame order ='))\
  {\
     if ($_RET == 0)\
       {\
         $graph->top(frame, $_FSL);\
       }\
     elsif ($_RET == 1)\
       {\
         $graph->up(frame, $_FSL);\
       }\
     elsif ($_RET == 2)\
       {\
         $graph->down(frame, $_FSL);\
       }\
     elsif ($_RET == 3)\
       {\
         $graph->bottom(frame, $_FSL);\
       }\
  }\
}\
else\
{\
  print \"Warning!: Select one instance.\n\";\
}\
", ""},
{M_FRAMECLONE, 0, "&Clone", false, "\
if ($graph->selectednumber(frame) == 1)\
{\
  if (selectyesno(1, 'Duplicate selected frame object?'))\
  {\
    if ($_RET)\
    {\
      $no = $graph->new(frame) - 1;\
      $graph->copy(frame, $no, $_FSL);\
      $graph->frame[$_ALL]->selected = 0;\
      $graph->frame[$no]->selected = 1;\
      $graph->currentframe = $no;\
    }\
  }\
}\
else\
{\
  print \"Warning!: Select one instance.\n\";\
}\
", ""},
endmenu;

defmenu(Axis, "Axis")
{M_X, X, "&X-axis", false, "", ""},
{M_Y, Y, "&Y-axis", false, "", ""},
{M_T, T, "&T-axis", false, "", ""},
{M_R, R, "&R-axis", false, "", ""},
{M_FRAME, 0, "&Frame", false, "framemenu();", ""},
{M_SEP, 0, "", false, "", ""},
{M_FRAMECURRENT, 0, "&Current frame", false,
"\
$graph->flushselect(frame);\
$graph->frame[$_CUR]->selected = 1;\
if (selectobject(frame, 0))\
{\
  $len = $graph->length(frame);\
  for ($i = $len -1; $i >= 0; $i--)\
    {\
       if ($graph->frame[$i]->selected == 1)\
	 {\
	    $graph->currentframe = $i;\
	}\
   }\
$graph->flushselect(frame);\
}\
", ""},
{M_FRAMENEW, 0, "&Add", false,
"\
if(selectyesno(1, 'Add a new frame?'))\
{\
  if ($_RET){\
    $no = $graph->new(frame) - 1;\
    if (!execfile(\"initframe\", $no))\
    {\
      print (\"Error!: cannot initialize frame object.\n\");\
    }\
    $graph->frame[$_ALL]->selected = 0;\
    $graph->frame[$no]->selected = 1;\
    $graph->currentframe = $no;\
  }\
}\
", ""},
{M_FRAMEEDIT, FrameEdit, "&Edit", false, "", ""},
{M_SEP, 0, "", false, "", ""},
{M_AUTOSCALE, Autoscale, "A&utoscaling", false,"", ""},
{M_TRIMMING, 0, "Trimm&ing", false, "\
if (trimming())\
{\
  $graph->frame[$_CUR]->axis[0]->start = min($_RET[0], $_RET[2]);\
  $graph->frame[$_CUR]->axis[0]->end = max($_RET[0], $_RET[2]);\
  $graph->frame[$_CUR]->axis[1]->start = min($_RET[1], $_RET[3]);\
  $graph->frame[$_CUR]->axis[1]->end = max($_RET[1], $_RET[3]);\
  $graph->frame[$_CUR]->autounit(0);\
  $graph->frame[$_CUR]->autounit(1);\
  $graph->frame[$_CUR]->arrangeaxes();\
}\
", ""},
{M_WATCH, 0, "&Watch point", false, "watch();", ""},
endmenu;

defmenu(File, "File")
{M_GRAPHNEW, 0, "&Initialize graph", false, "\
if ($graph->updated)\
{\
  if (selectyesno(0, 'The graph is updated. Refresh graph?'))\
  {\
    if ($_RET)\
    {\
      print ('Initializing graph .... ');\
      $graph->delete('frame', $_ALL);\
      $no = $graph->new('frame') - 1;\
      $graph->graphname = 'untitled.tpz';\
      updateseparator();\
      if (!execfile(\"initframe\", $no))\
      {\
        print (\"Error!: cannot initialize frame.\n\");\
      }\
      $graph->updated = 0;\
      print (\"done.\n\");\
    }\
  }\
}\
else\
{\
  print ('Initializing graph .... ');\
  $graph->delete('frame', $_ALL);\
  $no = $graph->new('frame') - 1;\
  $graph->currentframe = 0;\
  $graph->graphname = 'untitled.tpz';\
  updateseparator();\
  if (!execfile(\"initframe\", $no))\
  {\
    print (\"Error!: cannot initialize frame.\n\");\
  }\
  $graph->updated = 0;\
  print (\"done.\n\");\
}\
", ""},
{M_GRAPHOPEN, 0, "&Open graph", false, "\
if ($graph->updated)\
{\
  if (!selectyesno(0, 'The graph is updated. Load new graph?') || !$_RET)\
  {\
    exit(0);\
  }\
}\
if ($graph->init->search(graphext) == -1)\
{\
  $ext = '(\\\\.[Tt][Pp][Zz]|\\\\.[Gg][Ee][Mm])';\
}\
else\
{\
  $ext = $graph->init->get(graphext);\
}\
if (selectfile(0, $ext))\
{\
  print 'loading graph .....    ';\
  $graph->gropen($_RET[0]);\
  $graph->graphname = $_RET[0];\
  print \"done\n\";\
  execfile('updatehistory', $graph->graphname);\
}\
", ""},
{M_GRAPHAPPEND, 0, "&Append graph", false, "\
if (selectfile(0, '(\\\\.[Tt][Pp][Zz]|\\\\.[Gg][Ee][Mm])'))\
{\
  print 'loading graph .....    ';\
  $graph->grappend($_RET[0]);\
  print \"done\n\";\
}\
", ""},
{M_GRAPHSAVE, 0, "&Save as file", false, "\
if ($graph->graphname eq 'untitled.tpz')\
{\
  $cp = (getcwd()).'/'.$graph->graphname;\
  if (editfilename($cp, 'save graph: input filename'))\
  {\
    print 'saving graph .....    ';\
    $graph->grsave($_RET);\
    print \"done\n\";\
    execfile('updatehistory', $graph->graphname);\
  }\
}\
else\
{\
  if (editfilename($graph->graphname, 'save graph: input filename'))\
  {\
    $name = $_RET;\
    if (isfileexist($_RET))\
    {\
      if (selectyesno(0, 'file exists. overwrite?'))\
      {\
        if ($_RET)\
	{\
          print 'saving graph .....    ';\
          $graph->grsave($name);\
          print \"done\n\";\
          execfile('updatehistory', $graph->graphname);\
        }\
      }\
    }\
    else\
    {\
      print 'saving graph .....    ';\
      $graph->graphname = $name;\
      $graph->grsave($name);\
      print \"done\n\";\
      execfile('updatehistory', $graph->graphname);\
    }\
  }\
}\
", ""},
{M_SEP, 0, "", false, "", ""},
{M_CHANGEDIR, 0, "Change &directory", false, "\
$dir = getcwd().'/';\
if (editfilename($dir, 'change working directory ='))\
{\
  if (!chdir($_RET))\
  {\
    print \"Error!: cannot change directory: '$_RET'\n\";\
  }\
}\
", ""},
{M_PRINT, 0, "&Print graph", false, "\
if (edittext($graph->init->get('printscript'), 'script for printing graph ='))\
{\
  print 'printing graph .....    ';\
  $graph->init->set(printscript, $_RET);\
  open(PRINTER, $_RET);\
  $graph->preout(PRINTER);\
  $graph->paint(PRINTER);\
  $graph->postout(PRINTER);\
  close(PRINTER);\
  print \"done\n\";\
}\
", ""},
{M_EXPORT, 0, "&Export graph", false, "\
if (edittext($graph->init->get('exportscript'), 'script for exporting graph ='))\
{\
  print 'exporting graph .....    ';\
  $graph->init->set(exportscript, $_RET);\
  open(EXPORT, $_RET);\
  $graph->setbbox();\
  $graph->preout(EXPORT);\
  $graph->paint(EXPORT);\
  $graph->postout(EXPORT);\
  close(EXPORT);\
  print \"done\n\";\
}\
", ""},
{M_SEP, 0, "", false, "", ""},
{M_ABOUT, 0, "A&bout Topaz", false,
"\
$ver = $graph->version;\
message(\"Topaz Version $ver\n\nProgrammed by Hisao Kawaura, 1997-2005\n\n All rights reserved\n\n\nHit any key!!\");\
", ""},
{M_QUIT, 0, "&Quit Topaz", false,
"exit(0);", ""},
{M_SEP, 0, "", false, "", ""},
{M_HISTORY, 0, "&History", false,
"\
$hf = \"$TOPAZINIDIR/history\";\
@list = 0;\
@flist = 0;\
if (isfileexist($hf))\
{\
  open(F, $hf);\
  while($line = <F>)\
  {\
    $line =~ \"^[ ]*([^ \n]+)[ ]*\";\
    @list ,= $1;\
    @flist ,= removepath($1) . ': ' . '(' . $1 . ')';\
  }\
  close F;\
}\
if(selectlistitem('History', 0, @flist))\
{\
  $sno = $_RET;\
  if ($graph->updated)\
  {\
    if (!selectyesno(0, 'The graph is updated. Load new graph?') || !$_RET)\
    {\
      exit(0);\
    }\
  }\
  if (isfileexist($list[$sno]))\
  {\
    print 'loading graph .....    ';\
    $graph->gropen($list[$sno]);\
    print \"done\n\";\
    $graph->graphname = $list[$sno];\
    execfile('updatehistory', $graph->graphname);\
  }\
  else\
  {\
    print \"Cannot find $list[$sno]!!\n\";\
  }\
}", ""},
endmenu;

defmenu(Viewer, "Window")
{M_VIEWER_DRAW, 0, "&View     (space key)", true, "$graph->paintall(V0);",""},
{M_MAG, 0, "&Zooming", true,\
"\
if (selectmag($graph->mag * 100, \"Window zooming rate =   (%)\"))\
{\
$graph->mag = $_RET / 100;\
}", ""},
{M_VIEWER_SHIFT, 0, "&Shift view area", true,\
"\
$len = $graph->length('frame');\
if ($len == 0)\
{\
  exit(0);\
}\
@fr = 0;\
@fr ,= (0, 0, $graph->papersize_x, $graph->papersize_y);\
for ($i = 0; $i < $len; $i++)\
{\
@fr ,= ($graph->frame[$i]->wtov_x(0),\
        $graph->frame[$i]->wtov_y(0),\
        $graph->frame[$i]->wtov_x($graph->frame[$i]->x2 - $graph->frame[$i]->x1),\
        $graph->frame[$i]->wtov_y($graph->frame[$i]->y2 - $graph->frame[$i]->y1));\
}\
if (objectmove(@fr))\
{\
  $graph->offset_x -= $_RET[0];\
  $graph->offset_y -= $_RET[1];\
}\
", ""},
{M_WIN_HOME, 0, "&Back to home position", true,\
"\
if (selectyesno(1, 'Back to  home position?'))\
{\
  if ($_RET)\
  {\
    $graph->offset_x = 0;\
    $graph->offset_y = 0;\
  }\
}", ""},
{M_PAPERSIZE, 0, "&Paper size", true,
"\
@size = ($graph->papersize_x, $graph->papersize_y);\
$size = toscalar(@size);\
if (selectpapersize($size, \"Paper size = \"))\
{\
  @size = toarray($_RET);\
  $graph->papersize_x = $size[0];\
  $graph->papersize_y = $size[1];\
}", ""},
{M_MSGWIN_CLEAR, 0, "&Clear message window", true,
"\
if (selectyesno(0, 'Clear message window?'))\
{\
  if ($_RET)\
  {\
    flushmsg();\
  }\
}\
", ""},
endmenu;

defmenu(Macro, "Macro")
{M_MACROEXEC, 0, "&Script", false, \
"if (edittext($graph->init->get(defaultmacroscript), 'Execute Macro script'))\
{\
$graph->init->set(defaultmacroscript, $_RET);\
eval($_RET);\
}", ""},
{M_MACROEXECFROMFILE, 0, "&File", false, \
"if (edittext($graph->init->get(defaultmacrofile), 'Execute Macro file'))\
{\
$graph->init->set(defaultmacrofile, $_RET);\
execfile(toarray($_RET));\
}", ""},
{M_SEP, 0, "", false, "", ""},
{M_MACRORESISTERED, 0, "&Resistered", false, \
"\
if ($graph->init->search(regmacroentry) == -1)\
{\
  $selected = 0;\
}\
else\
{\
  $selected = $graph->init->get(regmacroentry);\
}\
@listentry = 0;\
@listmacro = 0;\
$line = '';\
$reg = \"$TOPAZINIDIR/regmacro\";\
if (isfileexist($reg))\
{\
  open(MACRORESITEREDFILELIST, $reg);\
  while($file = <MACRORESITEREDFILELIST>)\
  {\
    $file =~ \"^[ ]*([^ \n]+)[ ]*\";\
    $sfile = $1;\
    $file = getmacroname($sfile);\
    if ($file ne ''){\
      @listmacro ,= $sfile;\
      open(MACRORESITEREDFILE, $file);\
      $desc = '';\
      for ($i = 0; $i < 5; $i++)\
      {\
	if ($line = <MACRORESITEREDFILE>)\
	{\
          if ($line =~ \"^[ ]*###[ ]*description:[ ]*([^\n]*)\n\")\
          {\
             $desc = $1;\
          }\
	}\
      }\
      close MACRORESITEREDFILE;\
      @listentry ,= $sfile . \": \". $desc;\
    }\
  }\
  close MACRORESITEREDFILELIST;\
  if (selectlistitem('Registered macros', $selected, @listentry)){\
    execfile($listmacro[$_RET]);\
    $graph->init->set(regmacroentry,$_RET);\
  }\
}else{\
open(F, \">${reg}\"); close F;\
print \"Cannot find registered-macro list: ${reg}!!\nThis file is created.\n\";\
}", ""},
endmenu;

/*****************************************************************/
/********************* data **************************************/
/*****************************************************************/


defmenu(Nonlinear, "Data | Generate curve | Non-linear fitting")
{M_DATA_CREATE_NONLINEAR_START, 0, "&Start", true,
"if (edittext($graph->init->get(n_start), \"start value of data?\"))\
{\
  $graph->init->set(n_start, $_RET);\
}",
"exit $graph->init->get(n_start);"},
{M_DATA_CREATE_NONLINEAR_END, 0, "&End", true,
"if (edittext($graph->init->get(n_end), \"end value of data?\"))\
{\
  $graph->init->set(n_end, $_RET);\
}",
"exit $graph->init->get(n_end);"},
{M_DATA_CREATE_NONLINEAR_DIV, 0, "&Div", true,
"if (edittext($graph->init->get(n_div), \"division number of data?\"))\
{\
  $graph->init->set(n_div, $_RET);\
}",
"exit $graph->init->get(n_div);"},
{M_DATA_CREATE_NONLINEAR_SCALING, 0, "S&caling", true,
"if (selectmscaling($graph->init->get(n_scaling), \"scaling of data?\"))\
{\
  $graph->init->set(n_scaling, $_RET);\
}",
"exit $graph->getscalingname($graph->init->get(n_scaling));"},
{M_DATA_CREATE_NONLINEAR_FUNCTION, 0, "&Function", true,
"if (edittext($graph->init->get(n_function), \"function?\"))\
{\
  $graph->init->set(n_function, $_RET);\
}",
"exit $graph->init->get(n_function);"},
{M_DATA_CREATE_NONLINEAR_ALLOW, 0, "&Allowance", true,
"if (edittext($graph->init->get(n_allowance), \"allowance (%) =\"))\
{\
  $graph->init->set(n_allowance, $_RET);\
}",
"exit $graph->init->get(n_allowance);"},
{M_DATA_CREATE_NONLINEAR_STARTL, 0, "F&rom", true,
"if (edittext($graph->init->get(n_from), \"data line No. from?\"))\
{\
  $graph->init->set(n_from, $_RET);\
}",
"exit $graph->init->get(n_from);"},
{M_DATA_CREATE_NONLINEAR_ENDL, 0, "&To", true,
"if (edittext($graph->init->get(n_to), \"data line No. to?\"))\
{\
  $graph->init->set(n_to, $_RET);\
}",
"exit $graph->init->get(n_to);"},
{M_DATA_CREATE_NONLINEAR_INI_A, 0, "A", true,
"if (edittext($graph->init->get(n_ini_a), \"initial value of parameter 'A' =\"))\
{\
  $graph->init->set(n_ini_a, $_RET);\
}",
"exit $graph->init->get(n_ini_a);"},
{M_DATA_CREATE_NONLINEAR_FUN_A, 0, "dy/dA", true,
"if (edittext($graph->init->get(n_fun_a), \"dy/dA =\"))\
{\
  $graph->init->set(n_fun_a, $_RET);\
}",
"exit $graph->init->get(n_fun_a);"},
{M_DATA_CREATE_NONLINEAR_INI_B, 0, "B", true,
"if (edittext($graph->init->get(n_ini_b), \"initial value of parameter 'B' =\"))\
{\
  $graph->init->set(n_ini_b, $_RET);\
}",
"exit $graph->init->get(n_ini_b);"},
{M_DATA_CREATE_NONLINEAR_FUN_B, 0, "dy/dB", true,
"if (edittext($graph->init->get(n_fun_b), \"dy/dB =\"))\
{\
  $graph->init->set(n_fun_b, $_RET);\
}",
"exit $graph->init->get(n_fun_b);"},
{M_DATA_CREATE_NONLINEAR_INI_C, 0, "C", true,
"if (edittext($graph->init->get(n_ini_c), \"initial value of parameter 'C' =\"))\
{\
  $graph->init->set(n_ini_c, $_RET);\
}",
"exit $graph->init->get(n_ini_c);"},
{M_DATA_CREATE_NONLINEAR_FUN_C, 0, "dy/dC", true,
"if (edittext($graph->init->get(n_fun_c), \"dy/dC =\"))\
{\
  $graph->init->set(n_fun_c, $_RET);\
}",
"exit $graph->init->get(n_fun_c);"},
{M_DATA_CREATE_NONLINEAR_INI_D, 0, "D", true,
"if (edittext($graph->init->get(n_ini_d), \"initial value of parameter 'D' =\"))\
{\
  $graph->init->set(n_ini_d, $_RET);\
}",
"exit $graph->init->get(n_ini_d);"},
{M_DATA_CREATE_NONLINEAR_FUN_D, 0, "dy/dD", true,
"if (edittext($graph->init->get(n_fun_d), \"dy/dD =\"))\
{\
  $graph->init->set(n_fun_d, $_RET);\
}",
"exit $graph->init->get(n_fun_d);"},
{M_DATA_CREATE_NONLINEAR_INI_E, 0, "E", true,
"if (edittext($graph->init->get(n_ini_e), \"initial value of parameter 'E' =\"))\
{\
  $graph->init->set(n_ini_e, $_RET);\
}",
"exit $graph->init->get(n_ini_e);"},
{M_DATA_CREATE_NONLINEAR_FUN_E, 0, "dy/dE", true,
"if (edittext($graph->init->get(n_fun_e), \"dy/dE =\"))\
{\
  $graph->init->set(n_fun_e, $_RET);\
}",
"exit $graph->init->get(n_fun_e);"},
{M_DATA_CREATE_NONLINEAR_INI_F, 0, "F", true,
"if (edittext($graph->init->get(n_ini_f), \"initial value of parameter 'F' =\"))\
{\
  $graph->init->set(n_ini_f, $_RET);\
}",
"exit $graph->init->get(n_ini_f);"},
{M_DATA_CREATE_NONLINEAR_FUN_F, 0, "dy/dF", true,
"if (edittext($graph->init->get(n_fun_f), \"dy/dF =\"))\
{\
  $graph->init->set(n_fun_f, $_RET);\
}",
"exit $graph->init->get(n_fun_f);"},
{M_DATA_CREATE_NONLINEAR_INI_G, 0, "G", true,
"if (edittext($graph->init->get(n_ini_g), \"initial value of parameter 'G' =\"))\
{\
  $graph->init->set(n_ini_g, $_RET);\
}",
"exit $graph->init->get(n_ini_g);"},
{M_DATA_CREATE_NONLINEAR_FUN_G, 0, "dy/dG", true,
"if (edittext($graph->init->get(n_fun_g), \"dy/dG =\"))\
{\
  $graph->init->set(n_fun_g, $_RET);\
}",
"exit $graph->init->get(n_fun_g);"},
{M_DATA_CREATE_NONLINEAR_INI_H, 0, "H", true,
"if (edittext($graph->init->get(n_ini_h), \"initial value of parameter 'H' =\"))\
{\
  $graph->init->set(n_ini_h, $_RET);\
}",
"exit $graph->init->get(n_ini_h);"},
{M_DATA_CREATE_NONLINEAR_FUN_H, 0, "dy/dH", true,
"if (edittext($graph->init->get(n_fun_h), \"dy/dH =\"))\
{\
  $graph->init->set(n_fun_h, $_RET);\
}",
"exit $graph->init->get(n_fun_h);"},
{M_DATA_CREATE_NONLINEAR_INI_I, 0, "I", true,
"if (edittext($graph->init->get(n_ini_i), \"initial value of parameter 'I' =\"))\
{\
  $graph->init->set(n_ini_i, $_RET);\
}",
"exit $graph->init->get(n_ini_i);"},
{M_DATA_CREATE_NONLINEAR_FUN_A, 0, "dy/dI", true,
"if (edittext($graph->init->get(n_fun_i), \"dy/dI =\"))\
{\
  $graph->init->set(n_fun_i, $_RET);\
}",
"exit $graph->init->get(n_fun_i);"},
endmenu;


defmenu(Linear, "Data | Generate curve | Linear fitting")
{M_DATA_CREATE_LINEAR_START, 0, "&Start", true,
"if (edittext($graph->init->get(l_start), \"start value of data?\"))\
{\
  $graph->init->set(l_start, $_RET);\
}",
"exit $graph->init->get(l_start);"},
{M_DATA_CREATE_LINEAR_END, 0, "&End", true,
"if (edittext($graph->init->get(l_end), \"end value of data?\"))\
{\
  $graph->init->set(l_end, $_RET);\
}",
"exit $graph->init->get(l_end);"},
{M_DATA_CREATE_LINEAR_DIV, 0, "&Div", true,
"if (edittext($graph->init->get(l_div), \"division number of data?\"))\
{\
  $graph->init->set(l_div, $_RET);\
}",
"exit $graph->init->get(l_div);"},
{M_DATA_CREATE_LINEAR_SCALING, 0, "S&caling", true,
"if (selectmscaling($graph->init->get(l_scaling), \"scaling of data?\"))\
{\
  $graph->init->set(l_scaling, $_RET);\
}",
"exit $graph->getscalingname($graph->init->get(l_scaling));"},
{M_DATA_CREATE_LINEAR_FUNCTION, 0, "&Function", true,
"if (selectlinearfitfunction($graph->init->get(l_function), \"function?\"))\
{\
  $graph->init->set(l_function, $_RET);\
}",
"exit $graph->getlinearfitfunctionname($graph->init->get(l_function));"},
{M_DATA_CREATE_LINEAR_STARTL, 0, "F&rom", true,
"if (edittext($graph->init->get(l_from), \"data line No. from?\"))\
{\
  $graph->init->set(l_from, $_RET);\
}",
"exit $graph->init->get(l_from);"},
{M_DATA_CREATE_LINEAR_ENDL, 0, "&To", true,
"if (edittext($graph->init->get(l_to), \"data line No. to?\"))\
{\
  $graph->init->set(l_to, $_RET);\
}",
"exit $graph->init->get(l_to);"},
{M_DATA_CREATE_LINEAR_FIXED, 0, "F&ixed point", true,
"if (selectyesno($graph->init->get(l_fixedpoint), \"through given fixed point?\"))\
{\
  $graph->init->set(l_fixedpoint, $_RET);\
}",
"exit yesnoname($graph->init->get(l_fixedpoint));"},
{M_DATA_CREATE_LINEAR_FIXEDX, 0, "point &x", true,
"if (edittext($graph->init->get(l_fixedx), \"fixed point x?\"))\
{\
  $graph->init->set(l_fixedx, $_RET);\
}",
"exit $graph->init->get(l_fixedx);"},
{M_DATA_CREATE_LINEAR_FIXEDY, 0, "point &y", true,
"if (edittext($graph->init->get(l_fixedy), \"fixed point y?\"))\
{\
  $graph->init->set(l_fixedy, $_RET);\
}",
"exit $graph->init->get(l_fixedy);"},
endmenu;


defmenu(Function, "Data | Generate curve | Function")
{M_DATA_CREATE_FUNC_START, 0, "&Start", true,
"if (edittext($graph->init->get(f_start), \"start value of data?\"))\
{\
  $graph->init->set(f_start, $_RET);\
}",
"exit $graph->init->get(f_start);"},
{M_DATA_CREATE_FUNC_END, 0, "&End", true,
"if (edittext($graph->init->get(f_end), \"end value of data?\"))\
{\
  $graph->init->set(f_end, $_RET);\
}",
"exit $graph->init->get(f_end);"},
{M_DATA_CREATE_FUNC_DIV, 0, "&Div", true,
"if (edittext($graph->init->get(f_div), \"division number of data?\"))\
{\
  $graph->init->set(f_div, $_RET);\
}",
"exit $graph->init->get(f_div);"},
{M_DATA_CREATE_FUNC_SCALING, 0, "S&caling", true,
"if (selectmscaling($graph->init->get(f_scaling), \"scaling of data?\"))\
{\
  $graph->init->set(f_scaling, $_RET);\
}",
"exit $graph->getscalingname($graph->init->get(f_scaling));"},
{M_DATA_CREATE_FUNC_FUNCTION, 0, "&Function", true,
"if (edittext($graph->init->get(f_function), \"function?\"))\
{\
  $graph->init->set(f_function, $_RET);\
}",
"exit $graph->init->get(f_function);"},
endmenu;


defmenu(Create, "Data | Fit")
{M_DATA_CREATE_FUNC, 0, "&Function", true,
"\
functionmenu();\
if (selectyesno(1, 'Generate curve?'))\
{\
  if ($_RET)\
  {\
    $no = $graph->frame[$_CUR]->new(data) - 1;\
    if (!execfile(\"initdata\", $graph->currentframe, $no))\
    {\
      exit(1);\
    }\
    $graph->frame[$_CUR]->data[$no]->m_start     = $graph->init->get(f_start);\
    $graph->frame[$_CUR]->data[$no]->m_end       = $graph->init->get(f_end);\
    $graph->frame[$_CUR]->data[$no]->m_div       = $graph->init->get(f_div);\
    $graph->frame[$_CUR]->data[$no]->m_scaling   = $graph->init->get(f_scaling);\
    $graph->frame[$_CUR]->data[$no]->trans_y     = 1;\
    $graph->frame[$_CUR]->data[$no]->format_y    = $graph->init->get(f_function);\
    $graph->frame[$_CUR]->data[$no]->isfiledata  = 0;\
    $graph->frame[$_CUR]->data[$no]->remakebuffer();\
  }\
}\
",""},
{M_DATA_CREATE_LINEAR, 0, "&Linear fitting", true,
"\
if ($graph->frame[$_CUR]->selectednumber(data) == 0)\
{\
  print \"Warning!: No instance selected.\n\";\
  exit(1);\
}\
linearfitmenu();\
if (selectyesno(1, 'Generate curve?'))\
{\
  if ($_RET)\
  {\
    @ret = @graph->frame[$_CUR]->data[$_FSL]->linearfit($graph->init->get(l_function),\
                                              $graph->init->get(l_fixedpoint),\
                                              $graph->init->get(l_fixedx),\
                                              $graph->init->get(l_fixedy),\
                                              $graph->init->get(l_from),\
                                              $graph->init->get(l_to)\
                                             );\
    if ($ret[0] ne '')\
    {\
      $no = $graph->frame[$_CUR]->new(data) - 1;\
      if (!execfile(\"initdata\", $graph->currentframe, $no))\
      {\
        exit(1);\
      }\
      $graph->frame[$_CUR]->data[$no]->m_start     = $graph->init->get(l_start);\
      $graph->frame[$_CUR]->data[$no]->m_end       = $graph->init->get(l_end);\
      $graph->frame[$_CUR]->data[$no]->m_div       = $graph->init->get(l_div);\
      $graph->frame[$_CUR]->data[$no]->m_scaling   = $graph->init->get(l_scaling);\
      $graph->frame[$_CUR]->data[$no]->trans_y     = 1;\
      $graph->frame[$_CUR]->data[$no]->format_y    = $ret[0];\
      $graph->frame[$_CUR]->data[$no]->isfiledata  = 0;\
      $graph->frame[$_CUR]->data[$no]->info        = $ret[1];\
      $graph->frame[$_CUR]->data[$no]->refaxis_x   = $graph->frame[$_CUR]->data[$_FSL]->refaxis_x;\
      $graph->frame[$_CUR]->data[$no]->refaxis_y   = $graph->frame[$_CUR]->data[$_FSL]->refaxis_y;\
      $graph->frame[$_CUR]->data[$no]->remakebuffer();\
      print fromplaintext($ret[1]);\
    }\
  }\
}\
",""},
{M_DATA_CREATE_NONLINEAR, 0, "&Non-linear fitting", true,
"\
if ($graph->frame[$_CUR]->selectednumber(data) == 0)\
{\
  print \"Warning!: No instance selected.\n\";\
  exit(1);\
}\
nonlinearfitmenu();\
if (selectyesno(1, 'Generate curve?'))\
{\
  if ($_RET)\
  {\
    @ret = @graph->frame[$_CUR]->data[$_FSL]->nonlinearfit(\
                                              $graph->init->get(n_from),\
                                              $graph->init->get(n_to),\
                                              $graph->init->get(n_function),\
                                              $graph->init->get(n_ini_a),\
                                              $graph->init->get(n_ini_b),\
                                              $graph->init->get(n_ini_c),\
                                              $graph->init->get(n_ini_d),\
                                              $graph->init->get(n_ini_e),\
                                              $graph->init->get(n_ini_f),\
                                              $graph->init->get(n_ini_g),\
                                              $graph->init->get(n_ini_h),\
                                              $graph->init->get(n_ini_i),\
                                              $graph->init->get(n_fun_a),\
                                              $graph->init->get(n_fun_b),\
                                              $graph->init->get(n_fun_c),\
                                              $graph->init->get(n_fun_d),\
                                              $graph->init->get(n_fun_e),\
                                              $graph->init->get(n_fun_f),\
                                              $graph->init->get(n_fun_g),\
                                              $graph->init->get(n_fun_h),\
                                              $graph->init->get(n_fun_i),\
                                              $graph->init->get(n_allowance)\
                                             );\
    if ($ret[0] ne '')\
    {\
      $no = $graph->frame[$_CUR]->new(data) - 1;\
      if (!execfile(\"initdata\", $graph->currentframe, $no))\
      {\
        exit(1);\
      }\
      $graph->frame[$_CUR]->data[$no]->m_start     = $graph->init->get(n_start);\
      $graph->frame[$_CUR]->data[$no]->m_end       = $graph->init->get(n_end);\
      $graph->frame[$_CUR]->data[$no]->m_div       = $graph->init->get(n_div);\
      $graph->frame[$_CUR]->data[$no]->m_scaling   = $graph->init->get(n_scaling);\
      $graph->frame[$_CUR]->data[$no]->trans_y     = 1;\
      $graph->frame[$_CUR]->data[$no]->format_y    = $ret[0];\
      $graph->frame[$_CUR]->data[$no]->isfiledata  = 0;\
      $graph->frame[$_CUR]->data[$no]->info        = $ret[1];\
      $graph->frame[$_CUR]->data[$no]->refaxis_x   = $graph->frame[$_CUR]->data[$_FSL]->refaxis_x;\
      $graph->frame[$_CUR]->data[$no]->refaxis_y   = $graph->frame[$_CUR]->data[$_FSL]->refaxis_y;\
      $graph->frame[$_CUR]->data[$no]->remakebuffer();\
      print fromplaintext($ret[1]);\
    }\
  }\
}\
",""},
endmenu;

defmenu(Memdata, "Data | Range")
{M_PLOTMEMSET_MSTART, 0, "&Start", true,
"if (edittext($graph->frame[$_CUR]->data[$_FSL]->m_start, \"start value of memory data?\"))\
{\
  $graph->frame[$_CUR]->data[$_SEL]->m_start = $_RET;\
}",
"exit $graph->frame[$_CUR]->data[$_FSL]->m_start;"},
{M_PLOTMEMSET_MEND, 0, "&End", true,
"if (edittext($graph->frame[$_CUR]->data[$_FSL]->m_end, \"end value of memory data?\"))\
{\
  $graph->frame[$_CUR]->data[$_SEL]->m_end = $_RET;\
}",
"exit $graph->frame[$_CUR]->data[$_FSL]->m_end;"},
{M_PLOTMEMSET_MDIV, 0, "&Division No.", true,
"if (edittext($graph->frame[$_CUR]->data[$_FSL]->m_div, \"division number of memory data?\"))\
{\
  $graph->frame[$_CUR]->data[$_SEL]->m_div = $_RET;\
}",
"exit $graph->frame[$_CUR]->data[$_FSL]->m_div;"},
{M_PLOTMEMSET_MSCALING, 0, "S&caling", true,
"if (selectmscaling($graph->frame[$_CUR]->data[$_FSL]->m_scaling, \"scaling of memory data?\"))\
{\
  $graph->frame[$_CUR]->data[$_SEL]->m_scaling = $_RET;\
}",
"exit $graph->getscalingname($graph->frame[$_CUR]->data[$_FSL]->m_scaling);"},
endmenu;

defmenu(Mapping, "Data | Mapping")
{M_PLOTMAPPING_TRANSX, 0, "Transformation&X", true,
"if (selectyesno($graph->frame[$_CUR]->data[$_FSL]->trans_x, \"Apply x-transformation?\"))\
{\
$graph->frame[$_CUR]->data[$_SEL]->trans_x = $_RET;\
}",
"exit yesnoname($graph->frame[$_CUR]->data[$_FSL]->trans_x);"},
{M_PLOTMAPPING_TRANSFORMX, 0, "&ScriptX", true,
"if (edittext($graph->frame[$_CUR]->data[$_FSL]->format_x, \"x-transformation script =\"))\
{\
$graph->frame[$_CUR]->data[$_SEL]->format_x = $_RET;\
}",
"exit $graph->frame[$_CUR]->data[$_FSL]->format_x;"},
{M_PLOTMAPPING_TRANSY, 0, "Transformation&Y", true,
"if (selectyesno($graph->frame[$_CUR]->data[$_FSL]->trans_y, \"Apply y-transformation?\"))\
{\
$graph->frame[$_CUR]->data[$_SEL]->trans_y = $_RET;\
}",
"exit yesnoname($graph->frame[$_CUR]->data[$_FSL]->trans_y);"},
{M_PLOTMAPPING_TRANSFORMY, 0, "S&criptY", true,
"if (edittext($graph->frame[$_CUR]->data[$_FSL]->format_y, \"y-transformation script =\"))\
{\
$graph->frame[$_CUR]->data[$_SEL]->format_y = $_RET;\
}",
"exit $graph->frame[$_CUR]->data[$_FSL]->format_y;"},
{M_PLOTMAPPING_REFAXISX, 0, "&Ref. x-axis", true,
"if (edittext($graph->frame[$_CUR]->data[$_FSL]->refaxis_x, \"Reference x-axis ID =\"))\
{\
$graph->frame[$_CUR]->data[$_SEL]->refaxis_x = $_RET;\
}",
"exit $graph->frame[$_CUR]->data[$_FSL]->refaxis_x;"},
{M_PLOTMAPPING_REFAXISY, 0, "R&ef. y-axis", true,
"if (edittext($graph->frame[$_CUR]->data[$_FSL]->refaxis_y, \"Reference y-axis ID =\"))\
{\
$graph->frame[$_CUR]->data[$_SEL]->refaxis_y = $_RET;\
}",
"exit $graph->frame[$_CUR]->data[$_FSL]->refaxis_y;"},
{M_PLOTMAPPING_CLIPPING, 0, "C&lipping", true,
"if (selectyesno($graph->frame[$_CUR]->data[$_FSL]->clipping, \"Set data clipping?\"))\
{\
$graph->frame[$_CUR]->data[$_SEL]->clipping = $_RET;\
}",
"exit yesnoname($graph->frame[$_CUR]->data[$_FSL]->clipping);"},
{M_PLOTMAPPING_DISPLAY, 0, "S&how", true,
"if (selectyesno($graph->frame[$_CUR]->data[$_FSL]->show, \"Show the data?\"))\
{\
$graph->frame[$_CUR]->data[$_SEL]->show = $_RET;\
}",
"exit yesnoname($graph->frame[$_CUR]->data[$_FSL]->show);"},
endmenu;

defmenu(Plotline, "Data | Line")
{M_PLOTLINE_STYLE, 0, "&Style", true,
"\
if (selectlinestyle($graph->frame[$_CUR]->data[$_FSL]->linestyle, \"linestyle =\"))\
{\
$graph->frame[$_CUR]->data[$_SEL]->linestyle = $_RET;\
}",
"exit $graph->getlinestylename($graph->frame[$_CUR]->data[$_FSL]->linestyle);"},
{M_PLOTLINE_WIDTH, 0, "Line&width", true,
"\
if (edittext($graph->frame[$_CUR]->data[$_FSL]->linewidth, \"linewidth =   (1/20 point)\"))\
{\
$graph->frame[$_CUR]->data[$_SEL]->linewidth = $_RET;\
}",
"exit $graph->frame[$_CUR]->data[$_FSL]->linewidth;"},
{M_PLOTLINE_COLOR, 0, "Line&color", true,\
"@a = ($graph->frame[$_CUR]->data[$_FSL]->linecolor_red,\
$graph->frame[$_CUR]->data[$_FSL]->linecolor_green,\
$graph->frame[$_CUR]->data[$_FSL]->linecolor_blue);\
$a = toscalar(@a);\
if (selectcoloritem($a, \"line color =   (r, g, b)\"))\
{\
@a = toarray($_RET);\
$graph->frame[$_CUR]->data[$_SEL]->linecolor_red = $a[0];\
$graph->frame[$_CUR]->data[$_SEL]->linecolor_green = $a[1];\
$graph->frame[$_CUR]->data[$_SEL]->linecolor_blue = $a[2];\
}",
"@a = ($graph->frame[$_CUR]->data[$_FSL]->linecolor_red,\
$graph->frame[$_CUR]->data[$_FSL]->linecolor_green,\
$graph->frame[$_CUR]->data[$_FSL]->linecolor_blue);\
exit $graph->getcolorname(@a);"},
{M_PLOTLINE_CAP, 0, "Lineca&p", true,\
"\
if (selectlinecap($graph->frame[$_CUR]->data[$_FSL]->linecap, \"linecap =\"))\
{\
$graph->frame[$_CUR]->data[$_SEL]->linecap = $_RET;\
}",\
"exit $graph->getlinecapname($graph->frame[$_CUR]->data[$_FSL]->linecap);"},
{M_PLOTLINE_JOIN, 0, "Line&join", true,\
"\
if (selectlinejoin($graph->frame[$_CUR]->data[$_FSL]->linejoin, \"linejoin =\"))\
{\
$graph->frame[$_CUR]->data[$_SEL]->linejoin = $_RET;\
}",\
"exit $graph->getlinejoinname($graph->frame[$_CUR]->data[$_FSL]->linejoin);"},
{M_PLOTLINE_INTERPOLATE, 0, "&Interpolation", true,\
"\
if (selectinterpolate($graph->frame[$_CUR]->data[$_FSL]->interpolate, \"interpolate type =\"))\
{\
$graph->frame[$_CUR]->data[$_SEL]->interpolate = $_RET;\
}",\
"exit $graph->getinterpolationname($graph->frame[$_CUR]->data[$_FSL]->interpolate);"},
{M_PLOTLINE_INTERPOLATEDIV, 0, "Intpol. di&v. No.", true,
"\
if (edittext($graph->frame[$_CUR]->data[$_FSL]->interpolatediv, \"interpolation division number =\"))\
{\
$graph->frame[$_CUR]->data[$_SEL]->interpolatediv = $_RET;\
}",
"exit $graph->frame[$_CUR]->data[$_FSL]->interpolatediv;"},
endmenu;

defmenu(Plotmarker, "Data | Marker")
{M_PLOTMARKER_STYLE, 0, "&Style", true,
"\
if (selectmarkerstyle($graph->frame[$_CUR]->data[$_FSL]->markerstyle, \"marker style =\"))\
{\
$graph->frame[$_CUR]->data[$_SEL]->markerstyle = $_RET;\
}",
"exit ($graph->getmarkertypename($graph->frame[$_CUR]->data[$_FSL]->markerstyle));"},
{M_PLOTMARKER_CENTERDOT, 0, "C&enterdot", true,
"if (selectyesno($graph->frame[$_CUR]->data[$_FSL]->markercenterdot, \"Plot marker centerdot?\"))\
{\
$graph->frame[$_CUR]->data[$_SEL]->markercenterdot = $_RET;\
}",
"exit yesnoname($graph->frame[$_CUR]->data[$_FSL]->markercenterdot);"},
{M_PLOTMARKER_SIZE, 0, "Si&ze", true,
"\
if (edittext($graph->frame[$_CUR]->data[$_FSL]->markersize, \"markersize =\"))\
{\
$graph->frame[$_CUR]->data[$_SEL]->markersize = $_RET;\
}",
"exit $graph->frame[$_CUR]->data[$_FSL]->markersize;"},
{M_PLOTMARKER_EDGEWIDTH, 0, "Edge&width", true,
"\
if (edittext($graph->frame[$_CUR]->data[$_FSL]->markeredgewidth, \"marker edge width =\"))\
{\
$graph->frame[$_CUR]->data[$_SEL]->markeredgewidth = $_RET;\
}",
"exit $graph->frame[$_CUR]->data[$_FSL]->markeredgewidth;"},
{M_PLOTMARKER_EDGELINESTYLE, 0, "E&dgestyle", true,
"\
if (selectlinestyle($graph->frame[$_CUR]->data[$_FSL]->markeredgestyle, \"marker edgestyle =\"))\
{\
$graph->frame[$_CUR]->data[$_SEL]->markeredgestyle = $_RET;\
}",
"exit ($graph->getlinestylename($graph->frame[$_CUR]->data[$_FSL]->markeredgestyle));"},
{M_PLOTMARKER_BODYSTYLE, 0, "&Bodystyle", true,
"\
if (selectfillstyle($graph->frame[$_CUR]->data[$_FSL]->markerfillstyle, \"marker bodystyle =\"))\
{\
$graph->frame[$_CUR]->data[$_SEL]->markerfillstyle = $_RET;\
}",
"exit ($graph->getfillstylename($graph->frame[$_CUR]->data[$_FSL]->markerfillstyle));"},
{M_PLOTMARKER_EDGECOLOR, 0, "Edge&color", true,\
"@a = ($graph->frame[$_CUR]->data[$_FSL]->markeredgecolor_red,\
$graph->frame[$_CUR]->data[$_FSL]->markeredgecolor_green,\
$graph->frame[$_CUR]->data[$_FSL]->markeredgecolor_blue);\
$a = toscalar(@a);\
if (selectcoloritem($a, \"Edge color =   (r, g, b)\"))\
{\
@a = toarray($_RET);\
$graph->frame[$_CUR]->data[$_SEL]->markeredgecolor_red = $a[0];\
$graph->frame[$_CUR]->data[$_SEL]->markeredgecolor_green = $a[1];\
$graph->frame[$_CUR]->data[$_SEL]->markeredgecolor_blue = $a[2];\
}",
"@a = ($graph->frame[$_CUR]->data[$_FSL]->markeredgecolor_red,\
$graph->frame[$_CUR]->data[$_FSL]->markeredgecolor_green,\
$graph->frame[$_CUR]->data[$_FSL]->markeredgecolor_blue);\
exit $graph->getcolorname(@a);"},
{M_PLOTMARKER_BODYCOLOR, 0, "Bodyc&olor", true,\
"@a = ($graph->frame[$_CUR]->data[$_FSL]->markerbodycolor_red,\
$graph->frame[$_CUR]->data[$_FSL]->markerbodycolor_green,\
$graph->frame[$_CUR]->data[$_FSL]->markerbodycolor_blue);\
$a = toscalar(@a);\
if (selectcoloritem($a, \"Body color =   (r, g, b)\"))\
{\
@a = toarray($_RET);\
$graph->frame[$_CUR]->data[$_SEL]->markerbodycolor_red = $a[0];\
$graph->frame[$_CUR]->data[$_SEL]->markerbodycolor_green = $a[1];\
$graph->frame[$_CUR]->data[$_SEL]->markerbodycolor_blue = $a[2];\
}",
"@a = ($graph->frame[$_CUR]->data[$_FSL]->markerbodycolor_red,\
$graph->frame[$_CUR]->data[$_FSL]->markerbodycolor_green,\
$graph->frame[$_CUR]->data[$_FSL]->markerbodycolor_blue);\
exit $graph->getcolorname(@a);"},
{M_PLOTMARKER_BASEVALUE, 0, "Base&value", true,
"\
if (edittext($graph->frame[$_CUR]->data[$_FSL]->basevalue, \"basevalue =\"))\
{\
$graph->frame[$_CUR]->data[$_SEL]->basevalue = $_RET;\
}",
"exit $graph->frame[$_CUR]->data[$_FSL]->basevalue;"},
endmenu;

defmenu(Loaddata, "Data | Loaddata")
{M_LOADDATA_COLX, 0, "Col-&x", true,
"\
if (edittext($graph->frame[$_CUR]->data[$_FSL]->col_x, \"column x =\"))\
{\
$graph->frame[$_CUR]->data[$_SEL]->col_x = $_RET;\
}",
"exit $graph->frame[$_CUR]->data[$_FSL]->col_x;"},
{M_LOADDATA_COLY, 0, "Col-&y", true,
"\
if (edittext($graph->frame[$_CUR]->data[$_FSL]->col_y, \"column y =\"))\
{\
$graph->frame[$_CUR]->data[$_SEL]->col_y = $_RET;\
}",
"exit $graph->frame[$_CUR]->data[$_FSL]->col_y;"},
{M_LOADDATA_READSTART, 0, "&Startline", true,
"\
if (edittext($graph->frame[$_CUR]->data[$_FSL]->readstart, \"read start line =\"))\
{\
$graph->frame[$_CUR]->data[$_SEL]->readstart = $_RET;\
}",
"exit $graph->frame[$_CUR]->data[$_FSL]->readstart;"},
{M_LOADDATA_READEND, 0, "&Endline", true,
"\
if (edittext($graph->frame[$_CUR]->data[$_FSL]->readend, \"read end line =\"))\
{\
$graph->frame[$_CUR]->data[$_SEL]->readend = $_RET;\
}",
"exit $graph->frame[$_CUR]->data[$_FSL]->readend;"},
{M_LOADDATA_READSKIP, 0, "S&kiplines", true,
"\
if (edittext($graph->frame[$_CUR]->data[$_FSL]->skip, \"Skip lines =\"))\
{\
$graph->frame[$_CUR]->data[$_SEL]->skip = $_RET;\
}",
"exit $graph->frame[$_CUR]->data[$_FSL]->skip;"},
{M_LOADDATA_COMMENTLINEACTION, 0, "&Commentline", true,
"\
if (selectcommentlineaction($graph->frame[$_CUR]->data[$_FSL]->commentlineaction, \"Action when meets the commentline =\"))\
{\
$graph->frame[$_CUR]->data[$_SEL]->commentlineaction = $_RET;\
}",
"exit $graph->getcommentlineactionname($graph->frame[$_CUR]->data[$_FSL]->commentlineaction);"},
{M_LOADDATA_SEARCHPATH, 0, "Search&path", true,
"\
if (selectdatasearchpath($graph->frame[$_CUR]->data[$_FSL]->datasearchpath, \"Data seatch path =\"))\
{\
$graph->frame[$_CUR]->data[$_SEL]->datasearchpath = $_RET;\
}",
"exit $graph->getdatasearchpathname($graph->frame[$_CUR]->data[$_FSL]->datasearchpath);"},
{M_LOADDATA_EXTRADATA, 0, "&Other data", true,
"\
if (edittext($graph->frame[$_CUR]->data[$_FSL]->extradata, \"Other data =\"))\
{\
$graph->frame[$_CUR]->data[$_SEL]->extradata = $_RET;\
}",
"exit $graph->frame[$_CUR]->data[$_FSL]->extradata;"},
{M_LOADDATA_BARXON, 0, "Error&bar-x", true,
"if (selectyesno($graph->frame[$_CUR]->data[$_FSL]->bar_x, \"Show errorbar-x?\"))\
{\
$graph->frame[$_CUR]->data[$_SEL]->bar_x = $_RET;\
}",
"exit yesnoname($graph->frame[$_CUR]->data[$_FSL]->bar_x);"},
{M_LOADDATA_BARYON, 0, "E&rrorbar-y", true,
"if (selectyesno($graph->frame[$_CUR]->data[$_FSL]->bar_y, \"Show errorbar-y?\"))\
{\
$graph->frame[$_CUR]->data[$_SEL]->bar_y = $_RET;\
}",
"exit yesnoname($graph->frame[$_CUR]->data[$_FSL]->bar_y);"},
{M_LOADDATA_COLXMIN, 0, "Col-x&min", true,
"\
if (edittext($graph->frame[$_CUR]->data[$_FSL]->col_xmin, \"column x-min =\"))\
{\
$graph->frame[$_CUR]->data[$_SEL]->col_xmin = $_RET;\
}",
"exit $graph->frame[$_CUR]->data[$_FSL]->col_xmin;"},
{M_LOADDATA_COLYMIN, 0, "Col-ym&in", true,
"\
if (edittext($graph->frame[$_CUR]->data[$_FSL]->col_ymin, \"column y-min =\"))\
{\
$graph->frame[$_CUR]->data[$_SEL]->col_ymin = $_RET;\
}",
"exit $graph->frame[$_CUR]->data[$_FSL]->col_ymin;"},
{M_LOADDATA_COLXMAX, 0, "Col-xm&ax", true,
"\
if (edittext($graph->frame[$_CUR]->data[$_FSL]->col_xmax, \"column x-max =\"))\
{\
$graph->frame[$_CUR]->data[$_SEL]->col_xmax = $_RET;\
}",
"exit $graph->frame[$_CUR]->data[$_FSL]->col_xmax;"},
{M_LOADDATA_COLYMAX, 0, "Co&l-ymax", true,
"\
if (edittext($graph->frame[$_CUR]->data[$_FSL]->col_ymax, \"column y-max =\"))\
{\
$graph->frame[$_CUR]->data[$_SEL]->col_ymax = $_RET;\
}",
"exit $graph->frame[$_CUR]->data[$_FSL]->col_ymax;"},
{M_LOADDATA_FILENAME, 0, "&Filename", true,
"\
if (selectfile(0, ''))\
{\
$graph->frame[$_CUR]->data[$_SEL]->virgin = 1;\
$graph->frame[$_CUR]->data[$_SEL]->filename = $_RET[0];\
}",
"exit $graph->frame[$_CUR]->data[$_FSL]->filename;"},
endmenu;

defmenu(DataEdit, "Edit")
{M_DATALIST, 0, "&List", true,
"\
if ($graph->frame[$_CUR]->length('data') > 0)\
{selectobject(data, 1);}\
else\
{print \"Warning!: No instance exist.\n\";}\
", ""},
{M_DATADELETE, 0, "&Delete", false,
"\
if ($graph->frame[$_CUR]->selectednumber(data) == 0)\
{\
  print \"Warning!: No instance selected.\n\";\
  exit(1);\
}\
if (selectyesno(1, 'Delete selected data?'))\
{\
  if ($_RET){\
    $len = $graph->frame[$_CUR]->length(data);\
    for ($i = $len - 1; $i >= 0; $i--)\
    {\
      if ($graph->frame[$_CUR]->data[$i]->selected)\
      {\
        $graph->frame[$_CUR]->delete(data, $i);\
      }\
    }\
  }\
}\
, """},
{M_DATACORDER, 0, "&Order", false, "\
if ($graph->frame[$_CUR]->selectednumber(data) == 1)\
{\
  if (selectorder(0, 'selected object order ='))\
  {\
     if ($_RET == 0)\
       {\
         $graph->frame[$_CUR]->top(data, $_FSL);\
       }\
     elsif ($_RET == 1)\
       {\
         $graph->frame[$_CUR]->up(data, $_FSL);\
       }\
     elsif ($_RET == 2)\
       {\
         $graph->frame[$_CUR]->down(data, $_FSL);\
       }\
     elsif ($_RET == 3)\
       {\
         $graph->frame[$_CUR]->bottom(data, $_FSL);\
       }\
  }\
}\
else\
{\
  print \"Warning!: Select one instance.\n\";\
}\
", ""},
{M_DATACLONE, 0, "&Clone", false, "\
if ($graph->frame[$_CUR]->selectednumber(data) == 1)\
{\
  if (selectyesno(1, 'Duplicate selected data object?'))\
  {\
    if ($_RET)\
    {\
      $no = $graph->frame[$_CUR]->new(data) - 1;\
      $graph->frame[$_CUR]->copy(data, $no, $_FSL);\
      $graph->frame[$_CUR]->data[$_ALL]->selected = 0;\
      $graph->frame[$_CUR]->data[$no]->selected = 1;\
    }\
  }\
}\
else\
{\
  print \"Warning!: Select one instance.\n\";\
}\
", ""},
endmenu;

defmenu(Data, "Data")
{M_DATAOPEN, 0, "&Open data", false,
"\
$len = $graph->frame[$_CUR]->length(data);\
if ($graph->init->search(dataext) == -1)\
{\
  $ext = '';\
}\
else\
{\
  $ext = $graph->init->get(dataext);\
}\
if (selectfile(1, $ext))\
{\
  $graph->frame[$_CUR]->flushselect('data');\
  $count = 0; $initno = 0;\
  foreach $i (@_RET)\
  {\
    $no = $graph->frame[$_CUR]->new(data) - 1;\
    if (execfile(\"initdata\", $graph->currentframe, $no) == 0)\
    {\
      print (\"Error!: cannot initialize data.\n\");\
    }\
    $graph->frame[$_CUR]->data[$no]->selected = 1;\
    if ($count == 0)\
    {\
       $graph->frame[$_CUR]->data[$no]->filename = $i;\
      loaddatamenu();\
      $initno = $no;\
    }\
    else\
    {\
      $graph->frame[$_CUR]->copy('data', $no, $initno);\
      $graph->frame[$_CUR]->data[$no]->filename = $i;\
    }\
    $count++;\
  }\
  print 'reading data .....   ';\
  $graph->frame[$_CUR]->data[$_SEL]->loaddata();\
  print \"done\n\";\
  if ($len == 0)\
  {\
    $graph->frame[$_CUR]->autoscale($_ALL, 10);\
  }\
}\
",
""},
{M_DATALIST, 0, "&List", true,
"\
if ($graph->frame[$_CUR]->length('data') > 0)\
{selectobject(data, 1);}\
else\
{print \"Warning!: No instance exist.\n\";}\
", ""},
{M_LOADDATA, 0, "&Reload data", true,
"\
if ($graph->frame[$_CUR]->selectednumber(data) == 0)\
{\
  print \"Warning!: No instance selected.\n\";\
  exit(1);\
}\
if ($graph->frame[$_CUR]->data[$_FSL]->isfiledata == 0)\
{\
  print \"Warning!: Memory data cannot access disk file.\n\";\
  exit(1);\
}\
loaddatamenu();\
if (selectyesno(1, \"Reload selected data?\"))\
{\
  if ($_RET)\
  {\
    print 'reading data .....   ';\
    $graph->frame[$_CUR]->data[$_SEL]->loaddata();\
    print \"done\n\";\
  }\
}\
", ""},
{M_SEP, 0, "", false, "", ""},
{M_PLOTMAPPING, 0, "&Mapping", true,
"\
if ($graph->frame[$_CUR]->selectednumber(data) == 0)\
{\
  print \"Warning!: No instance selected.\n\";\
  exit(1);\
}\
plotmappingmenu();", ""},
{M_PLOTLINE, 0, "L&ine", true,
"\
if ($graph->frame[$_CUR]->selectednumber(data) == 0)\
{\
  print \"Warning!: No instance selected.\n\";\
  exit(1);\
}\
plotlinemenu();", ""},
{M_PLOTMARKER, 0, "M&arker", true,
"\
if ($graph->frame[$_CUR]->selectednumber(data) == 0)\
{\
  print \"Warning!: No instance selected.\n\";\
  exit(1);\
}\
plotmarkermenu();", ""},
{M_PLOTMEMDATA, 0, "Ran&ge", true,
"\
if ($graph->frame[$_CUR]->selectednumber(data) == 0)\
{\
  print \"Warning!: No instance selected.\n\";\
  exit(1);\
}\
if ($graph->frame[$_CUR]->data[$_FSL]->isfiledata == 1)\
{\
  print \"Warning!: This menu is not allowed for file data.\n\";\
  exit(1);\
}\
plotrangemenu();\
$graph->frame[$_CUR]->data[$_FSL]->remakebuffer();\
", ""},
{M_SEP, 0, "", false, "", ""},
{M_DATAEDIT, DataEdit, "&Edit", false, "", ""},
{M_DATA_CREATE, Create, "Generate cur&ve", false, "", ""},
{M_DATAINFO, 0, "Show informa&tion", false, "\
if ($graph->frame[$_CUR]->selectednumber(data) == 1)\
{\
  print '######## information for dataid = ';\
  print $graph->frame[$_CUR]->data[$_FSL]->id;\
  print \" ########\n\";\
  print (fromplaintext($graph->frame[$_CUR]->data[$_FSL]->info), \"\n\");\
}\
else\
{\
  print \"Warning!: Select one instance.\n\";\
}\
", ""},
{M_DATATRACE, 0, "Tra&ce curve", false, "\
if ($graph->frame[$_CUR]->selectednumber(data) == 1)\
{\
  $len = $graph->frame[$_CUR]->length(data);\
  for ($i = 0; $i < $len; $i++)\
  {\
    if ($graph->frame[$_CUR]->data[$i]->selected)\
    {\
      trace($i);\
      break;\
    }\
  }\
}\
else\
{\
  print \"Warning!: Select one instance.\n\";\
}\
", ""},
endmenu;

/***********************************************************/
/******************* parts ********************************/
/***********************************************************/



defmenu(Partsstyle, "Parts | Style")
{M_PARTS_LINECOLOR, 0, "Line&color", true,\
"@a = ($graph->frame[$_CUR]->parts[$_FSL]->linecolor_red,\
$graph->frame[$_CUR]->parts[$_FSL]->linecolor_green,\
$graph->frame[$_CUR]->parts[$_FSL]->linecolor_blue);\
$a = toscalar(@a);\
if (selectcoloritem($a, \"Line color =   (r, g, b)\"))\
{\
@a = toarray($_RET);\
$graph->frame[$_CUR]->parts[$_SEL]->linecolor_red = $a[0];\
$graph->frame[$_CUR]->parts[$_SEL]->linecolor_green = $a[1];\
$graph->frame[$_CUR]->parts[$_SEL]->linecolor_blue = $a[2];\
}",
"@a = ($graph->frame[$_CUR]->parts[$_FSL]->linecolor_red,\
$graph->frame[$_CUR]->parts[$_FSL]->linecolor_green,\
$graph->frame[$_CUR]->parts[$_FSL]->linecolor_blue);\
exit $graph->getcolorname(@a);"},
{M_PARTS_LINEWIDTH, 0, "Line&width", true,
"\
if (edittext($graph->frame[$_CUR]->parts[$_FSL]->linewidth, \"Line width =\"))\
{\
$graph->frame[$_CUR]->parts[$_SEL]->linewidth = $_RET;\
}",
"exit $graph->frame[$_CUR]->parts[$_FSL]->linewidth;"},
{M_PARTS_LINECAP, 0, "Lineca&p", true,\
"\
if (selectlinecap($graph->frame[$_CUR]->parts[$_FSL]->linecap, \"linecap =\"))\
{\
$graph->frame[$_CUR]->parts[$_SEL]->linecap = $_RET;\
}",\
"exit $graph->getlinecapname($graph->frame[$_CUR]->parts[$_FSL]->linecap);"},
{M_PARTS_LINEJOIN, 0, "Line&join", true,\
"\
if (selectlinejoin($graph->frame[$_CUR]->parts[$_FSL]->linejoin, \"linejoin =\"))\
{\
$graph->frame[$_CUR]->parts[$_SEL]->linejoin = $_RET;\
}",\
"exit $graph->getlinejoinname($graph->frame[$_CUR]->parts[$_FSL]->linejoin);"},
{M_PARTS_LINESTYLE, 0, "Line&style", true,
"\
if (selectlinestyle($graph->frame[$_CUR]->parts[$_FSL]->linestyle, \"linestyle =\"))\
{\
$graph->frame[$_CUR]->parts[$_SEL]->linestyle = $_RET;\
}",
"exit $graph->getlinestylename($graph->frame[$_CUR]->parts[$_FSL]->linestyle);"},
{M_PARTS_BODYCOLOR, 0, "Bodyc&olor", true,\
"@a = ($graph->frame[$_CUR]->parts[$_FSL]->bodycolor_red,\
$graph->frame[$_CUR]->parts[$_FSL]->bodycolor_green,\
$graph->frame[$_CUR]->parts[$_FSL]->bodycolor_blue);\
$a = toscalar(@a);\
if (selectcoloritem($a, \"Body color =   (r, g, b)\"))\
{\
@a = toarray($_RET);\
$graph->frame[$_CUR]->parts[$_SEL]->bodycolor_red = $a[0];\
$graph->frame[$_CUR]->parts[$_SEL]->bodycolor_green = $a[1];\
$graph->frame[$_CUR]->parts[$_SEL]->bodycolor_blue = $a[2];\
}",
"@a = ($graph->frame[$_CUR]->parts[$_FSL]->bodycolor_red,\
$graph->frame[$_CUR]->parts[$_FSL]->bodycolor_green,\
$graph->frame[$_CUR]->parts[$_FSL]->bodycolor_blue);\
exit $graph->getcolorname(@a);"},
{M_PARTS_BODYFILLSTYLE, 0, "&Bodystyle", true,
"\
if (selectfillstyle($graph->frame[$_CUR]->parts[$_FSL]->bodyfillstyle, \"Bodystyle =\"))\
{\
$graph->frame[$_CUR]->parts[$_SEL]->bodyfillstyle = $_RET;\
}",
"exit ($graph->getfillstylename($graph->frame[$_CUR]->parts[$_FSL]->bodyfillstyle));"},
{M_PARTS_INTERPORATE, 0, "I&nterpolate", true,
"if (selectpartsinterpolation($graph->frame[$_CUR]->parts[$_FSL]->interpolate, \"Interpolation = \"))\
{\
$graph->frame[$_CUR]->parts[$_SEL]->interpolate = $_RET;\
}",
"exit $graph->getinterpolationname($graph->frame[$_CUR]->parts[$_FSL]->interpolate);"},
{M_PARTS_INTERPORATEDIV, 0, "Interpol.d&v", true,
"\
if (edittext($graph->frame[$_CUR]->parts[$_FSL]->interpolatediv, \"Interpolation division =\"))\
{\
$graph->frame[$_CUR]->parts[$_SEL]->interpolatediv = $_RET;\
}",
"exit $graph->frame[$_CUR]->parts[$_FSL]->interpolatediv;"},
{M_PARTS_NODES, 0, "no&des", true,
"\
$len = $graph->frame[$_CUR]->parts[$_FSL]->length(nodes);\
@nodes = 0;\
for ($i = 0; $i < $len; $i++)\
{\
  $x = $graph->frame[$_CUR]->parts[$_FSL]->node_x[$i];\
  $y = $graph->frame[$_CUR]->parts[$_FSL]->node_y[$i];\
  @nodes ,= ($x, $y);\
}\
$nodes = toscalar(@nodes);\
if (edittext($nodes, \"nodes ... , xi, yi, ... =\"))\
{\
  @nodes = toarray($_RET);\
  $len = @nodes;\
  if ($len % 2 == 0)\
  {\
    $graph->frame[$_CUR]->parts[$_SEL]->flushnode();\
    for ($i = 0; $i < $len / 2; $i++)\
    {\
      $graph->frame[$_CUR]->parts[$_SEL]->addnodepoint($nodes[2 * $i], $nodes[2 * $i + 1]);\
    }\
  }\
}",
"\
$len = $graph->frame[$_CUR]->parts[$_FSL]->length(nodes);\
@nodes = 0;\
for ($i = 0; $i < $len; $i++)\
{\
  $x = $graph->frame[$_CUR]->parts[$_FSL]->node_x[$i];\
  $y = $graph->frame[$_CUR]->parts[$_FSL]->node_y[$i];\
  @nodes ,= ($x, $y);\
}\
$nodes = toscalar(@nodes);\
exit $nodes;\
;"},
{M_PARTS_P1_X, 0, "x1", true,
"\
if (edittext($graph->frame[$_CUR]->parts[$_FSL]->x1, \"x1 =\"))\
{\
$graph->frame[$_CUR]->parts[$_SEL]->x1 = $_RET;\
}",
"exit $graph->frame[$_CUR]->parts[$_FSL]->x1;"},
{M_PARTS_P1_Y, 0, "y1", true,
"\
if (edittext($graph->frame[$_CUR]->parts[$_FSL]->y1, \"y1 =\"))\
{\
$graph->frame[$_CUR]->parts[$_SEL]->y1 = $_RET;\
}",
"exit $graph->frame[$_CUR]->parts[$_FSL]->y1;"},
{M_PARTS_P2_X, 0, "x2", true,
"\
if (edittext($graph->frame[$_CUR]->parts[$_FSL]->x2, \"x2 =\"))\
{\
$graph->frame[$_CUR]->parts[$_SEL]->x2 = $_RET;\
}",
"exit $graph->frame[$_CUR]->parts[$_FSL]->x2;"},
{M_PARTS_P1_Y, 0, "y2", true,
"\
if (edittext($graph->frame[$_CUR]->parts[$_FSL]->y2, \"y2 =\"))\
{\
$graph->frame[$_CUR]->parts[$_SEL]->y2 = $_RET;\
}",
"exit $graph->frame[$_CUR]->parts[$_FSL]->y2;"},
{M_PARTS_P1ARROW, 0, "&Arrow1", true,
"if (selectyesno($graph->frame[$_CUR]->parts[$_FSL]->arrow1, \"Add arrow at point1?\"))\
{\
$graph->frame[$_CUR]->parts[$_SEL]->arrow1 = $_RET;\
}",
"exit yesnoname($graph->frame[$_CUR]->parts[$_FSL]->arrow1);"},
{M_PARTS_P2ARROW, 0, "A&rrow2", true,
"if (selectyesno($graph->frame[$_CUR]->parts[$_FSL]->arrow2, \"Add arrow at point2?\"))\
{\
$graph->frame[$_CUR]->parts[$_SEL]->arrow2 = $_RET;\
}",
"exit yesnoname($graph->frame[$_CUR]->parts[$_FSL]->arrow2);"},
{M_PARTS_ARROWLENGTH, 0, "arrowleng&th", true,
"\
if (edittext($graph->frame[$_CUR]->parts[$_FSL]->arrowlength, \"arrowlength =\"))\
{\
$graph->frame[$_CUR]->parts[$_SEL]->arrowlength = $_RET;\
}",
"exit $graph->frame[$_CUR]->parts[$_FSL]->arrowlength;"},
{M_PARTS_ARROWHALFANGLE, 0, "arrowHang&le", true,
"\
if (edittext($graph->frame[$_CUR]->parts[$_FSL]->arrowhalfangle, \"arrowhalfangle = (deg)\"))\
{\
$graph->frame[$_CUR]->parts[$_SEL]->arrowhalfangle = $_RET;\
}",
"exit $graph->frame[$_CUR]->parts[$_FSL]->arrowhalfangle;"},
endmenu;

defmenu(Textstyle, "Parts | Style (text)")
{M_PARTS_TEXT, 0, "&Text", true,
"\
if (edittext($graph->frame[$_CUR]->parts[$_FSL]->text, \"Text =\"))\
{\
$graph->frame[$_CUR]->parts[$_SEL]->text = $_RET;\
}",
"exit $graph->frame[$_CUR]->parts[$_FSL]->text;"},
{M_PARTS_FONTSIZE, 0, "Font&size", true,
"\
if (edittext($graph->frame[$_CUR]->parts[$_FSL]->fontsize, \"Font size =\"))\
{\
$graph->frame[$_CUR]->parts[$_SEL]->fontsize = $_RET;\
}",
"exit $graph->frame[$_CUR]->parts[$_FSL]->fontsize;"},
{M_PARTS_FONTFACE, 0, "&Fontface", true,
"\
if (selectfontface($graph->frame[$_CUR]->parts[$_FSL]->fontface, \"Font =\"))\
{\
$graph->frame[$_CUR]->parts[$_SEL]->fontface = $_RET;\
}",
"exit $graph->gettextfacename($graph->frame[$_CUR]->parts[$_FSL]->fontface);"},
{M_PARTS_JPFONTFACE, 0, "&Jp-fontface", true,
"\
if (selectjpfontface($graph->frame[$_CUR]->parts[$_FSL]->jpfontface, \"Jp-font =\"))\
{\
$graph->frame[$_CUR]->parts[$_SEL]->jpfontface = $_RET;\
}",
"exit $graph->gettextjpfacename($graph->frame[$_CUR]->parts[$_FSL]->jpfontface);"},
{M_PARTS_FONTANGLE, 0, "Font&angle", true,
"\
if (edittext($graph->frame[$_CUR]->parts[$_FSL]->fontangle, \"Font angle =\"))\
{\
$graph->frame[$_CUR]->parts[$_SEL]->fontangle = $_RET;\
}",
"exit $graph->frame[$_CUR]->parts[$_FSL]->fontangle;"},
{M_PARTS_FONTCOLOR, 0, "Font&color", true,\
"@a = ($graph->frame[$_CUR]->parts[$_FSL]->fontcolor_red,\
$graph->frame[$_CUR]->parts[$_FSL]->fontcolor_green,\
$graph->frame[$_CUR]->parts[$_FSL]->fontcolor_blue);\
$a = toscalar(@a);\
if (selectcoloritem($a, \"Line color =   (r, g, b)\"))\
{\
@a = toarray($_RET);\
$graph->frame[$_CUR]->parts[$_SEL]->fontcolor_red = $a[0];\
$graph->frame[$_CUR]->parts[$_SEL]->fontcolor_green = $a[1];\
$graph->frame[$_CUR]->parts[$_SEL]->fontcolor_blue = $a[2];\
}",
"@a = ($graph->frame[$_CUR]->parts[$_FSL]->fontcolor_red,\
$graph->frame[$_CUR]->parts[$_FSL]->fontcolor_green,\
$graph->frame[$_CUR]->parts[$_FSL]->fontcolor_blue);\
exit $graph->getcolorname(@a);"},
{M_PARTS_LINESPACE, 0, "L&inespace", true,
"\
if (edittext($graph->frame[$_CUR]->parts[$_FSL]->linespacing, \"Line spacing =\"))\
{\
$graph->frame[$_CUR]->parts[$_SEL]->linespacing = $_RET;\
}",
"exit $graph->frame[$_CUR]->parts[$_FSL]->linespacing;"},
{M_PARTS_LEGENDLENGTH, 0, "Legendsi&ze", true,
"\
if (edittext($graph->frame[$_CUR]->parts[$_FSL]->legendlength, \"Legend length =\"))\
{\
$graph->frame[$_CUR]->parts[$_SEL]->legendlength = $_RET;\
}",
"exit $graph->frame[$_CUR]->parts[$_FSL]->legendlength;"},
{M_PARTS_P1_X, 0, "&x1", true,
"\
if (edittext($graph->frame[$_CUR]->parts[$_FSL]->x1, \"x1 =\"))\
{\
$graph->frame[$_CUR]->parts[$_SEL]->x1 = $_RET;\
}",
"exit $graph->frame[$_CUR]->parts[$_FSL]->x1;"},
{M_PARTS_P1_Y, 0, "&y1", true,
"\
if (edittext($graph->frame[$_CUR]->parts[$_FSL]->y1, \"y1 =\"))\
{\
$graph->frame[$_CUR]->parts[$_SEL]->y1 = $_RET;\
}",
"exit $graph->frame[$_CUR]->parts[$_FSL]->y1;"},
endmenu;

defmenu(Parts, "Parts")
{M_PARTS_INPUT, 0, "&Add", true,
"\
if (selectpartstype(0, 'Select a new parts type.'))\
{\
$parts = $_RET;\
$graph->frame[$_CUR]->flushselect('parts');\
  if ($parts == 0)\
  {\
    $name = 'text';\
    $no = $graph->frame[$_CUR]->new(parts, $name) - 1;\
    if (execfile(\"initparts\", $graph->currentframe, $no) == 0)\
    {\
      print (\"Error!: cannot initialize parts.\n\");\
    }\
    $graph->frame[$_CUR]->parts[$no]->selected = 1;\
    textstylemenu();\
    @r = @graph->frame[$_CUR]->parts[$no]->bbox();\
    @ir = @r;\
    if (objectmove(@r))\
    {\
      $graph->frame[$_CUR]->parts[$no]->x1 \
        += $graph->frame[$_CUR]->vtow_x($_RET[0])\
        - $graph->frame[$_CUR]->vtow_x($ir[0]);\
      $graph->frame[$_CUR]->parts[$no]->y1 \
        += $graph->frame[$_CUR]->vtow_y($_RET[1])\
        - $graph->frame[$_CUR]->vtow_y($ir[1]);\
      $graph->frame[$_CUR]->parts[$no]->x2 \
        += $graph->frame[$_CUR]->vtow_x($_RET[2]) \
        - $graph->frame[$_CUR]->vtow_x($ir[2]);\
      $graph->frame[$_CUR]->parts[$no]->y2 \
        += $graph->frame[$_CUR]->vtow_y($_RET[3]) \
        - $graph->frame[$_CUR]->vtow_y($ir[3]);\
     }\
    exit(1);\
  }\
  elsif ($parts == 1){$name = 'line';}\
  elsif ($parts == 2){$name = 'polyline';}\
  elsif ($parts == 3){$name = 'rectangle';}\
  elsif ($parts == 4){$name = 'ellipse';}\
  elsif ($parts == 5){$name = 'cutline';}\
  elsif ($parts == 6)\
  {\
    print('scanning data .....    ');\
    $txt = '';\
    $datalen = $graph->frame[$_CUR]->length('data');\
    for ($i = 0; $i < $datalen; $i++)\
    {\
      $flag = 0;\
      for ($j = 0; $j < $i; $j++)\
      {\
        if ($graph->frame[$_CUR]->data[$i]->show && $graph->frame[$_CUR]->data[$j]->show)\
	{\
         if (\
             $graph->frame[$_CUR]->data[$i]->linecolor_red   ==  $graph->frame[$_CUR]->data[$j]->linecolor_red && \
             $graph->frame[$_CUR]->data[$i]->linecolor_green ==  $graph->frame[$_CUR]->data[$j]->linecolor_green && \
             $graph->frame[$_CUR]->data[$i]->linecolor_blue ==  $graph->frame[$_CUR]->data[$j]->linecolor_blue && \
             $graph->frame[$_CUR]->data[$i]->markeredgecolor_red   ==  $graph->frame[$_CUR]->data[$j]->markeredgecolor_red && \
             $graph->frame[$_CUR]->data[$i]->markeredgecolor_green ==  $graph->frame[$_CUR]->data[$j]->markeredgecolor_green && \
             $graph->frame[$_CUR]->data[$i]->markeredgecolor_blue ==  $graph->frame[$_CUR]->data[$j]->markeredgecolor_blue && \
             $graph->frame[$_CUR]->data[$i]->markerbodycolor_red   ==  $graph->frame[$_CUR]->data[$j]->markerbodycolor_red && \
             $graph->frame[$_CUR]->data[$i]->markerbodycolor_green ==  $graph->frame[$_CUR]->data[$j]->markerbodycolor_green && \
             $graph->frame[$_CUR]->data[$i]->markerbodycolor_blue ==  $graph->frame[$_CUR]->data[$j]->markerbodycolor_blue && \
             $graph->frame[$_CUR]->data[$i]->linewidth ==  $graph->frame[$_CUR]->data[$j]->linewidth && \
             $graph->frame[$_CUR]->data[$i]->linecap ==  $graph->frame[$_CUR]->data[$j]->linecap && \
             $graph->frame[$_CUR]->data[$i]->linejoin ==  $graph->frame[$_CUR]->data[$j]->linejoin && \
             $graph->frame[$_CUR]->data[$i]->linestyle ==  $graph->frame[$_CUR]->data[$j]->linestyle && \
             $graph->frame[$_CUR]->data[$i]->markeredgewidth ==  $graph->frame[$_CUR]->data[$j]->markeredgewidth && \
             $graph->frame[$_CUR]->data[$i]->markeredgecap ==  $graph->frame[$_CUR]->data[$j]->markeredgecap && \
             $graph->frame[$_CUR]->data[$i]->markeredgejoin ==  $graph->frame[$_CUR]->data[$j]->markeredgejoin && \
             $graph->frame[$_CUR]->data[$i]->markeredgestyle ==  $graph->frame[$_CUR]->data[$j]->markeredgestyle && \
             $graph->frame[$_CUR]->data[$i]->markerfillstyle ==  $graph->frame[$_CUR]->data[$j]->markerfillstyle && \
             $graph->frame[$_CUR]->data[$i]->markerfillrule ==  $graph->frame[$_CUR]->data[$j]->markerfillrule && \
             $graph->frame[$_CUR]->data[$i]->markerstyle ==  $graph->frame[$_CUR]->data[$j]->markerstyle && \
             $graph->frame[$_CUR]->data[$i]->markercenterdot ==  $graph->frame[$_CUR]->data[$j]->markercenterdot && \
             $graph->frame[$_CUR]->data[$i]->markersize ==  $graph->frame[$_CUR]->data[$j]->markersize\
            )\
         {\
           $flag = 1;\
         }\
        }\
        elsif (!$graph->frame[$_CUR]->data[$i]->show)\
	{ $flag = 1;}\
      }\
      if ($flag == 0)\
      {\
	 if ($graph->frame[$_CUR]->data[$i]->id < 10)\
         {\
            $dataid = '00' . $graph->frame[$_CUR]->data[$i]->id;\
	 }\
	 elsif ($graph->frame[$_CUR]->data[$i]->id < 100)\
         {\
            $dataid = '0' . $graph->frame[$_CUR]->data[$i]->id;\
	 }\
	 else\
         {\
            $dataid = $graph->frame[$_CUR]->data[$i]->id;\
	 }\
         $dataname = toplainfilename($graph->frame[$_CUR]->data[$i]->filename);\
         $txt .= \"#p${dataid}${dataname}\\\\n\";\
      }\
    }\
    $txt = chop($txt);\
    $txt = chop($txt);\
    $name = 'text';\
    $no = $graph->frame[$_CUR]->new(parts, $name) - 1;\
    if (execfile(\"initparts\", $graph->currentframe, $no) == 0)\
    {\
      print (\"Error!: cannot initialize parts.\n\");\
    }\
    $graph->frame[$_CUR]->parts[$no]->selected = 1;\
    $graph->frame[$_CUR]->parts[$no]->text = $txt;\
    print(\"done\n\");\
    textstylemenu();\
    @r = @graph->frame[$_CUR]->parts[$no]->bbox();\
    @ir = @r;\
    if (objectmove(@r))\
    {\
      $graph->frame[$_CUR]->parts[$no]->x1 \
        += $graph->frame[$_CUR]->vtow_x($_RET[0])\
        - $graph->frame[$_CUR]->vtow_x($ir[0]);\
      $graph->frame[$_CUR]->parts[$no]->y1 \
        += $graph->frame[$_CUR]->vtow_y($_RET[1])\
        - $graph->frame[$_CUR]->vtow_y($ir[1]);\
      $graph->frame[$_CUR]->parts[$no]->x2 \
        += $graph->frame[$_CUR]->vtow_x($_RET[2]) \
        - $graph->frame[$_CUR]->vtow_x($ir[2]);\
      $graph->frame[$_CUR]->parts[$no]->y2 \
        += $graph->frame[$_CUR]->vtow_y($_RET[3]) \
        - $graph->frame[$_CUR]->vtow_y($ir[3]);\
     }\
    exit(1);\
  }\
  else {exit 0;}\
  if ($parts != 0)\
  {\
    if (inputparts($parts, 0))\
      {\
	 $no = $graph->frame[$_CUR]->new(parts, $name);\
         if (execfile(\"initparts\", $graph->currentframe, $no - 1) == 0)\
         {\
           print (\"Error!: cannot initialize parts.\n\");\
         }\
         $graph->frame[$_CUR]->parts[$_ALL]->selected = 0;\
         $graph->frame[$_CUR]->parts[$no - 1]->selected = 1;\
         if ($parts == 2)\
         {\
            $len = @_RET; $len /= 2;\
            $graph->frame[$_CUR]->parts[$no - 1]->flushnode();\
            for ($i = 0; $i < $len; $i++)\
            {\
              $graph->frame[$_CUR]->parts[$no - 1]->addnodepoint(\
              $graph->frame[$_CUR]->vtow_x($_RET[2 * $i]) - $graph->frame[$_CUR]->parts[$no - 1]->x1,\
              $graph->frame[$_CUR]->vtow_y($_RET[2 * $i + 1]) - $graph->frame[$_CUR]->parts[$no - 1]->y1);\
            }\
         }\
         else\
         {\
            $graph->frame[$_CUR]->parts[$no - 1]->x1 = $graph->frame[$_CUR]->vtow_x($_RET[0]);\
            $graph->frame[$_CUR]->parts[$no - 1]->y1 = $graph->frame[$_CUR]->vtow_y($_RET[1]);\
            $graph->frame[$_CUR]->parts[$no - 1]->x2 = $graph->frame[$_CUR]->vtow_x($_RET[2]);\
            $graph->frame[$_CUR]->parts[$no - 1]->y2 = $graph->frame[$_CUR]->vtow_y($_RET[3]);\
         }\
      }\
  }\
}\
", ""},
{M_PARTSLIST, 0, "&List", true,
"\
if ($graph->frame[$_CUR]->length('parts') > 0)\
{selectobject(parts, 1);}\
else\
{print \"Warning!: No instance exist.\n\";}\
", ""},
{M_PARTS_STYLE, 0, "&Style", true,
"\
if ($graph->frame[$_CUR]->selectednumber(parts) == 0)\
{\
  print \"Warning!: No instance selected.\n\";\
  exit(1);\
}\
if ($graph->frame[$_CUR]->parts[$_FSL]->type == 0)\
{\
   textstylemenu();\
}\
else\
{\
   partsstylemenu();\
}\
", ""},
{M_SEP, 0, "", false, "", ""},
{M_PARTS_DEL, 0, "&Delete", false,
"\
if ($graph->frame[$_CUR]->selectednumber(parts) == 0)\
{\
  print \"Warning!: No instance selected.\n\";\
  exit(1);\
}\
if (selectyesno(1, 'Delete selected parts objects?')){\
  if ($_RET){\
    $graph->frame[$_CUR]->delete(parts, $_SEL);\
  }\
}", ""},
{M_PARTS_MOVE, 0, "&Move", true,
"\
if ($graph->frame[$_CUR]->selectednumber(parts) == 0)\
{\
  print \"Warning!: No instance selected.\n\";\
  exit(1);\
}\
@sp = 0;\
for ($i = 0; $i < $graph->frame[$_CUR]->length(parts); $i++)\
{\
  if ($graph->frame[$_CUR]->parts[$i]->selected)\
  {\
    @rect = @graph->frame[$_CUR]->parts[$i]->bbox();\
    @sp ,= @rect;\
  }\
}\
@initsp = @sp;\
if (!objectmove(@sp))\
{exit(1);}\
@sp = @_RET;\
$count = 0;\
for ($i = 0; $i < $graph->frame[$_CUR]->length(parts); $i++)\
{\
  if ($graph->frame[$_CUR]->parts[$i]->selected)\
  {\
    $graph->frame[$_CUR]->parts[$i]->x1 \
      += $graph->frame[$_CUR]->vtow_x($sp[4 * $count + 0])\
      - $graph->frame[$_CUR]->vtow_x($initsp[4 * $count + 0]);\
    $graph->frame[$_CUR]->parts[$i]->y1 \
      += $graph->frame[$_CUR]->vtow_y($sp[4 * $count + 1])\
      - $graph->frame[$_CUR]->vtow_y($initsp[4 * $count + 1]);\
    $graph->frame[$_CUR]->parts[$i]->x2 \
      += $graph->frame[$_CUR]->vtow_x($sp[4 * $count + 2]) \
      - $graph->frame[$_CUR]->vtow_x($initsp[4 * $count + 2]);\
    $graph->frame[$_CUR]->parts[$i]->y2 \
      += $graph->frame[$_CUR]->vtow_y($sp[4 * $count + 3]) \
      - $graph->frame[$_CUR]->vtow_y($initsp[4 * $count + 3]);\
    $count++;\
  }\
}\
", ""},
{M_PARTS_MOVENODES, 0, "Change &node", true,
"\
if ($graph->frame[$_CUR]->selectednumber(parts) != 1)\
{\
  print \"Warning!: Select one instance.\n\";\
  exit(1);\
}\
@nodes = 0;\
$obj = $graph->frame[$_CUR]->parts[$_FSL]->type;\
$inter = $graph->frame[$_CUR]->parts[$_FSL]->interpolate;\
if ($obj == 1)\
{\
  @nodes ,= ($graph->frame[$_CUR]->wtov_x($graph->frame[$_CUR]->parts[$_FSL]->x1),\
             $graph->frame[$_CUR]->wtov_y($graph->frame[$_CUR]->parts[$_FSL]->y1));\
  @nodes ,= ($graph->frame[$_CUR]->wtov_x($graph->frame[$_CUR]->parts[$_FSL]->x2),\
             $graph->frame[$_CUR]->wtov_y($graph->frame[$_CUR]->parts[$_FSL]->y2));\
}\
elsif ($obj == 2)\
{\
  $len = $graph->frame[$_CUR]->parts[$_FSL]->length(nodes);\
  for ($i = 0; $i < $len; $i++)\
  {\
    @nodes ,= ($graph->frame[$_CUR]->wtov_x($graph->frame[$_CUR]->parts[$_FSL]->node_x[$i]\
               + $graph->frame[$_CUR]->parts[$_FSL]->x1),\
               $graph->frame[$_CUR]->wtov_y($graph->frame[$_CUR]->parts[$_FSL]->node_y[$i]\
               + $graph->frame[$_CUR]->parts[$_FSL]->y1));\
  }\
}\
elsif ($obj == 3 || $obj == 4 || $obj == 5)\
{\
  @nodes ,= ($graph->frame[$_CUR]->wtov_x($graph->frame[$_CUR]->parts[$_FSL]->x1),\
             $graph->frame[$_CUR]->wtov_y($graph->frame[$_CUR]->parts[$_FSL]->y1));\
  @nodes ,= ($graph->frame[$_CUR]->wtov_x($graph->frame[$_CUR]->parts[$_FSL]->x2),\
             $graph->frame[$_CUR]->wtov_y($graph->frame[$_CUR]->parts[$_FSL]->y2));\
}\
else\
{\
  exit 0;\
}\
if (changenodes(@nodes, $obj, $inter))\
{\
  if ($obj == 1)\
  {\
    $graph->frame[$_CUR]->parts[$_SEL]->x1 = $graph->frame[$_CUR]->vtow_x($_RET[0]);\
    $graph->frame[$_CUR]->parts[$_SEL]->y1 = $graph->frame[$_CUR]->vtow_y($_RET[1]);\
    $graph->frame[$_CUR]->parts[$_SEL]->x2 = $graph->frame[$_CUR]->vtow_x($_RET[2]);\
   $graph->frame[$_CUR]->parts[$_SEL]->y2 = $graph->frame[$_CUR]->vtow_y($_RET[3]);\
  }\
  elsif ($obj == 2)\
  {\
    $len = @_RET; $len /= 2;\
    $graph->frame[$_CUR]->parts[$_SEL]->flushnode();\
    for ($i = 0; $i < $len; $i++)\
    {\
      $graph->frame[$_CUR]->parts[$_SEL]->addnodepoint(\
      $graph->frame[$_CUR]->vtow_x($_RET[2 * $i]) - $graph->frame[$_CUR]->parts[$_FSL]->x1,\
      $graph->frame[$_CUR]->vtow_y($_RET[2 * $i + 1]) - $graph->frame[$_CUR]->parts[$_FSL]->y1);\
    }\
  }\
  elsif ($obj == 3 || $obj == 4 || $obj == 5)\
  {\
    $graph->frame[$_CUR]->parts[$_SEL]->x1 = $graph->frame[$_CUR]->vtow_x($_RET[0]);\
    $graph->frame[$_CUR]->parts[$_SEL]->y1 = $graph->frame[$_CUR]->vtow_y($_RET[1]);\
    $graph->frame[$_CUR]->parts[$_SEL]->x2 = $graph->frame[$_CUR]->vtow_x($_RET[2]);\
    $graph->frame[$_CUR]->parts[$_SEL]->y2 = $graph->frame[$_CUR]->vtow_y($_RET[3]);\
  }\
}\
", ""},
{M_PARTSORDER, 0, "&Order", false, "\
if ($graph->frame[$_CUR]->selectednumber(parts) == 1)\
{\
  if (selectorder(0, 'selected object order ='))\
  {\
     if ($_RET == 0)\
       {\
         $graph->frame[$_CUR]->top(parts, $_FSL);\
       }\
     elsif ($_RET == 1)\
       {\
         $graph->frame[$_CUR]->up(parts, $_FSL);\
       }\
     elsif ($_RET == 2)\
       {\
         $graph->frame[$_CUR]->down(parts, $_FSL);\
       }\
     elsif ($_RET == 3)\
       {\
         $graph->frame[$_CUR]->bottom(parts, $_FSL);\
       }\
  }\
}\
else\
{\
  print \"Warning!: Select one instance.\n\";\
}\
", ""},
{M_PARTSCLONE, 0, "&Clone", false,
"if ($graph->frame[$_CUR]->selectednumber(parts) == 1)\
{\
  if (selectyesno(1, 'Duplicate selected parts object?'))\
  {\
    if ($_RET)\
    {\
      $no = $graph->frame[$_CUR]->new(parts, $graph->frame[$_CUR]->parts[$_FSL]->type) - 1;\
      $graph->frame[$_CUR]->copy(parts, $no, $_FSL);\
      $graph->frame[$_CUR]->parts[$_ALL]->selected = 0;\
      $graph->frame[$_CUR]->parts[$no]->selected = 1;\
    }\
  }\
}\
else\
{\
  print \"Warning!: Select one instance.\n\";\
}\
", ""},
endmenu;


defmenu(Main, "")
{M_FILE, File, "&File", false, "", ""},
{M_AXIS, Axis, "&Axis", false, "", ""},
{M_DATA, Data, "&Data", false, "", ""},
{M_PARTS, Parts, "&Parts", false, "", ""},
{M_WINDOW, Viewer, "&Window", false, "", ""},
{M_MACRO, Macro, "&Macro", false, "", ""},
endmenu;


/* color selection */
defmenu(Color, "color")
{C_BLACK, 0, "&Black", false, "0,0,0", ""},
{0, 0, "&Gray", false, "32768,32768,32768", ""},
{C_WHITE, 0, "&White", false, "65535,65535,65535", ""},
{C_RED, 0, "&Red", false, "65535,0,0", ""},
{C_GREEN, 0, "Gr&een", false, "0,65535,0", ""},
{C_BLUE, 0, "B&lue", false, "0,0,65535", ""},
{0, 0, "&Yellow", false, "65535,65535,0", ""},
{0, 0, "&Magenta", false, "65535,0,65535", ""},
{0, 0, "&Cyan", false, "0,65535,65535", ""},
{0, 0, "L-Yellow", false, "65535,65535,32768", ""},
{0, 0, "L-Magenta", false, "65535,32768,65535", ""},
{0, 0, "L-Cyan", false, "32768,65535,65535", ""},
{0, 0, "L-Red", false, "65535,32768,32768", ""},
{0, 0, "L-Green", false, "32768,65535,32768", ""},
{0, 0, "L-Blue", false, "32768,32768,65535", ""},
{0, 0, "Orange", false, "65535,32768,0", ""},
{0, 0, "Wine", false, "65535,0,32768", ""},
{0, 0, "D-Yellow", false, "32768,32768,0", ""},
{0, 0, "D-Magenta", false, "32768,0,32768", ""},
{0, 0, "D-Cyan", false, "0,32768,32768", ""},
{0, 0, "D-Red", false, "32768,0,0", ""},
{0, 0, "D-Green", false, "0,32768,0", ""},
{0, 0, "D-Blue", false, "0,0,32768", ""},
{C_OTHERS, (CUIMENU *)1, "&Others", false, "", ""},
endmenu;

/* color selection */
defmenu(Yesno, "yesno")
{A_YES, 0, "&Yes", false, "1", ""},
{A_NO, 0, "&No", false, "0", ""},
endmenu;

/* frametype selection */
defmenu(Frametype, "frametype")
{FRAMETYPE_BOX, 0, "&Box", false, "0", ""},
{FRAMETYPE_XY, 0, "&X-Y", false, "1", ""},
{FRAMETYPE_IND, 0, "&Individual", false, "2", ""},
endmenu;

/* tick direction */
defmenu(Tickdir, "tickdirection")
{TICK_NULL, 0, "&Null", false, "0", ""},
{TICK_IN, 0, "&In", false, "1", ""},
{TICK_OUT, 0, "&Out", false, "2", ""},
{TICK_BOTH, 0, "&Both", false, "3", ""},
endmenu;

/* scaling */
defmenu(Scaling, "scaling")
{SCALING_LINEAR, 0, "&Linear", false, "0", ""},
{SCALING_LOG, 0, "L&og", false, "1", ""},
{SCALING_INV, 0, "&Inv", false, "2", ""},
{SCALING_LOGLINEAR, 0, "Lo&g(linear)", false, "3", ""},
{SCALING_INVLINEAR, 0, "I&nv(linear)", false, "4", ""},
endmenu;

/* linecap */
defmenu(Linecap, "linecap")
{LINECAP_BUTT, 0, "&Butt", false, "0", ""},
{LINECAP_ROUND, 0, "&Round", false, "1", ""},
{LINECAP_PROJECTING, 0, "&Projecting", false, "2", ""},
endmenu;

/* linejoin */
defmenu(Linejoin, "linejoin")
{LINEJOIN_MITER, 0, "&Miter", false, "0", ""},
{LINEJOIN_ROUND, 0, "&Round", false, "1", ""},
{LINEJOIN_BEVEL, 0, "&Bevel", false, "2", ""},
endmenu;

/* linestyle */
defmenu(Linestyle, "linestyle")
{LINESTYLE_SOLID, 0, "&Solid", false, "0", ""},
{LINESTYLE_DASH, 0, "&Dash", false, "1", ""},
{LINESTYLE_LONGDASH, 0, "&Longdash", false, "2", ""},
{LINESTYLE_SHORTDASH, 0, "S&hortdash", false, "3", ""},
{LINESTYLE_DASHDOTDASH, 0, "&-*-", false, "4", ""},
{LINESTYLE_DASHDOTDOTDASH, 0, "-&**-", false, "5", ""},
{LINESTYLE_DOT, 0, "D&ot", false, "6", ""},
{LINESTYLE_NULL, 0, "&Null", false, "7", ""},
endmenu;

/* fillstyle */
defmenu(Fillstyle, "fillstyle")
{FILLSTYLE_SOLID, 0, "&Solid", false, "0", ""},
{FILLSTYLE_NULL, 0, "&Null", false, "1", ""},
endmenu;

/* fillrule */
defmenu(Fillrule, "fillrule")
{FILLRULE_EVENODD, 0, "&Evenodd", false, "0", ""},
{FILLRULE_WINDING, 0, "&Winding", false, "1", ""},
endmenu;

/* interpolate */
defmenu(Interpolate, "interpolate")
{INTER_POLYLINE, 0, "&Polyline", false, "0", ""},
{INTER_CLOSEDPOLYLINE, 0, "&C-poly", false, "1", ""},
{INTER_SPLINE, 0, "&Spline", false, "2", ""},
{INTER_PSPLINE, 0, "Psp&line", false, "3", ""},
{INTER_CLOSEDPSPLINE, 0, "C-Pspl&ine", false, "4", ""},
{INTER_BSPLINE, 0, "&Bspline", false, "5", ""},
{INTER_CLOSEDBSPLINE, 0, "C-Bspli&ne", false, "6", ""},
endmenu;

/* markerstyle */
defmenu(Markerstyle, "markerstyle")
{MARKER_NULL, 0, "&Null", false, "0", ""},
{MARKER_SQUARE, 0, "&Square", false, "1", ""},
{MARKER_TRIANGLE, 0, "&Triangle", false, "2", ""},
{MARKER_REVTRIANGLE, 0, "&Rev. tri.", false, "3", ""},
{MARKER_DIAMOND, 0, "&Diamond", false, "4", ""},
{MARKER_CIRCLE, 0, "&Circle", false, "5", ""},
{MARKER_CROSS, 0, "Cr&oss", false, "6", ""},
{MARKER_DCROSS, 0, "Dia&g. cross", false, "7", ""},
{MARKER_VAREA, 0, "&V-area", false, "8", ""},
{MARKER_HAREA, 0, "&H-area", false, "9", ""},
{MARKER_VBAR, 0, "V-bar", false, "10", ""},
{MARKER_HBAR, 0, "H-bar", false, "11", ""},
{MARKER_VSTEP, 0, "V-step", false, "12", ""},
{MARKER_HSTEP, 0, "H-step", false, "13", ""},
{MARKER_VBAR2, 0, "V-bar2", false, "14", ""},
{MARKER_HBAR2, 0, "H-bar2", false, "15", ""},
endmenu;

/* commentlineaction */
defmenu(Commentlineaction, "commentlineaction")
{M_COMMENT_ABORT, 0, "&Abort", false, "0", ""},
{M_COMMENT_IGNORE, 0, "&Ignore", false, "1", ""},
{M_COMMENT_SEPARTION, 0, "&Separation", false, "2", ""},
endmenu;


/* Datasearchpath */
defmenu(Datasearchpath, "Datasearchpath")
{M_PATH_ABSOLUTE, 0, "&Absolute", false, "0", ""},
{M_PATH_RELATIVE, 0, "&Relative", false, "1", ""},
endmenu;

/* partstype */
defmenu(Partstype, "Partsstyle")
{M_PARTS_TYPE_TEXT, 0, "&Text", false, "0", ""},
{M_PARTS_TYPE_LINE, 0, "&Line", false, "1", ""},
{M_PARTS_TYPE_POLYLINE, 0, "&Polyline", false, "2", ""},
{M_PARTS_TYPE_RECTANGLE, 0, "&Rectangle", false, "3", ""},
{M_PARTS_TYPE_ELLIPSE, 0, "&Ellipse", false, "4", ""},
{M_PARTS_TYPE_CUT, 0, "&Cutline", false, "5", ""},
{M_PARTS_TYPE_LEGEND, 0, "Le&gend", false, "6", ""},
endmenu;

/* Partstype */
defmenu(Fontface, "Fontface")
{M_FONT_TIMESROMAN, 0, "Times-R", false, "0", ""},
{M_FONT_TIMESBOLD, 0, "Times-B", false, "1", ""},
{M_FONT_TIMESITALIC, 0, "Times-I", false, "2", ""},
{M_FONT_TIMESBOLDITALIC, 0, "Times-BI", false, "3", ""},
{M_FONT_HELVETICA, 0, "Helv.", false, "4", ""},
{M_FONT_HELVETICABOLD, 0, "Helv.-B", false, "5", ""},
{M_FONT_HELVETICAOBLIQUE, 0, "Helv.-O", false, "6", ""},
{M_FONT_HELVETICABOLDOBLIQUE, 0, "Helv.-BO", false, "7", ""},
{M_FONT_COURIER, 0, "Courier", false, "8", ""},
{M_FONT_COURIERBOLD, 0, "Courier-B", false, "9", ""},
{M_FONT_COURIEROBLIQUE, 0, "Courier-O", false, "10", ""},
{M_FONT_COURIERBOLDOBLIQUE, 0, "Courier-BO", false, "11", ""},
{M_FONT_SYMBOL, 0, "Symbol", false, "12", ""},
endmenu;

/*Jp-fontface*/
defmenu(Jpfontface, "Jpfontface")
{M_FONT_MINCHO, 0, "Mincho", false, "1000", ""},
{M_FONT_GOTHIC, 0, "Gothic", false, "1004", ""},
endmenu;

/* Partsinterpolation */
defmenu(Partsinterpolation, "Partsinterpolation")
{INTER_POLYLINE, 0, "&Polyline", false, "0", ""},
{INTER_CLOSEDPOLYLINE, 0, "&C-poly", false, "1", ""},
{INTER_PSPLINE, 0, "Psp&line", false, "3", ""},
{INTER_CLOSEDPSPLINE, 0, "C-Pspl&ine", false, "4", ""},
endmenu;

/* Label parity */
defmenu(Labelparity, "Labelparity")
{LABEL_PARITY_PLUS, 0, "&Plus", false, "0", ""},
{LABEL_PARITY_MINUS, 0, "&Minus", false, "1", ""},
endmenu;

/* Label crosspoint parity */
defmenu(LabelCPparity, "LabelCPparity")
{LABEL_CPPARITY_ZERO, 0, "&Zero", false, "0", ""},
{LABEL_CPPARITY_MINUS, 0, "&Minus", false, "1", ""},
{LABEL_CPPARITY_PLUS, 0, "&Plus", false, "2", ""},
{LABEL_CPPARITY_NULL, 0, "&Null", false, "3", ""},
endmenu;

/* Label format */
defmenu(Labelformat, "Labelformat")
{LABEL_FORMAT_NULL, 0, "&Null", false, "0", ""},
{LABEL_FORMAT_DECIMAL, 0, "&Decimal", false, "1", ""},
{LABEL_FORMAT_EXP, 0, "&Exp.", false, "2", ""},
endmenu;

/* Label format */
defmenu(Orderlist, "Orderlist")
{ORDERLIST_TOP, 0, "&Top", false, "0", ""},
{ORDERLIST_UP, 0, "&Up", false, "1", ""},
{ORDERLIST_DOWN, 0, "&Down", false, "2", ""},
{ORDERLIST_BOTTOM, 0, "&Bottom", false, "3", ""},
endmenu;

/* paper size */
defmenu(Papersize, "Papersize")
{PAPERSIZE_LETTERP, 0, "LetterP", false, "12240,15840", ""},
{PAPERSIZE_LETTERL, 0, "LetterL", false, "15840,12240", ""},
{PAPERSIZE_A3P, 0, "A3P", false, "16840,23810", ""},
{PAPERSIZE_A3L, 0, "A3L", false, "23810,16840", ""},
{PAPERSIZE_A4P, 0, "A4P", false, "11910,16840", ""},
{PAPERSIZE_A4L, 0, "A4L", false, "16840,11910", ""},
{PAPERSIZE_A5P, 0, "A5P", false, "8422,11910", ""},
{PAPERSIZE_A5L, 0, "A5L", false, "11910,8422", ""},
{PAPERSIZE_B4P, 0, "B4P", false, "14570,20636", ""},
{PAPERSIZE_B4L, 0, "B4L", false, "20636,14570", ""},
{PAPERSIZE_B4P, 0, "B4P", false, "10320,14570", ""},
{PAPERSIZE_B4L, 0, "B4L", false, "14570,10320", ""},
endmenu;

/* memory data scaling */
defmenu(MScaling, "mscaling")
{M_MSCALING_LINEAR, 0, "&Linear", false, "0", ""},
{M_MSCALING_LOG, 0, "L&og", false, "1", ""},
{M_MSCALING_INV, 0, "&Inv", false, "2", ""},
endmenu;

/* memory data scaling */
defmenu(MLinearfit, "linear fit")
{M_LINEARFIT_POLY0, 0, "&0-Poly.", false, "0", ""},
{M_LINEARFIT_POLY1, 0, "&1-Poly.", false, "1", ""},
{M_LINEARFIT_POLY2, 0, "&2-Poly.", false, "2", ""},
{M_LINEARFIT_POLY3, 0, "&3-Poly.", false, "3", ""},
{M_LINEARFIT_POLY4, 0, "&4-Poly.", false, "4", ""},
{M_LINEARFIT_POLY5, 0, "&5-Poly.", false, "5", ""},
{M_LINEARFIT_POLY6, 0, "&6-Poly.", false, "6", ""},
{M_LINEARFIT_POLY7, 0, "&7-Poly.", false, "7", ""},
{M_LINEARFIT_POLY8, 0, "&8-Poly.", false, "8", ""},
{M_LINEARFIT_POLY9, 0, "&9-Poly.", false, "9", ""},
{M_LINEARFIT_POLY10, 0, "10-&Poly.", false, "10", ""},
{M_LINEARFIT_EXP, 0, "&Exp", false, "11", ""},
{M_LINEARFIT_LOG, 0, "&Log", false, "12", ""},
{M_LINEARFIT_POW1, 0, "&Pow1", false, "13", ""},
{M_LINEARFIT_POW2, 0, "P&ow2", false, "14", ""},
endmenu;

#endif











